<?php
/**
* @version $Id: controller.php, v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined( '_JEXEC' ) or die( 'Restricted access' );

// Load the base JController class
jimport( 'joomla.application.component.controller' );

class FullcourtController extends JControllerLegacy {

	public function display($cachable = false, $urlparams = false) {
		$viewname = JFactory::getApplication()->input->get('view', 'leagues');
		$view =  $this->getView(JFactory::getApplication()->input->get('view', 'leagues'), 'html');
		$model =  $this->getModel($viewname);
		$view->setModel($model, true);
		$view->display();
	}

	function saveOrder() {
		$view = JFactory::getApplication()->input->post->get('view', '', 'string' );
		if ($view == 'divisions') {
			$this->saveDivisionOrder();
		}
		else {
			$this->saveLeagueOrder();
		}
	}

	/* ----------- BOX SCORE FUNCTIONS ----------- */
	function editBoxscore() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first box score to be edited; */
		$id = (int)$cids[0];

		/* set the view to the box score edit view; */
		$view =  $this->getView('boxscore', 'html');
		$model =  $this->getModel('boxscore');
		$view->setModel($model, true);

		/* display the edit form for the requested box score; */
		$view->edit($id);
	}

	function saveExitBoxscore() {
		$model =  $this->getModel('boxscore');
		$model->saveLinescore();
		$model->saveBoxscore();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=boxscores', 'Box score details saved...');
	}

	function saveBoxscore() {
		$model =  $this->getModel('boxscore');
		$model->saveLinescore();
		$model->saveBoxscore();
		$id = intval($_POST['gameid']);
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=boxscore&task=editboxscore&cid=' . $id . '&hidemainmenu=1', 'Box score details saved...');
	}

	function cancelBoxscore()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=boxscores', 'Action cancelled...');
	}

	function removeBoxscores() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'No game results were selected for removal' );
		}

		$model =  $this->getModel('boxscores');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=boxscores', 'Game Results have been deleted...' );
	}

	/* ----------- END BOX SCORE FUNCTIONS ----------- */

	/* ----------- LEAGUE FUNCTIONS ----------- */
	function leagueorderUp() {
		$model =  $this->getModel('league');
		$model->orderUp();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'Ordering saved...');
	}

	function leagueorderDown() {
		$model =  $this->getModel('league');
		$model->orderDown();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'Ordering saved...');
	}

	function saveLeagueOrder() {
		$view = JFactory::getApplication()->input->post->get('view', '', 'string' );

		$model =  $this->getModel('leagues');
		$model->saveOrder();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'Ordering saved...');
	}

	function newLeague() {
		$view =  $this->getView('league', 'html');
		$model =  $this->getModel('league');
		$view->setModel($model, true);
		$view->add();
	}

	function editLeague() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first league to be edited; */
		$id = (int)$cids[0];

		/* set the view to the league edit view; */
		$view =  $this->getView('league', 'html');
		$model =  $this->getModel('league');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveLeague() {
		$model =  $this->getModel('league');
		$model->saveLeague();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'League details saved...');
	}

	function removeLeagues() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No leagues were selected for removal' );
		}

		$model =  $this->getModel('leagues');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'League(s) have been deleted...' );
	}

	function removeDivision() {
		$leagueid = JFactory::getApplication()->input->get('league', 0, 'int');
		$cids = JRequest::getVar( 'cid', null, 'default', 'array' );

		if($cids === null) {
			JError::raiseError( 500, 'No divisions were selected for removal' );
		}

		$model =  $this->getModel('leagues');
		$model->deleteDivision($cids, $leagueid);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&task=editleague&cid[]=' . $leagueid . '&hidmainmenu=1', 'Division deleted...');
	}

	function cancelLeague()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues', 'Action cancelled...');
	}

	function leaguePublish() {
		$model =  $this->getModel('leagues');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues');
	}

	function leagueUnpublish() {
		$model =  $this->getModel('leagues');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=leagues');
	}
	/* ----------- END LEAGUE FUNCTIONS ----------- */

	/* ----------- DIVSION FUNCTIONS ----------- */
	function divisionorderUp() {
		$model =  $this->getModel('division');
		$model->orderUp();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Ordering saved...');
	}

	function divisionorderDown() {
		$model =  $this->getModel('division');
		$model->orderDown();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Ordering saved...');
	}

	function saveDivisionOrder() {
		$view = JFactory::getApplication()->input->post->get('view', '', 'string' );

		if ($view == 'divisions') {
			$model =  $this->getModel('divisions');
			$model->saveOrder();
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Ordering saved...');
		}
	}

	function newDivision() {
		$view =  $this->getView('division', 'html');
		$model =  $this->getModel('division');
		$view->setModel($model, true);
		$view->add();
	}

	function editDivision() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first league to be edited; */
		$id = (int)$cids[0];

		/* set the view to the league edit view; */
		$view =  $this->getView('division', 'html');
		$model =  $this->getModel('division');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveDivision() {
		$model =  $this->getModel('division');
		$model->saveDivision();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Division details saved...');
	}

	function removeDivisions() {
		$cids = JRequest::getVar( 'cid', null, 'default', 'array' );

		if($cids === null) {
			JError::raiseError( 500, 'No divisions were selected for removal' );
		}

		$model =  $this->getModel('divisions');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Division(s) have been deleted ...');
	}

	function cancelDivision()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions', 'Action cancelled...');
	}

	function divisionPublish() {
		$model =  $this->getModel('divisions');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions');
	}

	function divisionUnpublish() {
		$model =  $this->getModel('divisions');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=divisions');
	}
	/* ----------- END DIVISION FUNCTIONS ----------- */

	/* ----------- SEASON FUNCTIONS ----------- */
	function newSeason() {
		$view =  $this->getView('season', 'html');
		$model =  $this->getModel('season');
		$view->setModel($model, true);
		$view->add();
	}

	function editSeason()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first league to be edited; */
		$id = (int)$cids[0];

		/* set the view to the league edit view; */
		$view =  $this->getView('season', 'html');
		$model =  $this->getModel('season');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveSeason() {
		$model =  $this->getModel('season');
		$model->saveSeason();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=seasons', 'Season details saved...');
	}

	function removeSeasons() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No seasons were selected for removal' );
		}

		$model =  $this->getModel('seasons');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=seasons', 'Season(s) have been deleted...' );
	}

	function cancelSeason()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=seasons', 'Action cancelled...');
	}

	function seasonPublish() {
		$model =  $this->getModel('seasons');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=seasons');
	}

	function seasonUnpublish() {
		$model =  $this->getModel('seasons');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=seasons');
	}
	/* ----------- END SEASON FUNCTIONS ----------- */

	/* ----------- TEAM FUNCTIONS ----------- */
	function newTeam() {
		$view =  $this->getView('team', 'html');
		$model =  $this->getModel('team');
		$view->setModel($model, true);
		$view->add();
	}

	function editTeam()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first league to be edited; */
		$id = (int)$cids[0];

		/* set the view to the league edit view; */
		$view =  $this->getView('team', 'html');
		$model =  $this->getModel('team');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveTeam() {
		$model =  $this->getModel('team');
		$model->saveTeam();
		$tmpl=JFactory::getApplication()->input->get('tmpl' );
		$return=JFactory::getApplication()->input->get('return' );
		if($tmpl=="component" || $return == -1)
		{
			/* OST Changes to close popup box*/
			JFactory::getApplication()->enqueueMessage('Team details saved...', 'message');
		   	$doc = JFactory::getDocument();
		   	$js = "window.setTimeout(function(){
				window.parent.SqueezeBox.close();	
			},1000);";
       //window.parent.location.href = '".JRoute::_('index.php?option=' . JFactory::getApplication()->input->get('option') . '&task=newschedule',FALSE)."';
           		$doc->addScriptDeclaration($js); 
		}
		else
		{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=teams', 'Team details saved...');
		}
	}
	
	function saveTeam2new() {
		$model =  $this->getModel('team');
		$model->saveTeam();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=team&task=editteam&cid=0', 'Team details saved...');
	}

	function removeTeams() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No teams were selected for removal' );
		}

		$model =  $this->getModel('teams');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=teams', 'Team(s) have been deleted...' );
	}

	function cancelTeam()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=teams', 'Action cancelled...');
	}

	function teamPublish() {
		$model =  $this->getModel('teams');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=teams');
	}

	function teamUnpublish() {
		$model =  $this->getModel('teams');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=teams');
	}
	/* ----------- END TEAM FUNCTIONS ----------- */

	/* ----------- SCHEDULE FUNCTIONS ----------- */
	function newSchedule() {
		$view =  $this->getView('schedule', 'html');
		$model =  $this->getModel('schedule');
		$view->setModel($model, true);
		$view->add();
	}

	function editSchedule()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first league to be edited; */
		$id = (int)$cids[0];

		/* set the view to the league edit view; */
		$view =  $this->getView('schedule', 'html');
		$model =  $this->getModel('schedule');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveSchedule() {
		$model =  $this->getModel('schedule');
		// OST Changes 
		$save = $model->saveSchedule();
		
		if(!$save){
			JError::raiseWarning( 100, 'Schedule details not saved ... Please fill all required fields' );
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules');
		} else {
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules', 'Schedule details saved...');
		}
		
	}
	
	function saveSchedule2new() {
		$model =  $this->getModel('schedule');
		// OST Changes 
		$save = $model->saveSchedule();
		
		if(!$save){
			JError::raiseWarning( 100, 'Schedule details not saved ... Please fill all required fields' );
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedule&task=editschedule&cid=0');
		} else {
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedule&task=editschedule&cid=0', 'Schedule details saved...');
		}
		
	}

	function removeSchedules() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No schedules were selected for removal' );
		}

		$model =  $this->getModel('schedules');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules', 'Schedule(s) have been deleted...' );
	}

	function cancelSchedule()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules', 'Action cancelled...');
	}

	function schedulePublish() {
		$model =  $this->getModel('schedules');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules');
	}

	function scheduleUnpublish() {
		$model =  $this->getModel('schedules');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedules');
	}
	/* ----------- END SCHEDULE FUNCTIONS ----------- */

	/* ----------- PLAYER FUNCTIONS ----------- */
	function newPlayer() {
		$view =  $this->getView('player', 'html');
		$model =  $this->getModel('player');
		$view->setModel($model, true);
		$view->add();
	}

	function editPlayer()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first record to be edited; */
		$id = (int)$cids[0];

		/* set the view to the player edit view; */
		$view =  $this->getView('player', 'html');
		$model =  $this->getModel('player');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function clonePlayer() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first record to be edited; */
		$id = (int)$cids[0];

		/* set the view to the player edit view; */
		$view =  $this->getView('player', 'html');
		$model =  $this->getModel('player');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->cloneplayer($id);
	}

	function savePlayer() {
		$model =  $this->getModel('player');
		$model->savePlayer();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=players', 'Player details saved...');
	}
	
	function savePlayer2new() {
		$model =  $this->getModel('player');
		$model->savePlayer();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=player&task=editplayer&cid=0', 'Player details saved...');
	}

	function removePlayers() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');
		if($cids === null) {
			JError::raiseError( 500, 'No players were selected for removal' );
		}

		$model =  $this->getModel('players');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=players', 'Player(s) have been deleted...' );
	}

	function cancelPlayer()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=players', 'Action cancelled...');
	}

	function playerPublish() {
		$model =  $this->getModel('players');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=players');
	}

	function playerUnpublish() {
		$model =  $this->getModel('players');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=players');
	}
	/* ----------- END PLAYER FUNCTIONS ----------- */

	/* ----------- LOCATION/FIELD FUNCTIONS ----------- */
	function newLocation() {
		$view =  $this->getView('location', 'html');
		$model =  $this->getModel('location');
		$view->setModel($model, true);
		$view->add();
	}

	function editLocation()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first record to be edited; */
		$id = (int)$cids[0];

		/* set the view to the location edit view; */
		$view =  $this->getView('location', 'html');
		$model =  $this->getModel('location');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveLocation() {
		$model =  $this->getModel('location');
		$model->saveLocation();
		$tmpl=JFactory::getApplication()->input->get('tmpl' );
		$return=JFactory::getApplication()->input->get('return' );
		if($tmpl=="component" || $return == -1)
		{
			/* OST Changes to close popup box*/
			JFactory::getApplication()->enqueueMessage('Location details saved...', 'message');
		   	$doc = JFactory::getDocument();
		   	$js = "window.setTimeout(function(){
			window.parent.SqueezeBox.close();	
			},1000);";
       //window.parent.location.href = '".JRoute::_('index.php?option=' . JFactory::getApplication()->input->get('option') . '&task=newschedule',FALSE)."';
           		$doc->addScriptDeclaration($js); 
		
		} else if($return = 45){
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=schedule&cid=0&hidemainmenu=1&task=editschedule', 'Location details saved...');
		} else {
			$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=locations', 'Location details saved...');
		}
	}

	function removeLocations() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No locations were selected for removal' );
		}

		$model =  $this->getModel('locations');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=locations', 'Location(s) have been deleted...' );
	}

	function cancelLocation()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=locations', 'Action cancelled...');
	}

	function locationPublish() {
		$model =  $this->getModel('locations');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=locations');
	}

	function locationUnpublish() {
		$model =  $this->getModel('locations');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=locations');
	}
	/* ----------- END LOCATION/FIELD FUNCTIONS ----------- */

	/* ----------- GAME TYPE FUNCTIONS ----------- */
	function newGametype() {
		$view =  $this->getView('gametype', 'html');
		$model =  $this->getModel('gametype');
		$view->setModel($model, true);
		$view->add();
	}

	function editGametype()	{
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if ($cids === null) {
			JError::raiseError( 500, 'cid parameter missing from the request' );
		}

		/* get the first record to be edited; */
		$id = (int)$cids[0];

		/* set the view to the gametype edit view; */
		$view =  $this->getView('gametype', 'html');
		$model =  $this->getModel('gametype');
		$view->setModel($model, true);

		/* display the edit form for the requested league; */
		$view->edit($id);
	}

	function saveGametype() {
		$model =  $this->getModel('gametype');
		$model->saveGametype();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=gametypes', 'Game type details saved...');
	}

	function removeGametypes() {
		$cids = JRequest::getVar('cid', null, 'default', 'array');

		if($cids === null) {
			JError::raiseError( 500, 'No game types were selected for removal' );
		}

		$model =  $this->getModel('gametypes');
		$model->delete($cids);

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=gametypes', 'Game type(s) have been deleted...' );
	}

	function cancelGametype()	{
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=gametypes', 'Action cancelled...');
	}

	function gametypePublish() {
		$model =  $this->getModel('gametypes');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=gametypes');
	}

	function gametypeUnpublish() {
		$model =  $this->getModel('gametypes');
		$model->publish();
		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=gametypes');
	}
	/* ----------- END GAME TYPE FUNCTIONS ----------- */

	/* ----------- PLAYER IMPORT/EXPORT FUNCTIONS ----------- */
	function exportCsv() {
		$model =  $this->getModel('export');
		$model->exportCsv();
		exit;
	}

	function importCsv() {
		$model =  $this->getModel('import');
		$model->importCsv();

		$this->setRedirect('index.php?option=' . JFactory::getApplication()->input->get('option') . '&view=import');
	}
	/* ----------- END PLAYER IMPORT/EXPORT FUNCTIONS ----------- */

	/* ------------- START AJAX CALLS ------------- */
	function leagueDivisions() {
		$leagueid = JFactory::getApplication()->input->get('lid', 1);
		echo getDivisionsAsSelectList($leagueid, 'divisionid', 0);
	}

	function leagueDivisionTeams() {
		$leagueid = JFactory::getApplication()->input->get('lid', 0);
		$divisionid = JFactory::getApplication()->input->get('did', 0);
		echo getTeamsAsSelectListAjax('teamid', '', $leagueid, $divisionid );
	}

	function parkFields() {
		$location = JFactory::getApplication()->input->get( 'location', '' );
		$fieldid=JFactory::getApplication()->input->get( 'fieldid', '' );
		echo getParkFieldListAjax($location, 'field_'.$fieldid);
	}
	/* ------------- END AJAX CALLS ------------- */

}

?>