<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

function getTMZ($offset) {
	$arr = array();
	$arr[-11] = "Pacific/Apia";
	$arr["-10"] = "Pacific/Honolulu";
	$arr["-9"] = "America/Anchorage";
	$arr["-8"] = "America/Los_Angeles";
	$arr["-7"] = "America/Phoenix";
	$arr["-6"] = "America/Chicago";
	$arr[-5] = "America/New_York";
	$arr["-4.5"] = "America/Caracas";
	$arr["-4"] = "America/Halifax";
	$arr["-3"] = "America/Sao_Paulo";
	$arr["-2"] = "Atlantic/South_Georgia";
	$arr["-1"] = "Atlantic/Cape_Verde";
	$arr["0"] = "Europe/London";
	$arr["1"] = "Europe/Berlin";
	$arr["2"] = "Africa/Johannesburg";
	$arr["3"] = "Asia/Baghdad";
	$arr["3.5"] = "Asia/Tehran";
	$arr["4"] = "Asia/Muscat";
	$arr["4.5"] = "Asia/Kabul";
	$arr["5"] = "Asia/Karachi";
	$arr["5.5"] = "Asia/Kolkata";
	$arr["6"] = "Asia/Dhaka";
	$arr["6.5"] = "Asia/Rangoon";
	$arr["7"] = "Asia/Bangkok";
	$arr["8"] = "Asia/Hong_Kong";
	$arr["9"] = "Asia/Tokyo";
	$arr["9.5"] = "Australia/Adelaide";
	$arr["10"] = "Australia/Sydney";
	$arr["11"] = "Pacific/Noumea";
	$arr["12"] = "Pacific/Auckland";

	if (array_key_exists($offset, $arr)) {
		return $arr[$offset];
	}
	return $arr[$offset];
}

function getSeasonStats($stat = null, $playerid = null, $teamid = null, $seasonid = null) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT SUM(p.{$stat}) AS forseason FROM #__fullcourt_playerstat AS p LEFT JOIN #__fullcourt_schedule AS s ON s.id = p.gameid  WHERE (s.season = {$seasonid} AND p.playerid = {$playerid} AND p.{$stat} > 0)");
	$total = $db->loadObject();
	if ($total) {
		return $total->forseason;
	}
	else {
		return 0;
	}
}

function isFrontendAdmin($teamid) {
	$db =  JFactory::getDBO();
	$user = JFactory::getUser();
	
	
	if ($user->id) {
	
	/* OST Changes */
		if($teamid == NULL || $teamid == '0'){
		$where = " (FIND_IN_SET('{$user->id}', adminids))";
		} else {
		$where = " (id = {$teamid} AND FIND_IN_SET('{$user->id}', adminids))";
		}
		
		$db->setQuery("SELECT id FROM #__fullcourt_team WHERE $where ");
		/* OST Changes */
		//$db->setQuery("SELECT id FROM #__fullcourt_team WHERE (id = {$teamid} AND FIND_IN_SET('{$user->id}', adminids))");
		$rows = $db->loadObjectList();
		if (sizeof($rows) > 0) {
			return true;
		}
	}
	return false;
}

function checkDefaults() {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT id FROM #__fullcourt_season WHERE isdefault = 1");
	$season = $db->loadObject();
	if ($season) {
		return true;
	}
	else {
		return false;
	}
}

function getDefaultLeagueId() {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT id FROM #__fullcourt_league WHERE isdefault = 1");
	$league = $db->loadObject();
	if ($league) {
		return $league->id;
	}
	else {
		return 0;
	}
}

function getDefaultSeasonId() {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT id FROM #__fullcourt_season WHERE isdefault = 1");
	$season = $db->loadObject();
	if ($season) {
		return $season->id;
	}
	else {
		return 0;
	}
}

function getLeagueName($id) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT name FROM #__fullcourt_league WHERE (id = {$id})");
	return stripslashes($db->loadResult());
}

function getDivisionName($id) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT division FROM #__fullcourt_division WHERE (id = {$id})");
	return stripslashes($db->loadResult());
}

function getTeamName($id) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT name FROM #__fullcourt_team WHERE (id = {$id})");
	return stripslashes($db->loadResult());
}

function getTeamLogo($id) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT logo FROM #__fullcourt_team WHERE (id = {$id})");
	return stripslashes($db->loadResult());
}

function getLeaguesAsSelectListAjax($name, $default) {
	$db =  JFactory::getDBO();
	$list = array();
	// if no default team was passed in, get the default team from the teams database table;
	if (!$default) {
		//$db->setQuery("SELECT id AS defaultleague FROM #__fullcourt_league WHERE (isdefault = 1)");
		//$default = $db->loadResult();
	}
	$db->setQuery("SELECT a.id AS value, a.name AS text FROM #__fullcourt_league AS a");
	$leagues = $db->loadObjectList();
	if (sizeof($leagues) == 0) {
		$list[]	= JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_NO_LEAGUES' ), 'value', 'text' );
	}
	else {
		$list[]	= JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_LEAGUE' ), 'value', 'text' );
	}
	$list	= array_merge( $list, $leagues );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getDivisionsAsSelectList($leagueid, $name, $default) {
	$app = JFactory::getApplication();
	/*OST Changes to avoid error if leagueid is not passed */
	if($leagueid == NULL){
		$where = 1;
	} else {
		$where = " (leagueid = {$leagueid})";
	}
	$db =  JFactory::getDBO();
	$list = array();
	$db->setQuery("SELECT a.id AS value, a.division AS text FROM #__fullcourt_division AS a WHERE ".$where."");
	$divisions = $db->loadObjectList();
	if (sizeof($divisions) == 0) {
		$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_NO_DIVISIONS' ), 'value', 'text' );
		$divisions = array();
	}
	else {
		$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_DIVISION' ), 'value', 'text' );
	}

	$list	= array_merge( $list, $divisions );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getSeasonsAsSelectList($name, $default = 0) {
	$db =  JFactory::getDBO();
	if (!$default) {
		$default = getDefaultSeasonId();
	}
	$db->setQuery("SELECT a.id AS value, a.name AS text FROM #__fullcourt_season AS a");
	$leagues = $db->loadObjectList();
	$list[]	= JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_SEASON' ), 'value', 'text' );
	$list = array_merge( $list, $db->loadObjectList() );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getGameTypesAsSelectList($name, $default) {
	$db =  JFactory::getDBO();
	$list = array();
	$db->setQuery("SELECT a.id AS value, a.description AS text FROM #__fullcourt_gametype AS a");
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_GAME_TYPE' ), 'value', 'text' );
	$list	= array_merge( $list, $db->loadObjectList() );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getLocationsAsSelectListAjax($name, $default) {
	$db =  JFactory::getDBO();
	$list = array();
	$db->setQuery("SELECT a.id AS value, CONCAT(a.name, ', ', a.city, ' ', a.state) AS text FROM #__fullcourt_location AS a ORDER BY a.name");
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_LOCATION' ), 'value', 'text' );
	$list	= array_merge( $list, $db->loadObjectList() );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getParkFieldsSelectList($location, $name, $default) {
	$db =  JFactory::getDBO();
	$list = array();
	/*OST Changes to avoid error if location is not passed */
	if($location == NULL){
		$where = 1;
	} else {
		$where = " (id = {$location})";
	}
	$db->setQuery("SELECT fieldnames FROM #__fullcourt_location WHERE " . $where . "");
	$fields = $db->loadResult();
	if ($fields) {
		$list = array();
		$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_FIELD' ), 'value', 'text' );
		$fields = unserialize($fields);
		foreach ($fields as $field) {
			$list[] = JHTML::_('select.option',  $field, JText::_( $field ), 'value', 'text' );
		}
		return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', $default );
	}
	else {
		return;
	}
}

function getParkFieldListAjax($location, $name) {
	$db =  JFactory::getDBO();
	$list = array();
	/*OST Changes to avoid error if location is not passed */
	if($location == NULL){
		$where = 1;
	} else {
		$where = " (id = {$location})";
	}
	$db->setQuery("SELECT fieldnames FROM #__fullcourt_location WHERE " . $where . "");
	$fields = $db->loadResult();
	if ($fields) {
		$list = array();
		$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_FIELD' ), 'value', 'text' );
		$fields = unserialize($fields);
		foreach ($fields as $field) {
			$list[] = JHTML::_('select.option',  $field, JText::_( $field ), 'value', 'text' );
		}
		echo JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', '' );
	}
	else {
		echo '';
	}
}

function getGameStatusAsSelectList($name, $default) {
	$db =  JFactory::getDBO();
	$list = array();
	$db->setQuery("SELECT a.id AS value, a.description AS text FROM #__fullcourt_gamestatus AS a ORDER BY a.id");
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_GAME_STATUS' ), 'value', 'text' );
	$list	= array_merge( $list, $db->loadObjectList() );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getTeamsAsSelectListLong($name, $default) {
	$db =  JFactory::getDBO();
	// if no default team was passed in, get the default team from the teams database table;
	if (!$default) {
		$db->setQuery("SELECT id AS defaultteam FROM #__fullcourt_team WHERE (defaultteam = 1)");
		//$default = $db->loadResult();
	}
	$list = array();
	$list[] = JHTML::_('select.option',  '0', JText::_( 'COM_FULLCOURT_SELECT_TBD' ), 'value', 'text' );
	$db->setQuery("SELECT a.id AS value, a.name AS text, l.name AS league, d.division AS division FROM #__fullcourt_team AS a LEFT JOIN #__fullcourt_league AS l ON a.leagueid = l.id LEFT JOIN #__fullcourt_division AS d ON a.divisionid = d.id ORDER BY a.name");
	$teams = $db->loadObjectList();
	$arr = array();
	foreach ($teams as $team) {
		$teamObj = new stdClass();
		$teamObj->value = $team->value;
		$teamObj->text = $team->text;
		if ($team->league) {
			$teamObj->text .= ' (' . $team->league;
			if ($team->division) {
				$teamObj->text .= ' - ' . $team->division;
			}
			$teamObj->text .= ')';
		}
		$arr[] = $teamObj;
	}
	$list = array_merge( $list, $arr );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getGameInformation($gameid) {
	$db =  JFactory::getDBO();
	$sql = "SELECT a.*,
		a.hometeam AS hometeamid,
		a.visitingteam AS visitingteamid,
		DATE_FORMAT(gamedatetime, '%W %M %D, %Y @ %l:%i %p') AS gamedatetime,
		DATE_FORMAT(gamedatetime, '%Y') AS season,
		h.name AS hometeam,
		v.name AS visitingteam,
		t.description AS gametype,
		l.name AS fieldname,
		l.city AS city,
		l.state AS state
		FROM #__fullcourt_schedule AS a
		LEFT JOIN #__fullcourt_team AS h ON a.hometeam = h.id
		LEFT JOIN #__fullcourt_team AS v ON a.visitingteam = v.id
		LEFT JOIN #__fullcourt_gametype AS t ON a.gametype = t.id
		LEFT JOIN #__fullcourt_location AS l ON a.location = l.id
		WHERE (a.id = {$gameid})
		GROUP BY a.id
		ORDER BY a.id";
	$db->setQuery($sql);
	$game = $db->loadObject();
	return $game;
}

function getGameLinescore($gameid) {
	$db =  JFactory::getDBO();
	$sql = "SELECT a.* FROM #__fullcourt_linescore AS a WHERE (a.gameid = {$gameid}) ORDER BY a.gameid";
	$db->setQuery($sql);
	return $db->loadObjectList();
}

function getTeamRosterEntered($teamid, $gameid) {
	$db =  JFactory::getDBO();
	$db->setQuery("SELECT a.*, s.entered, s.battingorder FROM #__fullcourt_player AS a LEFT JOIN #__fullcourt_playerstat AS s ON a.id = s.playerid AND (s.gameid = {$gameid} OR s.gameid IS NULL) WHERE (a.active = 1 AND a.teamid = {$teamid} AND (s.gameid = {$gameid} OR s.gameid IS NULL)) ORDER BY s.battingorder ASC, a.lname ASC, a.fname ASC");
	return $db->loadObjectList();
}

function getPlayerCloneTeams($name, $default, $playerid) {
	$db =  JFactory::getDBO();

	/* get all teams where this player is on their roster, they cannot be assigned to the same team; */
	$db->setQuery("SELECT teamid FROM #__fullcourt_player WHERE (playerid = {$playerid})");
	$teamids = $db->loadColumn();
	if($teamids){
		if(is_array($teamids)){
				$teamids = implode(',', $teamids);
		}
	}
	

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_TEAM' ), 'value', 'text' );
	$db->setQuery("SELECT a.id AS value, a.name AS text, l.name AS league, d.division AS division FROM #__fullcourt_team AS a LEFT JOIN #__fullcourt_league AS l ON a.leagueid = l.id LEFT JOIN #__fullcourt_division AS d ON a.divisionid = d.id WHERE (NOT FIND_IN_SET(a.id, '{$teamids}')) ORDER BY a.name");
	$teams = $db->loadObjectList();
	$arr = array();
	if ($teams) {
		foreach ($teams as $team) {
			$teamObj = new stdClass();
			$teamObj->value = $team->value;
			$teamObj->text = $team->text;
			if ($team->league) {
				$teamObj->text .= ' (' . $team->league;
				if ($team->division) {
					$teamObj->text .= ' - ' . $team->division;
				}
				$teamObj->text .= ')';
			}
			$arr[] = $teamObj;
		}
	}
	else {
		$list = array();
		$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_NO_CLONE' ), 'value', 'text' );
	}
	$list = array_merge( $list, $arr );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1"', 'value', 'text', intval($default) );
}

function getTeamFilterList($name, $default) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_TEAMS' ), 'value', 'text' );

	$db->setQuery("SELECT a.id AS value, a.name AS text, l.name AS league, d.division AS division FROM #__fullcourt_team AS a LEFT JOIN #__fullcourt_league AS l ON a.leagueid = l.id LEFT JOIN #__fullcourt_division AS d ON a.divisionid = d.id ORDER BY a.name");
	$teams = $db->loadObjectList();

	$arr = array();
	foreach ($teams as $team) {
		$teamObj = new stdClass();
		$teamObj->value = $team->value;
		$teamObj->text = $team->text;
		if ($team->league) {
			$teamObj->text .= ' (' . $team->league;
			if ($team->division) {
				$teamObj->text .= ' / ' . $team->division;
			}
			$teamObj->text .= ')';
		}
		$arr[] = $teamObj;
	}
	$list = array_merge($list, $arr);
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', intval($default) );
}

function getLeagues($name, $default) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_('COM_FULLCOURT_SELECT_ALL_LEAGUES'), 'value', 'text' );

	$db->setQuery("SELECT l.id AS value, l.name AS text FROM #__fullcourt_league AS l ORDER BY l.name");
	$leagues = $db->loadObjectList();
	$list = array_merge($list, $leagues);

	return JHTML::_('select.genericlist', $list, $name, 'class="required" size="1"', 'value', 'text', intval($default));
}

function getLeagueFilterList($name, $default) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_LEAGUES' ), 'value', 'text' );

	$db->setQuery("SELECT l.id AS value, l.name AS text FROM #__fullcourt_league AS l ORDER BY l.name");
	$leagues = $db->loadObjectList();
	$list = array_merge($list, $leagues);

	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', intval($default));
}

function getLeagueDivisionFilterList($name, $default) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_LEAGUES_DIVISIONS' ), 'value', 'text' );

	$db->setQuery("SELECT l.id AS lid, l.name, d.id AS did, d.division FROM #__fullcourt_league AS l LEFT JOIN #__fullcourt_division AS d ON l.id = d.leagueid ORDER BY l.name ASC");
	$leagues = $db->loadObjectList();

	foreach ($leagues as $league) {
		if ($league->division) {
			$list[] = JHTML::_('select.option',  $league->lid . ':' . $league->did, JText::_( $league->name . ' / ' . $league->division ), 'value', 'text' );
		}
		else {
			$list[] = JHTML::_('select.option',  $league->lid . ':' . $league->did, JText::_( $league->name ), 'value', 'text' );
		}
	}

	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $default);
}

function getManagedUnmanagedFilterList($name, $default) {
	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_GENERIC' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '1', JText::_( 'COM_FULLCOURT_SELECT_MANAGED' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '0', JText::_( 'COM_FULLCOURT_SELECT_UNMANAGED' ), 'value', 'text' );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $default );
}

function getPlayerStatusFilterList($name, $default) {
	$list = array();

	$list[] = JHTML::_('select.option', '', JText::_( 'COM_FULLCOURT_SELECT_ALL_PLAYERS' ), 'value', 'text' );
	$list[] = JHTML::_('select.option', '1', JText::_( 'COM_FULLCOURT_SELECT_ACTIVE_PLAYERS' ), 'value', 'text' );
	$list[] = JHTML::_('select.option', '0', JText::_( 'COM_FULLCOURT_SELECT_INACTIVE_PLAYERS' ), 'value', 'text' );
	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $default );
}

function getSeasonsAsFiilterList($name, $default = 0) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_SEASONS' ), 'value', 'text' );

	$db->setQuery("SELECT a.id AS value, a.name AS text FROM #__fullcourt_season AS a");
	$seasons = $db->loadObjectList();
	$list = array_merge( $list, $seasons );

	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', intval($default) );
}

function getGameTypesAsFiilterList($name, $default = 0) {
	$db =  JFactory::getDBO();

	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_ALL_GAME_TYPES' ), 'value', 'text' );

	$db->setQuery("SELECT a.id AS value, a.description AS text FROM #__fullcourt_gametype AS a");
	$gametypes = $db->loadObjectList();
	$list = array_merge( $list, $gametypes );

	return JHTML::_('select.genericlist', $list, $name, 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', intval($default) );
}

function getPositionsAsSelectList($name, $default) {
	$default = explode(', ', $default);
	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_POSITION' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'PG', JText::_( 'Point Guard' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'SG', JText::_( 'Shooting Guard' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'SF', JText::_( 'Small Forward' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'PF', JText::_( 'Power Forward' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'C', JText::_( 'Center' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'F', JText::_( 'Forward' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  'G', JText::_( 'Guard' ), 'value', 'text' );
	return JHTML::_('select.genericlist', $list, $name . '[]', 'class="inputbox" size="10" multiple', 'value', 'text', $default );
}

function getDateAsSelectList($mname, $dname, $yname, $default) {
	if ($default && $default != '0000-00-00') {
		$mvalue = date('m', strtotime($default));
		$dvalue = date('d', strtotime($default));
		$yvalue = date('Y', strtotime($default));
	}
	else {
		$mvalue = '';
		$dvalue = '';
		$yvalue = '';
	}

	/* construct the month values; */
	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_MONTH' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '1', JText::_( 'COM_FULLCOURT_SELECT_JAN' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '2', JText::_( 'COM_FULLCOURT_SELECT_FEB' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '3', JText::_( 'COM_FULLCOURT_SELECT_MAR' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '4', JText::_( 'COM_FULLCOURT_SELECT_APR' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '5', JText::_( 'COM_FULLCOURT_SELECT_MAY' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '6', JText::_( 'COM_FULLCOURT_SELECT_JUN' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '7', JText::_( 'COM_FULLCOURT_SELECT_JUL' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '8', JText::_( 'COM_FULLCOURT_SELECT_AUG' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '9', JText::_( 'COM_FULLCOURT_SELECT_SEP' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '10', JText::_( 'COM_FULLCOURT_SELECT_OCT' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '11', JText::_( 'COM_FULLCOURT_SELECT_NOV' ), 'value', 'text' );
	$list[] = JHTML::_('select.option',  '12', JText::_( 'COM_FULLCOURT_SELECT_DEC' ), 'value', 'text' );
	$fulldate = JHTML::_('select.genericlist', $list, $mname, 'class="inputbox" size="1"', 'value', 'text', $mvalue );

	/* construct the day values; */
	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_DAY' ), 'value', 'text' );
	for ($i = 1; $i < 32; $i++) {
		$list[] = JHTML::_('select.option',  str_pad($i, 2, '0', STR_PAD_LEFT), JText::_( str_pad($i, 2, '0', STR_PAD_LEFT) ), 'value', 'text' );
	}
	$fulldate .= ' / ' . JHTML::_('select.genericlist', $list, $dname, 'class="inputbox" size="1"', 'value', 'text', $dvalue );

	/* construct the year values; */
	$list = array();
	$list[] = JHTML::_('select.option',  '', JText::_( 'COM_FULLCOURT_SELECT_YEAR' ), 'value', 'text' );
	for ($i = date('Y')-3; $i > date('Y')-75; $i--) {
		$list[] = JHTML::_('select.option',  str_pad($i, 2, '0', STR_PAD_LEFT), JText::_( str_pad($i, 2, '0', STR_PAD_LEFT) ), 'value', 'text' );
	}
	$fulldate .= ' / ' . JHTML::_('select.genericlist', $list, $yname, 'class="inputbox" size="1"', 'value', 'text', $yvalue );
	return $fulldate;
}

function getStandingsTeams($divisionid, $leagueid, $seasonid) {
	$db =  JFactory::getDBO();

	$seasonid = intval($seasonid);
	$divisionid = intval($divisionid);

	if ($divisionid) {
		$db->setQuery("SELECT a.id AS value, a.name AS text FROM #__fullcourt_team AS a WHERE (a.published = 1 AND a.defaultteam = 1 AND a.divisionid = {$divisionid}) ORDER BY a.name");
	}
	else if ($leagueid) {
		/* if there are no divisions configured just get all the teams; */
		$db->setQuery("SELECT a.id AS value, a.name AS text FROM #__fullcourt_team AS a WHERE (a.published = 1 AND a.defaultteam = 1 AND a.leagueid = {$leagueid}) ORDER BY a.name");
	}

	$teamlist = $db->loadObjectList();

	/* array to store the wins, losses, ties, and teamid; */
	$gamedata = array();
	/* go through each teams schedule and get their wins, losses, and ties so that we know how to order the league standings; */
	foreach ($teamlist as $team) {
		$wins = $losses = $ties = $gamesplayed =$pointsfor=$pointsagainst=$total_points= 0;
		/* now get the total points for each team and each game; */
		/* OST Changes Added s.status = 3 AND to get only completed game */
		$db->setQuery("SELECT s.hometeam, s.visitingteam, b.finalv, b.finalh FROM #__fullcourt_schedule AS s LEFT JOIN #__fullcourt_linescore AS b ON b.gameid = s.id WHERE (s.status = 3 AND s.scored = 1 AND s.season = {$seasonid} AND (s.visitingteam = {$team->value} OR s.hometeam = {$team->value}))");
		$games = $db->loadObjectList();

		/* go through each game and count the wins/losses/ties for the team then dump the results into an array for sorting; */
		foreach ($games as $game) {
		$gamesplayed++;
			if ($game->hometeam == $team->value) {
				$pointsfor = $pointsfor + $game->finalh;
				$pointsagainst = $pointsagainst + $game->finalv;
				$minus_points_against=$pointsfor-$pointsagainst;
				if ($game->finalh > $game->finalv) {
					$wins++;
				}
				else if ($game->finalh < $game->finalv) {
					$losses++;
				}
				else {
					$ties++;
				}
			}
			else {
			$pointsfor = $pointsfor + $game->finalh;
			$pointsagainst = $pointsagainst + $game->finalv;
			$minus_points_against=$pointsfor-$pointsagainst;	
				if ($game->finalv > $game->finalh) {
					$wins++;
				}
				else if ($game->finalv < $game->finalh) {
					$losses++;
				}
				else {
					$ties++;
				}
			}
		}
		
		$app = JFactory::getApplication();
		$params = JComponentHelper::getParams('com_fullcourt');
			
		$winpoints=$params->get( 'win_points' , '0' );
		$losspoints=$params->get( 'loss_points' , '0' );
		$tiepoints=$params->get( 'tie_points' , '0' );
		$display_points_column=$params->get('display_points_column_standings');
					
		$winpct = $wins + ($ties*.5);
		if ($gamesplayed > 0) {
		//echo "<br>aa-->";
			$winpct = $winpct/$gamesplayed;
		}
		else {
		//echo "<br>bb-->";
			$winpct = 0;
		}
		$winpct = number_format($winpct, 3);
		
		if($display_points_column==1)
		{
		$total_points=($wins*$winpoints)+($losses*$losspoints)+($ties*$tiepoints);	
		$gamedata[] = array('winpct' => $winpct, 'total_points'=>$total_points, 'wins' => $wins,  'losses' => $losses, 'ties' => $ties,'minus_points_against'=>$minus_points_against ,'teamid' => $team->value);
		}
		else
		{
		$gamedata[] = array('winpct' => $winpct, 'wins' => $wins, 'losses' => $losses, 'ties' => $ties,'minus_points_against'=>$minus_points_against ,'teamid' => $team->value);
		}
	}

	/* sort the gamedata array by winpct, wins, losses, ties; */
	$winpct = $wins = $losses = $ties =$gamesplayed= $minus_points_against=$total_points=array();
	
	/*echo "<pre>";
	print_r($gamedata);*/
	foreach ($gamedata as $key => $value) {
	$gamesplayed++;
		$winpct[$key] = $value['winpct'];
		if(isset($value['total_points'])){
			$total_points[$key]=$value['total_points'];
		}
		
	    $wins[$key] = $value['wins'];
		$losses[$key] = $value['losses'];
	    $ties[$key] = $value['ties'];
		$minus_points_against[$key] = $value['minus_points_against'];
	}
	if($display_points_column==1)
	{
	array_multisort($winpct, SORT_DESC,$total_points,SORT_DESC, $wins, SORT_DESC, $losses, SORT_ASC, $ties, SORT_ASC,$minus_points_against, SORT_DESC, $gamedata);
	}
	else
	{
	array_multisort($winpct, SORT_DESC, $wins, SORT_DESC, $losses, SORT_ASC, $ties, SORT_ASC,$minus_points_against, SORT_DESC, $gamedata);
	}
	
		//echo "<pre>";
	//print_r($gamedata);

	$teamsort = array();
	foreach ($gamedata as $game) {
		$teamsort[] = $game['teamid'];
	}
	/* teamsort will be used to order the database results so that the team with the best record is on top; */
	if(is_array($teamsort)){
				$teamsort = implode(',', $teamsort);
	}
	

	if ($divisionid) {
		$db->setQuery("SELECT t.id, t.leagueid, t.name, t.divisionid FROM #__fullcourt_team AS t WHERE (t.published = 1 AND t.defaultteam = 1 AND t.divisionid = {$divisionid}) ORDER BY FIND_IN_SET(id, '$teamsort')");
	}
	else if ($leagueid) {
		$db->setQuery("SELECT t.id, t.leagueid, t.name, t.divisionid FROM #__fullcourt_team AS t WHERE (t.published = 1 AND t.defaultteam = 1 AND t.leagueid = {$leagueid}) ORDER BY FIND_IN_SET(id, '$teamsort')");
	}

	$teams = $db->loadObjectList();

	return $teams;
}

function getStandingsStats($teams, $seasonid) {
	$db =  JFactory::getDBO();

	$i = 0;
	$standings = array();
	/* go through each team and get their wins, losses, and ties; */
	foreach ($teams as $team) {
		$wins = $losses = $ties = $gamesplayed = $pointsfor = $pointsagainst = 0;
		/* now get the total points for each team and each game; */
		/* OST Changes Added s.status = 3 AND to get only completed game */
		//echo "<br>bb-->"."SELECT s.hometeam, s.visitingteam, b.finalv, b.finalh FROM #__fullcourt_schedule AS s LEFT JOIN #__fullcourt_linescore AS b ON b.gameid = s.id WHERE (s.scored = 1 AND s.season = {$seasonid} AND (s.visitingteam = {$team->id} OR s.hometeam = {$team->id}))";
		
		$db->setQuery("SELECT s.hometeam, s.visitingteam, b.finalv, b.finalh FROM #__fullcourt_schedule AS s LEFT JOIN #__fullcourt_linescore AS b ON b.gameid = s.id WHERE (s.status = 3 AND s.scored = 1 AND s.season = {$seasonid} AND (s.visitingteam = {$team->id} OR s.hometeam = {$team->id}))");
		$games = $db->loadObjectList();
		/* go through each game and count the wins/losses/ties for the team then dump the results into an array for sorting; */
		foreach ($games as $game) {
			$gamesplayed++;
			if ($game->hometeam == $team->id) {
				$pointsfor = $pointsfor + $game->finalh;
				$pointsagainst = $pointsagainst + $game->finalv;
				if ($game->finalh > $game->finalv) {
					$wins++;
				}
				else if ($game->finalh < $game->finalv) {
					$losses++;
				}
				else {
					$ties++;
				}
			}
			else {
				$pointsfor = $pointsfor + $game->finalv;
				$pointsagainst = $pointsagainst + $game->finalh;
				if ($game->finalv > $game->finalh) {
					$wins++;
				}
				else if ($game->finalv < $game->finalh) {
					$losses++;
				}
				else {
					$ties++;
				}
			}
		}
		//echo "<br>pointsfor 1-->".$pointsfor;
		//echo "<br>pointsagainst 2-->".$pointsagainst;
		
		/* create an object with the team stats to return in the array; */
		$obj = new stdClass();
		$obj->id = $team->id;
		$obj->name = stripslashes($team->name);
		$obj->leagueid = $team->leagueid;
		$obj->gamesplayed = $gamesplayed;
		$obj->wins = $wins;
		$obj->losses = $losses;
		$obj->ties = $ties;
		$obj->pointsfor = $pointsfor;
		$obj->pointsagainst = $pointsagainst;
		$obj->winpct = $wins + ($ties*.5);
		$obj->division = getDivisionName($team->divisionid);

		if ($obj->gamesplayed > 0) {
			$obj->winpct = $obj->winpct/$gamesplayed;
		}
		else {
			$obj->winpct = 0;
		}

		$standings[] = $obj;
		$i++;
	}
	return $standings;
}

function isCalendarEvent($rows, $day, $month, $year, $teamid) {
	$events = array();
	$calendardate = $year . $month . $day;
	$e = 0; $i = 0;
	foreach ($rows as $row) {
		if (date('Ynj', strtotime($row->gamedatetime)) == $calendardate) {
			$e++;
		}
	}

	foreach ($rows as $row) {
		if ($i < 3) {
			$gameid = $row->gameid;
			$scored = $row->scored;
			if (date('Ynj', strtotime($row->gamedatetime)) == $calendardate) {
				if ($row->scored) {
					$event = '<a href="' . JRoute::_("index.php?view=boxscore&id=$gameid") . '">' . $row->visitingteam . ' (' . $row->visitingscore . ') &#64; ' . $row->hometeam . ' (' . $row->homescore . ')</a>';
					$events[] = $event;
				}
				else {
					$event = '<a href="' . JRoute::_("index.php?view=schedule&layout=day&id=$teamid&day=$day&month=$month&year=$year") . '">';
					$row->gametime == '12:00 AM' ? $gametime = 'Time: TBA':$gametime = $row->gametime;
					$visitingteam = $row->visitingteam;
					$hometeam = $row->hometeam;
					if ($row->visitingteam == '') {
						$visitingteam = 'TBA';
					}
					if ($row->hometeam == '') {
						$hometeam = 'TBA';
					}
					if ($row->gametype == 'Practice') {
						$event .= $hometeam . ' Practice: ' . $gametime;
					}
					else if ($row->gametype == 'Tournament Game') {
						$event .= 'Tournament: ' . $visitingteam . ' &#64; ' . $hometeam . ' ' . $gametime;
					}
					else {
						$event .= $visitingteam . ' &#64; ' . $hometeam . ' ' . $gametime;
					}

					$event .= ',&nbsp;' . $row->status;
					$event .= '</a>';
					$events[] = $event;
				}
				$i++;
			}
		}
	}
	if (sizeof($events) > 2) {
		$events[] = '<a href="' . JRoute::_("index.php?view=schedule&layout=day&id=$teamid&day=$day&month=$month&year=$year") . '">More (' . abs($i-$e) . ')</a>';
	}
	return $events;
}

function isMonthEvent($rows, $day, $month, $year) {
	$calendardate = $year . $month . $day;
	$events = array();
	$location = '';

	foreach ($rows as $row) {
		$visitingteam = $row->visitingteam;
		$hometeam = $row->hometeam;
		if ($row->visitingteam == '') {
			$visitingteam = 'TBA';
		}
		if ($row->hometeam == '') {
			$hometeam = 'TBA';
		}
		$location = '';
		$event = '';
		if (date('Ynj', strtotime($row->gamedatetime)) == $calendardate) {
			if ($row->scored) {
				$event = $visitingteam . ' (' . $row->visitingscore . ') &#64; ' . $hometeam . ' (' . $row->homescore . ')' . '<br /><br /><a href="' . JRoute::_("index.php?view=boxscore&id=$row->id") . '">Game Summary</a>';
				$event .= '</a>';
			}
			else {
				$row->gametime == '12:00 AM' ? $gametime = ' Time: TBA':$gametime = $row->gametime;

				if ($row->gametype == 'Tournament Game') {
					$event = 'Tournament: ';
				}

				if ($row->gametype == 'Practice') {
					$event = '<a href="' . JRoute::_("index.php?view=team&id=$row->hometeamid") . '">' . $hometeam . '</a> ' . ' Practice: ';
				}
				else {
					if ($row->visitingteamid == 0) {
						$event .= $visitingteam . ' &#64; ';
					}
					else {
						$event .= '<a href="' . JRoute::_("index.php?view=team&id=$row->visitingteamid") . '">' . $visitingteam . '</a> &#64; ';
					}

					if ($row->hometeamid == 0) {
						$event .= $hometeam;
					}
					else {
						$event .= '<a href="' . JRoute::_("index.php?view=team&id=$row->hometeamid") . '">' . $hometeam . '</a> ';
					}
				}
				$event .= $gametime;
				//$event = '<a href="' . JRoute::_("index.php?view=team&id=$row->visitingteamid") . '">' . $row->visitingteam . '</a> &#64; <a href="' . JRoute::_("index.php?view=team&id=$row->hometeamid") . '">' . $row->hometeam . '</a> ' . $gametime;

				if ($row->fieldname != '') {
					if ($row->address || $row->zipcode) {
						$location .= " at <a href=\"http://maps.google.com/?ie=UTF8&hl=en&q=" . urlencode($row->address) . "," . urlencode($row->zipcode) . "&f=q&sampleq=1\" target=\"popup\" onClick=\"wopen('http://maps.google.com/?ie=UTF8&hl=en&q=" . urlencode($row->fieldname) . ',' . urlencode($row->address) . "," . urlencode($row->zipcode) . "&f=q&sampleq=1', 'popup', 850, 600); return false;\">" . $row->fieldname;
						if ($row->field != '') {
							$location .= ', ' . $row->field;
						}
						$location .= '</a>';
					}
					else {
						$location .= ' at ' . $row->fieldname;
					}
				}
			}
			$event .= $location;
			$event .= ',&nbsp;' . $row->status;

			$events[] = $event;
		}
	}
	return $events;
}

function isDayEvent($rows, $day, $month, $year) {
	$events = array();
	$calendardate = $year . $month . $day;

	foreach ($rows as $row) {
		$visitingteam = $row->visitingteam;
		$hometeam = $row->hometeam;
		if ($row->visitingteam == '') {
			$visitingteam = 'TBA';
		}
		if ($row->hometeam == '') {
			$hometeam = 'TBA';
		}
		$location = '';
		$event = '';
		if ($row->scored) {
			$event = $visitingteam . ' (' . $row->visitingscore . ') &#64; ' . $hometeam . ' (' . $row->homescore . ')' . '<br /><br /><a href="' . JRoute::_("index.php?view=boxscore&id=$row->id") . '">Game Summary</a>';
			$event .= '</a>';
		}
		else {
			$row->gametime == '12:00 AM' ? $gametime = ' Time: TBA':$gametime = $row->gametime;

			if ($row->gametype == 'Tournament Game') {
				$event = 'Tournament: ';
			}

			if ($row->gametype == 'Practice') {
				$event = '<a href="' . JRoute::_("index.php?view=team&id=$row->hometeamid") . '">' . $hometeam . '</a> ' . ' Practice: ';
			}
			else {
				if ($row->visitingteamid == 0) {
					$event .= $visitingteam . ' &#64; ';
				}
				else {
					$event .= '<a href="' . JRoute::_("index.php?view=team&id=$row->visitingteamid") . '">' . $visitingteam . '</a> &#64; ';
				}

				if ($row->hometeamid == 0) {
					$event .= $hometeam;
				}
				else {
					$event .= '<a href="' . JRoute::_("index.php?view=team&id=$row->hometeamid") . '">' . $hometeam . '</a> ';
				}
			}
			$event .= $gametime;

			if ($row->fieldname != '') {
				if ($row->address || $row->zipcode) {
					$location .= " <br /><br />Location: <a href=\"http://maps.google.com/?ie=UTF8&hl=en&q=" . urlencode($row->address) . "," . urlencode($row->zipcode) . "&f=q&sampleq=1\" target=\"popup\" onClick=\"wopen('http://maps.google.com/?ie=UTF8&hl=en&q=" . urlencode($row->fieldname) . ',' . urlencode($row->address) . "," . urlencode($row->zipcode) . "&f=q&sampleq=1', 'popup', 850, 600); return false;\">" . $row->fieldname;
					if ($row->field != '') {
						$location .= ', ' . $row->field;
					}
					$location .= '</a>';
				}
				else {
					$location .= ' <br /><br />Location: ' . $row->fieldname;
				}
			}
		}
		$event .= $location;
		$event .= ',&nbsp;' . $row->status;
		$events[] = $event;
	}

	if (sizeof($events) == 0) {
		$events[] = 'There are no games scheduled for this day';
	}
	return $events;
}

/* image handling routines; */
function processImage($file, &$filename, $width, $height) {
	$params = JComponentHelper::getParams('com_fullcourt');

	$filepath = JPATH_CONFIGURATION . DS . $params->get('images_path');

	if ($file['error'] > 0) {
		switch ($file['error']) {
			case 1:
				$error = 'File exceeded the maximum upload file size';
				break;
			case 2:
				$error = 'File exceeded the maximum file size';
				break;
			case 3:
				$error = 'File only partially uploaded';
				break;
			case 4:
				$error = 'No file selected to upload';
				break;
		}
		return $error;
	}

	// check to make sure the file is of the supported type;
	$allowed_file_types = array('image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png', 'image/gif');
	if (!in_array($file['type'], $allowed_file_types)) {
		$error = "Unsupported image file type uploaded!";
		return $error;
	}

	// everything looks good for the file upload so resize and move it;
	//OST Changes to upload png file
	
	
	//$filename .= ".jpg";
	move_uploaded_file($file['tmp_name'], $filepath . $filename);
	$size = getimagesize($filepath . $filename);
	$w = $size[0];
	$h = $size[1];
	$stype = $size[2];
	switch($stype) {
		case '1':
			$simg = imagecreatefromgif($filepath . $filename);
			break;
		case '2':
			$simg = imagecreatefromjpeg($filepath . $filename);
			break;
		default:
			$simg = imagecreatefrompng($filepath . $filename);
			break;
	}

	if ($w > $width || $h > $height) {
		$dimg = imagecreatetruecolor($width, $height);
		imagealphablending($dimg, true);
		$backgroundcolor = imagecolorallocate($dimg, 255, 255, 255);
		imagefilledrectangle($dimg, 0, 0, $width, $height, $backgroundcolor);
		$wm = $w/$width;
		$hm = $h/$height;
		$h_height = $height/2;
		$w_height = $width/2;
		if ($w > $h) {
			$adjusted_width = $w / $hm;
			$half_width = $adjusted_width / 2;
			$int_width = $half_width - $w_height;
			imagecopyresampled($dimg,$simg,-$int_width,0,0,0,$adjusted_width,$height,$w,$h);
		}
		else if (($w < $h) || ($w == $h)) {
			$adjusted_height = $h / $wm;
			$half_height = $adjusted_height / 2;
			$int_height = $half_height - $h_height;
			imagecopyresampled($dimg,$simg,0,-$int_height,0,0,$width,$adjusted_height,$w,$h);
		}
		else {
			imagecopyresampled($dimg,$simg,0,0,0,0,$width,$height,$w,$h);
		}
	}
	else {
		$dimg = imagecreatetruecolor($w, $h);
		imagealphablending($dimg, true);
		$backgroundcolor = imagecolorallocate($dimg, 255, 255, 255);
		imagefilledrectangle($dimg, 0, 0, $w, $h, $backgroundcolor);
		imagecopyresampled($dimg, $simg, 0, 0, 0, 0, $w, $h, $w, $h);
	}

	imagejpeg($dimg, $filepath . $filename, 80);
	imagedestroy($dimg);

	return false;
}

?>