<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

function boxscoreStats($playerid, $gameid, $teamid, $season, $type, $sort = 'yards') {
	$db =  JFactory::getDBO();
	
	if ($type == 'teamseason') {
		/* OST Changes 
		
		*/
		
		$db->setQuery("SELECT t.*, b.gameid AS gameid, b.playerid AS playerid, CONCAT(l.fname, ' ', l.lname) AS name, ROUND(AVG(b.min), 1) AS min, ROUND(AVG(b.fgm), 1) AS fgm, ROUND(AVG(b.fga), 1) AS fga, ROUND(AVG(b.fgm)/AVG(b.fga), 3) AS fgpct, ROUND(AVG(b.threepm), 1) AS threepm, ROUND(AVG(b.threepa), 1) AS threepa, ROUND(AVG(b.threepm)/AVG(b.threepa), 3) AS threeppct, ROUND(AVG(b.ftm), 1) AS ftm, ROUND(AVG(b.fta), 1) AS fta, ROUND(AVG(b.ftm)/AVG(b.fta), 3) AS ftpct, ROUND(AVG(b.oreb), 1) AS oreb, ROUND(AVG(b.dreb), 1) AS dreb , ROUND(AVG(b.ast), 1) AS ast, ROUND(AVG(b.stl), 1) AS stl, ROUND(AVG(b.blk), 1) AS blk, ROUND(AVG(b.turnovers), 1) AS turnovers, ROUND(AVG(b.pf), 1) AS pf, ROUND(AVG(b.pts), 1) AS pts FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id LEFT JOIN #__fullcourt_player AS l ON l.id = b.playerid WHERE (t.id = {$teamid} AND b.seasonid = {$season}) GROUP BY b.playerid");
		
	}
	else if ($type == 'teamseasontotals') {
		$sort = '';
				
		$db->setQuery("SELECT t.*, b.gameid AS gameid, b.playerid AS playerid, CONCAT(l.fname, ' ', l.lname) AS name, SUM(b.min) AS min, SUM(b.fgm) AS fgm, SUM(b.fga) AS fga, SUM(b.threepm) AS threepm, SUM(b.threepa) AS threepa, SUM(b.ftm) AS ftm, SUM(b.fta) AS fta, SUM(b.oreb) AS oreb, SUM(b.dreb) AS dreb, SUM(b.ast) AS ast, SUM(b.stl) AS stl, SUM(b.blk) AS blk, SUM(b.turnovers) AS turnovers, SUM(b.pf) AS pf, SUM(b.pts) AS pts FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id LEFT JOIN #__fullcourt_player AS l ON l.id = b.playerid WHERE (t.id = {$teamid} AND b.seasonid = {$season}  AND l.published = 1) GROUP BY b.seasonid");
	}
	else if ($type == 'playerseason') 
	{
		$sort = 'date';
				
		$db->setQuery("SELECT b.*, (b.oreb+b.dreb) AS reb, ROUND(b.fgm/b.fga, 3) AS fgpct, ROUND(b.threepm/b.threepa, 3) AS threeppct, ROUND(b.ftm/b.fta, 3) AS ftpct, s.*, ls.finalv, ls.finalh, (SELECT name FROM #__fullcourt_team WHERE (id = s.visitingteam)) AS visitingteamname, (SELECT name FROM #__fullcourt_team WHERE (id = s.hometeam)) AS hometeamname, (SELECT shortname FROM #__fullcourt_team WHERE (id = s.visitingteam)) AS visitingteamnameshort, (SELECT shortname FROM #__fullcourt_team WHERE (id = s.hometeam)) AS hometeamnameshort, DATE_FORMAT(s.gamedatetime, '%m/%d/%Y') AS date FROM #__fullcourt_boxscore AS b LEFT JOIN #__fullcourt_schedule AS s ON b.gameid = s.id LEFT JOIN #__fullcourt_linescore AS ls ON b.gameid = ls.gameid WHERE (b.playerid = {$playerid} AND s.season = {$season})");
	}
	else {
		$db->setQuery("SELECT b.playerid AS playerid, ROUND(AVG(b.min), 1) AS min, ROUND(AVG(b.fgm), 1) AS fgm, ROUND(AVG(b.fga), 1) AS fga, ROUND(AVG(b.fgm)/AVG(b.fga), 3) AS fgpct, ROUND(AVG(b.threepm), 1) AS threepm, ROUND(AVG(b.threepa), 1) AS threepa, ROUND(AVG(b.threepm)/AVG(b.threepa), 3) AS threeppct, ROUND(AVG(b.ftm), 1) AS ftm, ROUND(AVG(b.fta), 1) AS fta, ROUND(AVG(b.ftm)/AVG(b.fta), 3) AS ftpct, ROUND(AVG(b.oreb + b.dreb), 1) AS reb, ROUND(AVG(b.ast), 1) AS ast, ROUND(AVG(b.stl), 1) AS stl, ROUND(AVG(b.blk), 1) AS blk, ROUND(AVG(b.turnovers), 1) AS turnovers, ROUND(AVG(b.pf), 1) AS pf, ROUND(AVG(b.pts), 1) AS pts, s.*, (SELECT name FROM #__fullcourt_team WHERE (id = s.visitingteam)) AS visitingteamname, (SELECT name FROM #__fullcourt_team WHERE (id = s.hometeam)) AS hometeamname, DATE_FORMAT(s.gamedatetime, '%m/%d/%Y') AS date FROM #__fullcourt_boxscore AS b LEFT JOIN #__fullcourt_schedule AS s ON b.gameid = s.id WHERE (b.playerid = {$playerid} AND s.season = {$season}) GROUP BY b.playerid");
	}

	$stats = $db->loadObjectList();

	$arr = array();
	$obj = new stdClass();
	foreach ($stats as $p) {

		$obj = new stdClass();
		if(isset($p->gameid)){
			$obj->gameid = $p->gameid;
		}
		if(isset($p->playerid)){
			$obj->playerid = $p->playerid;
		}
		
		if(isset($p->name)){
			$obj->name = $p->name;
		}
		
		if (isset($p->visitingteamnameshort)) {
			$obj->visitingteamname = $p->visitingteamnameshort;
		}
		else {
			if (isset($p->visitingteamname)) {
				$obj->visitingteamname = $p->visitingteamname;
			}
			
		}
		if (isset($p->hometeamnameshort)) {
			$obj->hometeamname = $p->hometeamnameshort;
		}
		else {
			if (isset($p->hometeamname)) {
				$obj->hometeamname = $p->hometeamname;
			}
			
		}
		if(isset($p->teamid)){
			$obj->teamid = $p->teamid;
		}
		
		if(isset($p->visitingteam)){
			$obj->visitingteam = $p->visitingteam;
		}

		if(isset($p->hometeam)){
			$obj->hometeam = $p->hometeam;
		}
		
		if(isset($p->date)){
			$obj->date = $p->date;
		}
		
		if(isset($p->min)){
			$obj->min = $p->min;
		}

		if(isset($p->fgm)){
			$obj->fgm = $p->fgm;
		}
		if(isset($p->fga)){
			$obj->fga = $p->fga;
		}
		
		
		if (isset($p->fgpct)) {
			$obj->fgpct = $p->fgpct;
		}
		else {
			$obj->fgpct = '0.000';
		}
		
		if(isset($p->threepm)){
			$obj->threepm = $p->threepm;
		}
		
		if(isset($p->threepa)){
			$obj->threepa = $p->threepa;
		}
		
		if (isset($p->threeppct)) {
			$obj->threeppct = $p->threeppct;
		}
		else {
			$obj->threeppct = '0.000';
		}
		if (isset($p->ftm)) {
			$obj->ftm = $p->ftm;
		}
		
		if (isset($p->fta)) {
			$obj->fta = $p->fta;
		}
		
		if (isset($p->ftpct)) {
			$obj->ftpct = $p->ftpct;
		}
		else {
			$obj->ftpct = '0.000';
		}
		if(isset($p->oreb)){
			$obj->oreb = $p->oreb;
		}
		if(isset($p->dreb)){
			$obj->dreb = $p->dreb;
		}
		
		
		if(isset($p->reb)){
			$obj->reb = $p->reb;
		}
		if(isset($p->ast)){
			$obj->ast = $p->ast;
		}
		if(isset($p->stl)){
			$obj->stl = $p->stl;
		}
		if(isset($p->blk)){
			$obj->blk = $p->blk;
		}
		
		if(isset($p->turnovers)){
			$obj->turnovers = $p->turnovers;
		}
		
		
		
		
		if(isset($p->pf)){
			$obj->pf = $p->pf;
		}
		if(isset($p->pts)){
			$obj->pts = $p->pts;
		}
		
		if(isset($p->finalv)){
			$obj->finalv = $p->finalv;
			
		}
		if(isset($p->finalh)){
			$obj->finalh = $p->finalh;
		}
		
		$arr[] = $obj;
	}

	$direction = -1;
	if ($sort == 'name') {
		$direction = 1;
	}
	$arr = JArrayHelper::sortObjects($arr, $sort, $direction);

	if ($arr) {
		return $arr;
	}
	else {
		return array();
	}
}

function calendarSchedule($whereclause) {
	$db =  JFactory::getDBO();

$sql = "SELECT a.*, a.id AS gameid, a.hometeam AS hometeamid, a.visitingteam AS visitingteamid,
		DATE_FORMAT(a.gamedatetime, '%a, %M %D %Y') AS gamedate,
		DATE_FORMAT(a.gamedatetime, '%l:%i %p') As gametime,
		b.finalv AS visitingscore,
		b.finalh AS homescore,
		h.name AS hometeam,
		h.logo AS homelogo,
		v.name AS visitingteam,
		v.logo AS visitinglogo,
		t.description AS gametype,
		l.name AS fieldname,
		l.address AS address,
		l.city AS city,
		l.state AS state,
		l.zipcode AS zipcode,
		s.description AS status
		FROM #__fullcourt_schedule AS a
		LEFT JOIN #__fullcourt_team AS h ON a.hometeam = h.id
		LEFT JOIN #__fullcourt_team AS v ON a.visitingteam = v.id
		LEFT JOIN #__fullcourt_gametype AS t ON a.gametype = t.id
		LEFT JOIN #__fullcourt_location AS l ON a.location = l.id
		LEFT JOIN #__fullcourt_gamestatus AS s ON a.status = s.id
		LEFT JOIN #__fullcourt_linescore AS b ON a.id = b.gameid
		WHERE 1=1 {$whereclause}
		GROUP BY a.id
		ORDER BY a.gamedatetime";

	$db->setQuery($sql);
	$rows = $db->loadObjectList();

	if ($rows) {
		return $rows;
	}
	else {
		return array();
	}
}
?>
