SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for #__fullcourt_boxscore
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_boxscore`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_boxscore` (
  `gameid` int(11) NOT NULL DEFAULT '0',
  `playerid` int(11) NOT NULL DEFAULT '0',
  `teamid` int(11) DEFAULT NULL,
  `seasonid` int(11) DEFAULT NULL,
  `gs` tinyint(1) DEFAULT '0',
  `pos` char(2) DEFAULT NULL,
  `min` smallint(6) DEFAULT '0',
  `fgm` smallint(6) DEFAULT '0',
  `fga` smallint(6) DEFAULT '0',
  `threepm` smallint(6) DEFAULT '0',
  `threepa` smallint(6) DEFAULT '0',
  `ftm` smallint(6) DEFAULT '0',
  `fta` smallint(6) DEFAULT '0',
  `oreb` smallint(6) DEFAULT '0',
  `dreb` smallint(6) DEFAULT '0',
  `ast` smallint(6) DEFAULT '0',
  `stl` smallint(6) DEFAULT '0',
  `blk` smallint(6) DEFAULT '0',
  `turnovers` smallint(6) DEFAULT '0',
  `pf` smallint(6) DEFAULT '0',
  `pts` smallint(6) DEFAULT '0',
  PRIMARY KEY (`gameid`,`playerid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_division
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_division`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_division` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `leagueid` int(11) DEFAULT '0',
  `division` varchar(255) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  `ordering` int(11) DEFAULT '0',  
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_gamestatus
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_gamestatus`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_gamestatus` (
  `id` tinyint(4) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`,`description`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_gametype
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_gametype`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_gametype` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `description` varchar(255) DEFAULT NULL,
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT '00:00:00',
  `published` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `id` (`id`,`description`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_league
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_league`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_league` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `isdefault` tinyint(1) DEFAULT '0',
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `cname` varchar(50) DEFAULT NULL,
  `cphone` varchar(15) DEFAULT NULL,
  `cmobile` varchar(15) DEFAULT NULL,
  `cemail` varchar(65) DEFAULT NULL,
  `logo` varchar(35) DEFAULT NULL,
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT '00:00:00',
  `published` tinyint(1) DEFAULT '1',
  `ordering` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_linescore
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_linescore`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_linescore` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `gameid` int(11) DEFAULT NULL,
  `seasonid` int(11) DEFAULT NULL,
  `scoretype` char(1) DEFAULT 'Q',
  `vteamid` int(11) DEFAULT NULL,
  `quarter1v` smallint(6) DEFAULT '0',
  `quarter2v` smallint(6) DEFAULT '0',
  `quarter3v` smallint(6) DEFAULT '0',
  `quarter4v` smallint(6) DEFAULT '0',
  `overtimev` varchar(128) DEFAULT '0',
  `finalv` smallint(6) DEFAULT '0',
  `hteamid` int(11) DEFAULT NULL,
  `quarter1h` smallint(6) DEFAULT '0',
  `quarter2h` smallint(6) DEFAULT '0',
  `quarter3h` smallint(6) DEFAULT '0',
  `quarter4h` smallint(6) DEFAULT '0',
  `overtimeh` varchar(128) DEFAULT '0',
  `finalh` smallint(6) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_location
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_location`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_location` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL,
  `city` varchar(50) DEFAULT NULL,
  `state` char(3) DEFAULT NULL,
  `zipcode` varchar(10) DEFAULT NULL,
  `country` char(3) DEFAULT NULL,
  `fieldnames` text,
  `extrainfo` text,
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_player
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_player`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_player` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `active` int(11) DEFAULT '1',
  `playerid` int(11) DEFAULT '0',
  `teamid` int(11) DEFAULT '0',
  `fname` varchar(35) DEFAULT NULL,
  `mname` char(1) DEFAULT NULL,
  `lname` varchar(35) DEFAULT NULL,
  `positions` varchar(255) DEFAULT NULL,
  `jerseyhome` varchar(5) DEFAULT NULL,
  `jerseyaway` varchar(5) DEFAULT NULL,
  `birthdate` date DEFAULT '0000-00-00',
  `heightfeet` INT(8) DEFAULT '0',
  `heightinches` INT(8) DEFAULT '0',
  `weight` smallint(15) DEFAULT '0',
  `weightuom` varchar(10) DEFAULT 'lbs',
  `hometown` varchar(50) DEFAULT NULL,
  `photo` varchar(35) DEFAULT NULL,
  `cphone` varchar(15) DEFAULT NULL,
  `cmobile` varchar(15) DEFAULT NULL,
  `email` varchar(65) DEFAULT NULL,
  `experience` text,
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  `custom1` varchar(255) DEFAULT NULL,
  `custom2` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_schedule
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_schedule`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_schedule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `season` int(11) DEFAULT '0',
  `leagueid` int(11) DEFAULT '0',
  `divisionid` int(11) DEFAULT '0',
  `visitingteam` int(11) DEFAULT '0',
  `hometeam` int(11) DEFAULT '0',
  `gamedatetime` datetime DEFAULT '0000-00-00 00:00:00',
  `gametimezone` varchar(5) DEFAULT NULL,
  `gametype` int(11) DEFAULT '0',
  `location` int(11) DEFAULT '0',
  `field` varchar(50) DEFAULT NULL,
  `status` tinyint(1) DEFAULT '1',
  `scored` tinyint(1) DEFAULT '0',
  `published` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `gametype` (`gametype`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_season
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_season`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_season` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `isdefault` tinyint(1) DEFAULT '0',
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT '00:00:00',
  `published` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for #__fullcourt_team
-- ----------------------------
-- DROP TABLE IF EXISTS `#__fullcourt_team`;
CREATE TABLE IF NOT EXISTS `#__fullcourt_team` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `leagueid` int(11) DEFAULT '0',
  `divisionid` int(11) DEFAULT '0',
  `defaultteam` tinyint(1) DEFAULT '0',
  `name` varchar(255) DEFAULT NULL,
  `shortname` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `state` char(3) DEFAULT NULL,
  `adminids` varchar(255) DEFAULT NULL,
  `mname` varchar(50) DEFAULT NULL,
  `mphone` varchar(15) DEFAULT NULL,
  `mmobile` varchar(15) DEFAULT NULL,
  `memail` varchar(65) DEFAULT NULL,
  `mtshow` enum('0','1') DEFAULT '0',
  `mrshow` enum('0','1') NOT NULL DEFAULT '0',
  `m1name` varchar(50) DEFAULT NULL,
  `m1phone` varchar(15) DEFAULT NULL,
  `m1mobile` varchar(15) DEFAULT NULL,
  `m1email` varchar(65) DEFAULT NULL,
  `ctshow` enum('0','1') DEFAULT '0',
  `crshow` enum('0','1') NOT NULL DEFAULT '0',
  `m2name` varchar(50) DEFAULT NULL,
  `m2phone` varchar(15) DEFAULT NULL,
  `m2mobile` varchar(15) DEFAULT NULL,
  `m2email` varchar(65) DEFAULT NULL,
  `logo` varchar(35) DEFAULT NULL,
  `photo` varchar(35) DEFAULT NULL,
  `accomplishments` text,
  `checked_out` tinyint(1) DEFAULT '0',
  `checked_out_time` time DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  `facebook` varchar(255) DEFAULT NULL,
  `website` varchar(255) DEFAULT NULL,
  `mediateam` tinyint(1) DEFAULT '0',
  `mediaroster` tinyint(1) DEFAULT '0',
  `mediaschedule` tinyint(1) DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=21;
-- ----------------------------
-- Table structure for #__fullcourt_importexport_logs
-- ----------------------------
CREATE TABLE IF NOT EXISTS `#__fullcourt_importexport_logs` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `log_type` varchar(255) NOT NULL,
  `tablename` varchar(255) NOT NULL,
  `userid` int(9) NOT NULL,
  `log_datetime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `add_rows` int(9) NOT NULL,
  `edit_rows` int(11) NOT NULL,
  `delete_rows` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records
-- ----------------------------
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('1', 'As Scheduled');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('2', 'Cancelled');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('3', 'Game Completed');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('4', 'Forfeit by Home Team');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('5', 'Forfeit by Visiting Team');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('6', 'Rained Out');
INSERT IGNORE INTO `#__fullcourt_gamestatus` (`id`, `description`) VALUES ('7', 'Called Early');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('1', 'Regular Season', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('2', 'League Game', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('3', 'Non League Game', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('4', 'Exhibition Game', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('5', 'Playoff Game', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('6', 'Practice', '0', '00:00:00');
INSERT IGNORE INTO `#__fullcourt_gametype` (`id`, `description`, `checked_out`, `checked_out_time`) VALUES ('7', 'Tournament Game', '0', '00:00:00');
