<?php
/**
 * @version $Id: manifest.class.php, v3.0 Oct 2013 01:32:15
 * @author Fastball Productions
 * @package com_fullcourt
 * @subpackage components
 * @link http://www.fastballproductions.com
 * @copyright Copyright (C) 2013 Fastball Productions
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

class com_fullcourtInstallerScript {

	function preflight($action, $installer) {
    	switch ($action) {
        	case "install":
            	/* stuff to do immediately before installing; */
                break;
        }
    }

    function update($parent) {
    	/* $parent is the class calling this method; */
    	echo '<p>' . JText::sprintf('COM_FULLCOURT_UPDATE_TEXT', $parent->get('manifest')->version) . '</p>';
    }

    function uninstall($installer) {
    	$this->displayComponentUninstallSuccess();
    }

    function postflight($action, $installer) {
        switch ($action) {
            case "install":
            /* 	$this->alterTables(); */
                $this->createConfigurationParams();
                $this->runFileOperations();
				$this->displayComponentInstallSuccess();
                break;

            case "update":
            /* 	$this->alterTables();  */ 
                $this->createConfigurationParams();
                $this->runFileOperations();
				$this->displayComponentInstallSuccess();
            	break;
        }
    }

    function alterTables() {
		$db =  JFactory::getDBO();
		@$db->setQuery("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '". $db->getPrefix()."fullcourt_team'");
		@$db->query();
		$data = $db->loadObjectList();
		$a = 0;
		$b = 0;
		foreach($data as $row){
		if( $row->COLUMN_NAME == 'mshow'){
			@$db->setQuery("ALTER TABLE `" . $db->getPrefix() . "fullcourt_team` CHANGE mshow `mtshow` enum('0','1') DEFAULT '0'");
			@$db->query();
		}
		if( $row->COLUMN_NAME == 'm1show'){
			@$db->setQuery("ALTER TABLE `" . $db->getPrefix() . "fullcourt_team` CHANGE m1show `mrshow` enum('0','1') NOT NULL DEFAULT '0'");
			@$db->query();
		}
		if($row->COLUMN_NAME == 'ctshow'){
				$a = 1;
			} 
			if($row->COLUMN_NAME == 'crshow'){
				$b = 1;
			} 
		}
		
		if($a == '0'){ 
			@$db->setQuery("ALTER TABLE `" . $db->getPrefix() . "fullcourt_team` ADD `ctshow` enum('0','1') DEFAULT '0'");
			@$db->query();
		}
		if($b == '0'){ 
			@$db->setQuery("ALTER TABLE `" . $db->getPrefix() . "fullcourt_team` ADD `crshow` enum('0','1') NOT NULL DEFAULT '0'");
			@$db->query();
		}
    
    }

    function createConfigurationParams() {
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->update('#__extensions');
		$defaults = '{"standings_ties":"1","boxscore_stats":"1","player_jersey":"1","player_position":"1","player_heightweight":"1","player_uom":"english","player_birthdate":"1","player_age":"1","player_hometown":"0","player_phone":"0","player_email":"0","player_experience":"1","custom1":"Custom 1","custom1_playerpage":"1","custom1_rosterpage":"1","custom2":"Custom 2","custom2_playerpage":"1","custom2_rosterpage":"1","roster_sort":"jerseyhome","images_path":"images\/fullcourt\/","team_logo":"1","team_photo":"1","player_photo":"1","admin_teaminfo":"1","admin_teamroster":"1","admin_teamschedule":"1","admin_locations":"1","admin_results":"1","admin_addteam":"1"}';
		$query->set("params = " . "'".$defaults."'");
		$query->where("name = 'com_fullcourt'");
		$db->setQuery($query);
		$db->query();
    }

    function runFileOperations() {
		/* file operations - make sure the fullcourt image directory does not already exist; */
		if (!file_exists(JPATH_CONFIGURATION . '/images/fullcourt/')) {
			@mkdir(JPATH_CONFIGURATION . '/images/fullcourt', 0777);
		}
		@chmod(JPATH_CONFIGURATION . '/images/fullcourt', 0777);
		if (!file_exists(JPATH_CONFIGURATION . '/images/fullcourt/nophoto.gif')) {
			@rename(JPATH_CONFIGURATION . '/components/com_fullcourt/nophoto.gif', JPATH_CONFIGURATION . '/images/fullcourt/nophoto.gif');
		}
		if (!file_exists(JPATH_CONFIGURATION . '/images/fullcourt/facebook-logo-16.png')) {
			@rename(JPATH_CONFIGURATION . '/components/com_fullcourt/facebook-logo-16.png', JPATH_CONFIGURATION . '/images/fullcourt/facebook-logo-16.png');
		}
		if (!file_exists(JPATH_CONFIGURATION . '/images/fullcourt/index.html')) {
			@copy(JPATH_CONFIGURATION . '/components/com_fullcourt/index.html', JPATH_CONFIGURATION . '/images/fullcourt/index.html');
		}
    }

    function displayComponentInstallSuccess() {
		?>
	  	<a href="http://www.fastballproductions.com"><img src="./components/com_fullcourt/images/FullCourtManager160.jpg" border="0"></a>
      	<div>Fastball Productions Basketball Management and Reporting Version 3.1.5</div>
      	<p>Getting Started</p>
      	<p>
		Select the .FullCourt. component from the Components menu in the Joomla admin.
		<br /><br />
        <ul>
        	<li>Compatible with both Joomla version 2.5 and 3.0.</li>
        	<li>Create a new league (not required, use as necessary). </li>
        	<li>Create a new team (for managed yes/no select yes). </li>
        	<li>In team setup, select registered users who will have admin rights (for front-end admin access).</li>
            <li>Create a new season -> select "default season". The default season is the one that will load for schedules, stats and current roster.</li>
            <li>Create new venue/playing court(s) as needed. Venues/Courts are required for scheduling games.</li>
            <li>Create new opposing team(s) for scheduling purposes. Note: for opposing teams that you do not want to track rosters, etc., select "no" for managed team.</li>
            <li>Create scheduled games.</li>
            <li>Enter game results and individual statistics. Select "Game Results" then select the appropriate game from the list. Follow directions for entering team summaries and individual statistics. Remember to save your work.</li>
            <li>Review configuration options.</li>
            <li>For menu linking options, create a new menu link and select &ldquo;.FullCourt.&rdquo; and the appropriate link type (Schedule, Roster, Stats, etc).  You may setup the menu structure you desire or simply use the &ldquo;All Teams with Nagivation&rdquo; link type for built in navigation (may be desired for league management).</li>
       	 </ul>
         
		<br /><br />
		For support questions and suggestions for future development, please contact <a href="mailto:support@fastballproductions.com">support@fastballproductions.com</a>.<br />
	    Fastballproductions.com &copy; 2013 | <a href="http://www.fastballproductions.com">www.fastballproductions.com</a>
      	</p>
      	<br/><br/>
		<?php
    }

    function displayComponentUninstallSuccess() {
		?>
      	<div>Fastball Productions Basketball Management and Reporting has been removed from your system.</div>
      	<p></p>
      	<p>The MySql database tables have not been removed. If you wish to remove these manually the tables have a naming structure of #__fullcourt_ where #__ is the database prefix you supplied during your Joomla installation.</p>
      	<p></p>
      	<p>If you plan to reinstall or upgrade your FullCourt component you should not remove the database tables or all data will be lost.
		<br /><br />
		<a href="http://www.fastballproductions.com"><img src="./components/com_fullcourt/images/FullCourtManager160.jpg" border="0"></a>
		<br /><br />
		For support questions and suggestions for future development, please contact <a href="mailto:support@fastballproductions.com">support@fastballproductions.com</a>.<br />
	    Fastballproductions.com &copy; 2013 | <a href="http://www.fastballproductions.com">www.fastballproductions.com</a>
      	</p>
      	<br/><br/>
    	<?php
    }
}
?>
