<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');
error_reporting(E_ALL ^ E_NOTICE);
jimport('joomla.application.component.model');

class FullcourtModelBoxscore extends JModelLegacy {
	var $_game = null;
	var $_boxscore = null;
	var $_linescore = null;
	var $_hometeam = null;
	var $_visitingteam = null;

	function getGame($id) {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_schedule WHERE (id = {$id})";
		$db->setQuery($query);
		$this->_game = $db->loadObject();
		return $this->_game;
	}

	function getLinescore() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_linescore WHERE (gameid = {$this->_game->id})";
		$db->setQuery($query);
		$this->_linescore = $db->loadObject();
		
		/* unserialize the OT for the visiting team; */
		if(isset($this->_linescore->overtimev)){
			$this->_linescore->overtimev = unserialize($this->_linescore->overtimev);
		}

		/* unserialize the OT for the home team; */
		if(isset($this->_linescore->overtimev)){
			$this->_linescore->overtimeh = unserialize($this->_linescore->overtimeh);
		}

		return $this->_linescore;
	}
	function getBoxscore($teamid) {
		$db = $this->getDBO();
		$arr = array();

		/* get the list of players for the team; */
		$query = "SELECT p.id, CONCAT(p.lname, ', ', p.fname) AS name FROM #__fullcourt_player AS p WHERE (p.teamid = {$teamid}) ORDER BY name ASC";
		$db->setQuery($query);
		$players = $db->loadObjectList();
		
		foreach ($players as $player) {
			
			$playerstats = new stdClass();
			
			$query = "SELECT b.* FROM #__fullcourt_boxscore AS b WHERE (b.playerid = {$player->id} AND b.gameid = {$this->_game->id})";
			$db->setQuery($query);
			$game = $db->loadObject();
			
			if ($game) {
				$playerstats->id = $player->id;
				$playerstats->name = $player->name;
				$playerstats->gameid = $game->gameid;
				$playerstats->teamid = $game->teamid;
				$playerstats->seasonid = $game->seasonid;
				$playerstats->gs = $game->gs;
				$playerstats->pos = $game->pos;
				$playerstats->min = $game->min;
				$playerstats->fgm = $game->fgm;
				$playerstats->fga = $game->fga;
				$playerstats->threepm = $game->threepm;
				$playerstats->threepa = $game->threepa;
				$playerstats->ftm = $game->ftm;
				$playerstats->fta = $game->fta;
				$playerstats->oreb = $game->oreb;
				$playerstats->dreb = $game->dreb;
				$playerstats->ast = $game->ast;
				$playerstats->stl = $game->stl;
				$playerstats->blk = $game->blk;
				$playerstats->turnovers = $game->turnovers;
				$playerstats->pf = $game->pf;
				$playerstats->pts = $game->pts;
			}
			else {
				$playerstats->id = $player->id;
				$playerstats->name = $player->name;
				$playerstats->gameid = '';
				$playerstats->teamid = '';
				$playerstats->seasonid = '';
				$playerstats->gs = '';
				$playerstats->pos = '';
				$playerstats->min = '';
				$playerstats->fgm = '';
				$playerstats->fga = '';
				$playerstats->threepm = '';
				$playerstats->threepa = '';
				$playerstats->ftm = '';
				$playerstats->fta = '';
				$playerstats->oreb = '';
				$playerstats->dreb = '';
				$playerstats->ast = '';
				$playerstats->stl = '';
				$playerstats->blk = '';
				$playerstats->turnovers = '';
				$playerstats->pf = '';
				$playerstats->pts = '';
			}
			$arr[] = $playerstats;
		}

		$this->_boxscore = $arr;
		return $this->_boxscore;
	}

	function getVisitingteamRoster() {
		$db = $this->getDBO();
		$query = "SELECT id AS value, CONCAT(SUBSTR(fname, 1, 1), '. ', lname) AS text FROM #__fullcourt_player WHERE (teamid = {$this->_game->visitingteam})";
		$db->setQuery($query);
		$roster = $db->loadObjectList();
		return $roster;
	}

	function getHometeamRoster() {
		$db = $this->getDBO();
		$query = "SELECT id AS value, CONCAT(lname, ', ', SUBSTR(fname, 1, 1), '.') AS text FROM #__fullcourt_player WHERE (teamid = {$this->_game->hometeam}) ORDER BY text ASC";
		$db->setQuery($query);
		$roster = $db->loadObjectList();
		return $roster;
	}

	function getHometeam() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_team WHERE (id = {$this->_game->hometeam})";
		$db->setQuery($query);
		$this->_hometeam = $db->loadObject();
		return $this->_hometeam;
	}

	function getVisitingteam() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_team WHERE (id = {$this->_game->visitingteam})";
		$db->setQuery($query);
		$this->_visitingteam = $db->loadObject();
		return $this->_visitingteam;
	}

	function saveLinescore() {
		$db = $this->getDBO();

		$row =  JTable::getInstance('linescore', 'Table');
		$post = JRequest::get('post');
		$otv = array();
		$oth = array();

		/* get the scores by quarter OT input values as an array; */
		$overtimev = $post['overtimev'];
		$overtimeh = $post['overtimeh'];

		/* check if the score was entered by quarters or halves; */
		if ($post['scoretype'] == 'H') {
			/* save the halves to quarter1 and quarter2; */
			$post['quarter1v'] = $post['half1v'];
			$post['quarter2v'] = $post['half2v'];
			$post['quarter1h'] = $post['half1h'];
			$post['quarter2h'] = $post['half2h'];

			/* save the final scores; */
			$post['finalv'] = $post['finalvh'];
			$post['finalh'] = $post['finalhh'];

			/* clear out the other quarters and overtimes; */
			$post['quarter3v'] = 0;
			$post['quarter4v'] = 0;
			$post['quarter3h'] = 0;
			$post['quarter4h'] = 0;

			/* get the score by halves OT input values as an array; */
			$overtimev = $post['halfovertimev'];
			$overtimeh = $post['halfovertimeh'];
		}

		/* cycle through the OTs and make sure values have been entered; */
		for ($i = 0; $i < sizeof($overtimev); $i++) {
			if (is_numeric($overtimev[$i]) || is_numeric($overtimeh[$i])) {
				if (is_numeric($overtimev[$i])) {
					$otv[] = $overtimev[$i];
				}
				else {
					$otv[] = 0;
				}

				if (is_numeric($overtimeh[$i])) {
					$oth[] = $overtimeh[$i];
				}
				else {
					$oth[] = 0;
				}
			}
		}

		$overtimev = serialize($otv);
		$overtimeh = serialize($oth);

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$row->overtimev = $overtimev;
		$row->overtimeh = $overtimeh;

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		/* update the game schedule and set the "scored" flag on; */
		$gameid = intval($post['gameid']);
		$query = "UPDATE #__fullcourt_schedule SET status = 3, scored = 1 WHERE (id = {$gameid})";
		$db->setQuery($query);
		$db->query();
		return true;
	}

	function saveBoxscore() {
		$db = $this->getDBO();
		jimport('joomla.filesystem.file');
		$file_home = JRequest::getVar('home_team_stats', null, 'files', 'array');
		$file_visiting = JRequest::getVar('visiting_team_stats', null, 'files', 'array');
				
		$post = JRequest::get('post');
		$gameid = $post['gameid'];
		$seasonid = JFactory::getApplication()->input->post->get('seasonid', '', 'int');
		$hteamid = JFactory::getApplication()->input->post->get('hteamid', '', 'int');
		$vteamid = JFactory::getApplication()->input->get('vteamid', '', 'int');
		$hplayerids = JRequest::getVar('hplayerid', '', 'post', 'array');
		$vplayerids = JRequest::getVar('vplayerid', '', 'post', 'array');
		/* $gs value, if checked, will be the value of the player ID otherwise a non-checked game start checkbox will not pass a value messing up the order of the data array; */
		$hgamestart = JRequest::getVar('hgs', '', 'post', 'array');
		$vgamestart = JRequest::getVar('vgs', '', 'post', 'array');
		
		//$filename_home = JFile::makeSafe($file_home['tmp_name']);
		//$filename_visiting = JFile::makeSafe($file_visiting['tmp_name']);
		
		//print_r($file_home);
		if($file_home['tmp_name']!='')
		{
		if (($handle = fopen($file_home['tmp_name'], "r")) !== FALSE) 
		{
		//echo "hiiiiiiiiiiiiii";
		$i=0;
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) 
			{
						
			  $i++;
			  if($i!=1)
			  {
			  	
				$player_number=$data[0];
				$fname=$data[1];
				$lname=$data[2];
				$fgm=$data[9];
				$fgm=$data[9];
				$fga=$data[10];
				$ftm=$data[12];
				$fta=$data[13];
				$oreb=$data[16];
				$total_points=$data[15];
				$total_rebounds=$data[18];
				$oreb=$data[16];
				$dreb=$data[17];
				$turnovers=$data[19];
				$ast=$data[21];
				$stl=$data[20];
				$blk=$data[23];
				$fouls=$data[22];
				$playing_time=$data[24];
				
				$threepm=$data[6];
				$threepa=$data[7];
				
							
				$sql_player="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$hteamid."' ";
				$res_player=$db->setQuery($sql_player);
				$result=$db->loadObjectList();
				$num_rows=count($result);
				if($num_rows==0)
				{
				
					
					$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$hteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
					$db->setQuery($sql_ins_player);
					$db->query();
					$auto_id = $db->insertid();
					
					$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
					$db->setQuery($sql_update);
					$db->query();
					
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
					$db->setQuery($sql_boxscore);
					$db->query();
					
				
				}
				else
				{
				
					$sql_jno="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$hteamid."' AND LOWER(`fname`) = LOWER('".$fname."') AND  LOWER(`lname`) = LOWER('".$lname."')";
					$res_jno=$db->setQuery($sql_jno);
					$result_jno=$db->loadObjectList();
					$numrows_jno=count($result_jno);
					if($numrows_jno==0)
					{
					$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$hteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
					$db->setQuery($sql_ins_player);
					$db->query();
					$auto_id = $db->insertid();
					
					$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
					$db->setQuery($sql_update);
					$db->query();
					
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
					$db->setQuery($sql_boxscore);
					$db->query();
					}
					
					else
					{
					$query = "DELETE FROM #__fullcourt_boxscore WHERE playerid='".$result_jno[0]->playerid."'  AND gameid='".$gameid."'";
				$db->setQuery($query);
				$db->query();
				
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore 			(gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) 
				VALUES ('".$gameid."','".$result_jno[0]->playerid."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','','','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
					
					}
				
				
				
				
				
				/*$query = "DELETE FROM #__fullcourt_boxscore WHERE playerid='".$result[0]->playerid."'  AND gameid='".$gameid."'";
				$db->setQuery($query);
				$db->query();
				
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore 			(gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) 
				VALUES ('".$gameid."','".$result[0]->playerid."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','','','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();*/
				
				
				}
				
			}	
			}	

		}	
		
		}
		else
		{
			$query = "DELETE FROM #__fullcourt_boxscore WHERE (gameid = {$gameid}  AND teamid={$hteamid})";
			$db->setQuery($query);
			$db->query();
		
			for ($i = 0; $i < sizeof($hplayerids); $i++) {
			$playerid = $hplayerids[$i];
			if ($playerid > 0) {
				$pos = JArrayHelper::getValue($post['hpos'], $i, 0, 'string');
				$min = JArrayHelper::getValue($post['hmin'], $i, 0, 'int');
				$fgm = JArrayHelper::getValue($post['hfgm'], $i, 0, 'int');
				$fga = JArrayHelper::getValue($post['hfga'], $i, 0, 'int');
				$threepm = JArrayHelper::getValue($post['hthreepm'], $i, 0, 'int');
				$threepa = JArrayHelper::getValue($post['hthreepa'], $i, 0, 'int');
				$ftm = JArrayHelper::getValue($post['hftm'], $i, 0, 'int');
				$fta = JArrayHelper::getValue($post['hfta'], $i, 0, 'int');
				$oreb = JArrayHelper::getValue($post['horeb'], $i, 0, 'int');
				$dreb = JArrayHelper::getValue($post['hdreb'], $i, 0, 'int');
				$ast = JArrayHelper::getValue($post['hast'], $i, 0, 'int');
				$stl = JArrayHelper::getValue($post['hstl'], $i, 0, 'int');
				$blk = JArrayHelper::getValue($post['hblk'], $i, 0, 'int');
				$to = JArrayHelper::getValue($post['hto'], $i, 0, 'int');
				$pf = JArrayHelper::getValue($post['hpf'], $i, 0, 'int');
				$pts = JArrayHelper::getValue($post['hpts'], $i, 0, 'int');

				/* default the game start to 0 and then check for the player id to be in the gamestart array(); */
				$gs = 0;
				//Commented By Ajay
				//if (in_array($playerid, $hgamestart)) {
					$gs = 1;
				//}//Commented By Ajay

				if ($gs || $pos || $min || $fgm || $fga || $threepm || $threepa || $ftm || $fta || $oreb || $dreb || $ast || $stl || $blk || $to || $pf) {
					$query = "INSERT INTO #__fullcourt_boxscore (gameid, playerid, teamid, seasonid, gs, pos, min, fgm, fga, threepm, threepa, ftm, fta, oreb, dreb, ast, stl, blk, turnovers, pf, pts) VALUES ('{$gameid}', '{$playerid}', '{$hteamid}', '{$seasonid}',
					'{$gs}', '{$pos}', '{$min}', '{$fgm}', '{$fga}', '{$threepm}', '{$threepa}', '{$ftm}', '{$fta}', '{$oreb}', '{$dreb}', '{$ast}', '{$stl}', '{$blk}', '{$to}', '{$pf}', '{$pts}')";
					$db->setQuery($query);
					$db->query();
				}
			}
		}

		
		
		}
		
		//die;
		
		if($file_visiting['tmp_name']!='')
		{
		
		if (($handle = fopen($file_visiting['tmp_name'], "r")) !== FALSE) 
		{
		//echo "hiiiiiiiiiiiiii";
		$i=0;
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) 
			{
						
			  $i++;
			  if($i!=1)
			  {
			  	
				$player_number=$data[0];
				$fname=$data[1];
				$lname=$data[2];
				$fgm=$data[9];
				$fgm=$data[9];
				$fga=$data[10];
				$ftm=$data[12];
				$fta=$data[13];
				$oreb=$data[16];
				$total_points=$data[15];
				$total_rebounds=$data[18];
				$oreb=$data[16];
				$dreb=$data[17];
				$turnovers=$data[19];
				$ast=$data[21];
				$stl=$data[20];
				$blk=$data[23];
				$fouls=$data[22];
				$playing_time=$data[24];
				
				$threepm=$data[6];
				$threepa=$data[7];
				
				$sql_player="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$vteamid."'";
				$res_player=$db->setQuery($sql_player);
				$result=$db->loadObjectList();
				$num_rows=count($result);
				if($num_rows==0)
				{
				$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$vteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
				$db->setQuery($sql_ins_player);
				$db->query();
				$auto_id = $db->insertid();
				
				$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
				$db->setQuery($sql_update);
				$db->query();
				
								
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				
				}
				else
				{
					$sql_jno="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$vteamid."' AND LOWER(`fname`) = LOWER('".$fname."') AND  LOWER(`lname`) = LOWER('".$lname."')";
					$res_jno=$db->setQuery($sql_jno);
					$result_jno=$db->loadObjectList();
					$numrows_jno=count($result_jno);
					if($numrows_jno==0)
					{
					$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$vteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
					$db->setQuery($sql_ins_player);
					$db->query();
					$auto_id = $db->insertid();
					
					$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
					$db->setQuery($sql_update);
					$db->query();
					
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
					$db->setQuery($sql_boxscore);
					$db->query();
					}
					
					else
					{
				
				$query = "DELETE FROM #__fullcourt_boxscore WHERE playerid='".$result[0]->playerid."' AND gameid='".$gameid."'";
				$db->setQuery($query);
				$db->query();
				
			$sql_boxscore="INSERT INTO #__fullcourt_boxscore 			(gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) 
				VALUES ('".$gameid."','".$result[0]->playerid."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','','','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				}
				
				}
				
			}	
			}	

		}	
		}
		else	
		{	
		//die;
		//Commented By Ajay
		/* remove the old box score stats for this game - will re-add them next; */
		/*$query = "DELETE FROM #__fullcourt_boxscore WHERE (gameid = {$gameid} AND teamid={$vteamid}) ";
		$db->setQuery($query);
		$db->query();*/
			//Commented By Ajay

		/* save the home team stats; */
		
		/* save the opposing team stats; */
		for ($i = 0; $i < sizeof($vplayerids); $i++) {
			$playerid = $vplayerids[$i];
			if ($playerid > 0) {
				$pos = JArrayHelper::getValue($post['vpos'], $i, 0, 'string');
				$min = JArrayHelper::getValue($post['vmin'], $i, 0, 'int');
				$fgm = JArrayHelper::getValue($post['vfgm'], $i, 0, 'int');
				$fga = JArrayHelper::getValue($post['vfga'], $i, 0, 'int');
				$threepm = JArrayHelper::getValue($post['vthreepm'], $i, 0, 'int');
				$threepa = JArrayHelper::getValue($post['vthreepa'], $i, 0, 'int');
				$ftm = JArrayHelper::getValue($post['vftm'], $i, 0, 'int');
				$fta = JArrayHelper::getValue($post['vfta'], $i, 0, 'int');
				$oreb = JArrayHelper::getValue($post['voreb'], $i, 0, 'int');
				$dreb = JArrayHelper::getValue($post['vdreb'], $i, 0, 'int');
				$ast = JArrayHelper::getValue($post['vast'], $i, 0, 'int');
				$stl = JArrayHelper::getValue($post['vstl'], $i, 0, 'int');
				$blk = JArrayHelper::getValue($post['vblk'], $i, 0, 'int');
				$to = JArrayHelper::getValue($post['vto'], $i, 0, 'int');
				$pf = JArrayHelper::getValue($post['vpf'], $i, 0, 'int');
				$pts = JArrayHelper::getValue($post['vpts'], $i, 0, 'int');

				/* default the game start to 0 and then check for the player id to be in the gamestart array(); */
				$gs = 0;
				if (in_array($playerid, $vgamestart)) {
					$gs = 1;
				}
//Commented By Ajay
				//if ($gs || $pos || $min || $fgm || $fga || $threepm || $threepa || $ftm || $fta || $oreb || $dreb || $ast || $stl || $blk || $to || $pf) 
				//{
					
					/*$query = "INSERT INTO #__fullcourt_boxscore (gameid, playerid, teamid, seasonid, gs, pos, min, fgm, fga, threepm, threepa, ftm, fta, oreb, dreb, ast, stl, blk, turnovers, pf, pts) VALUES ('{$gameid}', '{$playerid}', '{$vteamid}', '{$seasonid}',
					'{$gs}', '{$pos}', '{$min}', '{$fgm}', '{$fga}', '{$threepm}', '{$threepa}', '{$ftm}', '{$fta}', '{$oreb}', '{$dreb}', '{$ast}', '{$stl}', '{$blk}', '{$to}', '{$pf}', '{$pts}')";
					$db->setQuery($query);
					$db->query();*/
				//}
				//Commented By Ajay
			}
		}
		
		}
		
		//die;

		return true;
	}


}



?>
