<?php
/**
 * @version $Id: v1.7.3 August 2012 01:32:15
 * @author Fastball Productions
 * @package com_fullcourt
 * @copyright Copyright (C) 2009-2017 Fastball Productions
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

/* no direct access; */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class FullcourtModelDivision extends JModelLegacy {

	function orderUp() {
		$db = $this->getDBO();

		$cids = JRequest::getVar('cid', null, 'default', 'array');
		$id = (int)$cids[0];

		$row =  JTable::getInstance('division', 'Table');
		$row->load($id);

		if (!$row->move(-1, "ordering < $row->ordering")) {
			$this->setError($db->getErrorMsg());
			return false;
		}
		return true;
	}

	function orderDown() {
		$db = $this->getDBO();

		$cids = JRequest::getVar('cid', null, 'default', 'array');
		$id = (int)$cids[0];

		$row =  JTable::getInstance('division', 'Table');
		$row->load($id);

		if (!$row->move(1, "ordering > $row->ordering")) {
			$this->setError($db->getErrorMsg());
			return false;
		}
		return true;
	}

	function getDivision($id) {
		$db = $this->getDBO();

		$row =  JTable::getInstance('division', 'Table');
		$row->load($id);

		if ($row === null) {
			JError::raiseError( 500, 'Revue [' .$id.'] not found.' );
		}
		else {
			return $row;
		}
	}

	function getNewDivision()	{
		$division =  $this->getTable('division');
		$division->id = 0;
		$division->published = 1;
		return $division;
	}

	function saveDivision() {
		$db = $this->getDBO();

		$table =  $this->getTable();
		$post = JRequest::get('post');

		/* get the next sorting order (ordering) value for this record if it's a new entry; */
		if (!$post['id']) {
			$nextorder = $table->getNextOrder();
			$post['ordering'] = $nextorder;
		}

		if(!$table->bind($post)) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->check()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		return true;
	}
}

?>