<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FullcourtModelGametypes extends JModelLegacy {
	var $_gametypes;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		$app = JFactory::getApplication();
		$option = JRequest::getCmd('option');
		parent::__construct();
		$limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'));
		$limitstart = $app->getUserStateFromRequest($option.'limitstart', 'limitstart', 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getGametypes() {
		$db  =  $this->getDBO();
		$limitstart = $this->getState('limitstart');
		$limit = $this->getState('limit');
		$query = "SELECT * FROM #__fullcourt_gametype";
		$this->_gametypes = $this->_getList($query, $limitstart, $limit);
		$this->_total = $this->_getListCount($query);
		if(empty($this->_gametypes) && $this->_total > 0){
			$this->_gametypes = $this->_getList($query, 0, $limit);
		}
		return $this->_gametypes;
	}

	function delete($cids) {
		$db = $this->getDBO();
		$table = $db->quoteName('#__fullcourt_gametype');
		$id = $db->quoteName('id');
		$query = "DELETE FROM " . $table . " WHERE " . $id . "IN (" . implode( ',', $cids ) . ")";
		$db->setQuery( $query );

		if(!$db->query()) {
			$errorMessage = $this->getDBO()->getErrorMsg();
			JError::raiseError( 500, 'Error deleting game types: ' . $errorMessage );
		}
	}

	function publish() {
		$db  =  $this->getDBO();
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		$task = JRequest::getVar( 'task', '', 'default', 'default' );
		if ($task == 'gametypepublish') {
			$publish = 1;
		}
		else {
			$publish = 0;
		}
		$table =  JTable::getInstance('gametype', 'Table');
		$table->publish($cid, $publish);
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$total = $this->_total;
			$limitstart = $this->getState('limitstart');
			$limit = $this->getState('limit');
			$this->_pagination = new JPagination($total, $limitstart, $limit);
		}
		return $this->_pagination;
	}
}

?>