<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class FullcourtModelLeague extends JModelLegacy {

	function orderUp() {
		$db = $this->getDBO();

		$cids = JRequest::getVar('cid', null, 'default', 'array');
		$id = (int)$cids[0];

		$row =  JTable::getInstance('league', 'Table');
		$row->load($id);

		if (!$row->move(-1, "ordering < $row->ordering")) {
			$this->setError($db->getErrorMsg());
			return false;
		}
		return true;
	}

	function orderDown() {
		$db = $this->getDBO();

		$cids = JRequest::getVar('cid', null, 'default', 'array');
		$id = (int)$cids[0];

		$row =  JTable::getInstance('league', 'Table');
		$row->load($id);

		if (!$row->move(1, "ordering > $row->ordering")) {
			$this->setError($db->getErrorMsg());
			return false;
		}
		return true;
	}

	function getLeague($id) {
		$db = $this->getDBO();

		$row =  JTable::getInstance('league', 'Table');
		$row->load($id);

		if ($row === null) {
			JError::raiseError( 500, 'Revue [' .$id.'] not found.' );
		}
		else {
			return $row;
		}
	}

	function getNewLeague()	{
		$league =  $this->getTable('league');
		$league->id = 0;
		$league->published = 1;
		return $league;
	}

	function saveLeague() {
		$db = $this->getDBO();

		$table =  $this->getTable();
		$post = JRequest::get('post');

		/* make sure the league description field can allow Raw data; */
		$post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);

		$isdefault = JFactory::getApplication()->input->post->get('isdefault', 0, 'int');
		if ($isdefault) {
			$db->setQuery("UPDATE #__fullcourt_league SET isdefault = 0 WHERE isdefault = 1");
			$db->query();
		}

		/* get the next sorting order (ordering) value for this record if it's a new entry; */
		if (!$post['id']) {
			$nextorder = $table->getNextOrder();
			$post['ordering'] = $nextorder;
		}

		if(!$table->bind($post)) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->check()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		return true;
	}
}

?>