<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FullcourtModelSeason extends JModelLegacy {

	function getSeason($id) {
		$db = $this->getDBO();

		$row =  JTable::getInstance('season', 'Table');
		$row->load($id);

		if ($row === null) {
			JError::raiseError(500, 'Season [' . $id .'] not found.');
		}
		else {
			return $row;
		}
	}

	function getNewSeason()	{
		$row =  $this->getTable('season');
		$row->id = 0;
		$row->published = 1;
		return $row;
	}

	function saveSeason() {
		$db = $this->getDBO();

		$isdefault = JRequest::getVar('isdefault', 0, 'post', 'int');
		if ($isdefault) {
			$db->setQuery("UPDATE #__fullcourt_season SET isdefault = 0 WHERE isdefault = 1");
			$db->query();
		}

		$table =  $this->getTable();
		$post = JRequest::get('post');

		/* make sure the table buffer is empty; */
		$table->reset();

		if (!$table->bind($post)) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if (!$table->check()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if (!$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		return true;
	}
}

?>