<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FullcourtModelTeam extends JModelLegacy {
	var $_team = null;
	var $_leagueid = null;
	var $_divisionid = null;
	var $_leagues = null;
	var $_divisions = null;
	var $_users = null;

	function getTeam($id) {
		$db = $this->getDBO();

		$row =  JTable::getInstance('team', 'Table');
		$row->load($id);

		if ($row === null) {
			JError::raiseError(500, 'Team [' . $id .'] not found.');
		}
		else {
			$this->_leagueid = $row->leagueid;
			$this->_divisionid = $row->divisionid;
			$this->_team = $row;
			return $row;
		}
	}

	function getNewTeam() {
		$db = $this->getDBO();
		$row =  $this->getTable('team');
		$row->id = 0;

		/* get the default league if one exists; */
		$db->setQuery("SELECT id AS defaultleague FROM #__fullcourt_league WHERE (isdefault = 1)");
		$default = $db->loadResult();
		$row->published = 1;
		$row->defaultteam = 1;
		if(!$default){
			$default = 1;
		}
		$row->leagueid = $default;

		$this->_team = $row;
		$this->_leagueid = $row->leagueid;
		$this->_divisionid = 0;

		return $row;
	}

	function getLeagues() {
		$this->_leagues = getLeaguesAsSelectListAjax('leagueid', $this->_leagueid);
		return $this->_leagues;
	}

	function getDivisions() {
	
		$this->_divisions = getDivisionsAsSelectList($this->_leagueid, 'divisionid', $this->_divisionid);
		return $this->_divisions;
	}

	function getUsers() {
		$db = $this->getDBO();
		/* get a list of all Joomla users so that front-end admins can be configured; */
		$adminids = explode(',', $this->_team->adminids);
		foreach ($adminids as $id) {
			$obj = new stdClass();
			$obj->value = $id;
			$selected[] = $obj;
		}

		$db->setQuery("SELECT u.id AS value, CONCAT(u.username, ' [', u.name, ']') AS text FROM #__users As u ORDER BY u.username ASC");
		$users = $db->loadObjectList();

		$list[] = JHTML::_('select.option',  '0', JText::_( '- choose front-end admins -' ), 'value', 'text' );
		$list = array_merge($list, $users);
		$this->_users = JHTML::_('select.genericlist', $list, 'admins[]', 'class="inputbox" size="10" multiple', 'value', 'text', $selected);
		return $this->_users;
	}

	function saveTeam() {
		$db = $this->getDBO();

		$table =  $this->getTable();
		$post = JRequest::get('post');

		/* make sure the accomplishments field can allow Raw data; */
		$post['accomplishments'] = JRequest::getVar('accomplishments', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if(!$table->bind($post)) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->check()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if( !$table->store()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		/* check if file was uploaded and process accordingly; */
		if (!$table->fileCheck()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		/* store the team logo and team photo if uploaded; */
		if (!$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		return true;
	}
}

?>