<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FullcourtModelPlayer extends JModelLegacy {
	var $_player = null;

	function getPlayer($id) {
		$db = $this->getDBO();

		$row =  JTable::getInstance('player', 'Table');
		$row->load($id);

		if ($row === null) {
			JError::raiseError(500, 'Player [' . $id .'] not found.');
		}
		else {
			$row->clone = 0;
			$this->_player = $row;
			return $this->_player;
		}
	}

	function getNewPlayer()	{
		$row =  $this->getTable('player');
		$row->id = 0;
		$row->active = 1;
		$row->published = 1;
		$row->clone = 0;
		$this->_player = $row;
		return $this->_player;
	}

	function savePlayer() {
		$db = $this->getDBO();

		$table =  $this->getTable();
		$post = JRequest::get('post');

		/* make sure the player experience field can allow Raw data; */
		$post['experience'] = JRequest::getVar('experience', '', 'post', 'string', JREQUEST_ALLOWRAW);

		/* make sure the table buffer is empty; */
		$table->reset();

		if (!$table->bind($post)) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if (!$table->check()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		if (!$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		/* set the player id to the record id - needed for assigning players to multiple teams; */
		$table->playerid = $table->id;

		/* check if file was uploaded and process accordingly; */
		if (!$table->fileCheck()) {
			$this->setError( $this->_db->getErrorMsg());
			return false;
		}

		/* store the player photo if uploaded; */
		if (!$table->store()) {
			$this->setError( $table->getErrorMsg());
			return false;
		}

		return true;
	}
}

?>