<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

class TableLocation extends JTable {
	var	$id = null;
	var $name = null;
	var $address = null;
	var $city = null;
	var $state = null;
	var $zipcode = null;
	var $country = null;
	var $fieldnames	= null;
	var $extrainfo = null;
	var $checked_out = null;
	var $checked_out_time = null;
	var $published = null;

	function __construct(&$db) {
		parent::__construct( '#__fullcourt_location', 'id', $db );
	}

	function check() {
		$this->state = strtoupper($this->state);
		// check for individual field names or labels to be listed
		$arr = $this->fieldnames;
		$fields = array();
		foreach ($arr as $a) {
			if (trim($a)) {
				$fields[] = stripslashes($a);
			}
		}
		if (is_array($fields) && sizeof($fields) > 0) {
			$this->fieldnames = serialize($fields);
		}
		else {
			$this->fieldnames = '';
		}
		return true;
	}
}
?>