<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

class TablePlayer extends JTable {
	var	$id = null;
	var	$active = null;
	var $playerid = null;
	var	$teamid = null;
	var $fname = null;
	var $mname = null;
	var $lname = null;
	var $positions = null;
	var $jerseyhome = null;
	var $jerseyaway = null;
	var $birthdate = null;
	var $heightfeet = null;
	var $heightinches = null;
	var $weight = null;
	var $weightuom = null;
	var $hometown = null;
	var $photo = null;
	var $cphone = null;
	var $cmobile = null;
	var $email = null;
	var $experience = null;
	var $checked_out = null;
	var $checked_out_time = null;
	var $published = null;
	var $custom1 = null;
	var $custom2 = null;

	function __construct(&$db) {
		parent::__construct( '#__fullcourt_player', 'id', $db );
	}

	function check() {
		$params = JComponentHelper::getParams('com_fullcourt');

		// set the away jersey number to the home jersey number;
		if (!$this->jerseyaway) {
			$this->jerseyaway = $this->jerseyhome;
		}

		/* set the player's offensive, defensive, special teams positions; */
		$positions = $this->positions;
		if (is_array($positions) && sizeof($positions) > 0) {
			$this->positions = implode(', ', $positions);
		}

		// convert the birthday fields to a true date format;
		$bmonth = JFactory::getApplication()->input->get('bmonth', '');
		$bday = JFactory::getApplication()->input->get('bday', '');
		$byear = JFactory::getApplication()->input->get('byear', '');

		!$bmonth ? $bmonth = '00':$bmonth;
		!$bday ? $bday = '00':$bday;
		!$byear ? $byear = '0000':$byear;

		$this->birthdate = $byear . '-' . $bmonth . '-' . $bday;

		// check if the user wants to delete the player photo if it exists;
		$removefile = JFactory::getApplication()->input->get('removephoto', 0);
		if ($removefile) {
			unlink(JPATH_CONFIGURATION . DS . $params->get('images_path') . $this->photo);
			$this->photo = '';
		}

		return true;
	}

	function fileCheck() {
		$params = JComponentHelper::getParams('com_fullcourt');

		$clone = JFactory::getApplication()->input->get('clone', 0);
		$photo = JFactory::getApplication()->input->post->get('photo', '', 'default');

		// initialize an error flag to be set if file upload did not succeed;
		$error = true;
		// check if a file was selected to upload;
		if (isset($_FILES['photo']) && $_FILES['photo']['name'] != "") {
		// OST Changes to upload png
			$extension = pathinfo($_FILES["photo"]["name"]);
			$ext = ".".$extension['extension'];
			$filename = 'p' . $this->teamid . '_' . $this->id . $ext;
			if ($this->_error = (processImage($_FILES['photo'], $filename, 150, 200))) {
				$error = $this->_error;
			}
			else {
				$this->photo = $filename;
			}
		}

		/* check if the player was assigned to a different team, if so, change the name of their profile photo and delete the old one; */
		if ($clone == 0) {
			$filename = 'p' . $this->teamid . '_' . $this->id . $ext;
			if ($this->photo != $filename) {
				copy(JPATH_CONFIGURATION . DS . $params->get('images_path') . $this->photo, JPATH_CONFIGURATION . DS . $params->get('images_path') . $filename);
				unlink(JPATH_CONFIGURATION . DS . $params->get('images_path') . $this->photo);
				$this->photo = $filename;
			}
		}

		/* check to see if this player is being cloned, if so, copy their photo to use for the new clone as well; */
		if ($clone) {
			$filename = 'p' . $this->teamid . '_' . $this->playerid . $ext;
			@copy(JPATH_CONFIGURATION . DS . $params->get('images_path') . $photo, JPATH_CONFIGURATION . DS . $params->get('images_path') . $filename);
			$this->photo = $filename;
		}
		return $error;
	}
}

?>