<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @subpackage components
* @link http://www.fastballproductions.com
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

class TableTeam extends JTable {
	var	$id = null;
	var	$leagueid = null;
	var	$divisionid = null;
	var $defaultteam = null;
	var $name = null;
	var $shortname = null;
	var $city = null;
	var $state = null;
	var $adminids = null;
	var $mname = null;
	var $mphone = null;
	var $mmobile = null;
	var $memail = null;
	var $mtshow = null;
	var $mrshow = null;
	var $m1name = null;
	var $m1phone = null;
	var $m1mobile = null;
	var $m1email = null;
	var $ctshow = null;
	var $crshow = null;
	var $m2name = null;
	var $m2phone = null;
	var $m2mobile = null;
	var $m2email = null;
	var $logo = null;
	var $photo = null;
	var $accomplishments = null;
	var $checked_out = null;
	var $checked_out_time = null;
	var $published = null;
	var $facebook = null;
	var $website = null;
	var $mediateam = null;
	var $mediaroster = null;
	var $mediaschedule = null;
	var $ordering = null;

	function __construct(&$db) {
		parent::__construct( '#__fullcourt_team', 'id', $db );
	}

	function check() {
		$params = JComponentHelper::getParams('com_fullcourt');

		// check if the user wants to delete the team photo if it exists;
		$removefile = JFactory::getApplication()->input->get('removelogo', 0);
		if ($removefile) {
			unlink(JPATH_CONFIGURATION . DS . $params->get('images_path') . $this->logo);
			$this->logo = '';
		}

		// check if the user wants to delete the team photo if it exists;
		$removefile = JFactory::getApplication()->input->get('removephoto', 0);
		if ($removefile) {
			unlink(JPATH_CONFIGURATION . DS . $params->get('images_path') . $this->photo);
			$this->photo = '';
		}

		// remove any spaces from the admin ID's field;
		$admins = JFactory::getApplication()->input->get('admins', NULL,NULL);
	
		if ($admins != '') {
			if(is_array($admins)){
					$adminids = implode(',', $admins);
					$this->adminids = $adminids;
			}	else {
				$this->adminids = $admins;
			}	
			
		}
	

		if (!$this->mediateam) {
			$this->mediateam = 0;
		}
		if (!$this->mediaroster) {
			$this->mediaroster = 0;
		}
		if (!$this->mediaschedule) {
			$this->mediaschedule = 0;
		}

		return true;
	}

	function fileCheck() {
		// initialize an error flag to be set if file upload did not succeed;
		$error = true;
		// check if a team logo was uploaded;
		if (isset($_FILES['logo']) && $_FILES['logo']['name'] != "") {
		// OST Changes to upload png
			$extension = pathinfo($_FILES["logo"]["name"]);
			$ext = $extension['extension'];
			//$filename = 'l' . $this->id;
			//$filename = 'l' . $this->id . $ext;
			$filename = str_shuffle(time().substr($_FILES["logo"]["name"],0,(strrpos($_FILES["logo"]["name"], ".") > 10) ? 10 : strrpos($_FILES["logo"]["name"], "."))).'.'.$ext;
			if ($this->_error = (processImage($_FILES['logo'], $filename, 75, 75))) {
				$error = $this->_error;
			}
			else {
				$this->logo = $filename;
			}
		}

		// check if a team photo was uploaded;
		if (isset($_FILES['photo']) && $_FILES['photo']['name'] != "") {
			//$filename = 't' . $this->id;
			// OST Changes to upload png
			$extension = pathinfo($_FILES["photo"]["name"]);
			
			$ext = $extension['extension'];
			
			//$filename = 'l' . $this->id;
			//$filename = 'l' . $this->id . $ext;
			$filename = str_shuffle(time().substr($_FILES["photo"]["name"],0,(strrpos($_FILES["photo"]["name"], ".") > 10) ? 10 : strrpos($_FILES["photo"]["name"], "."))).'.'.$ext;
			if ($this->_error = (processImage($_FILES['photo'], $filename, 288, 216))) {
				$error = $this->_error;
			}
			else {
				$this->photo = $filename;
			}
		}
		return $error;
	}
}
?>