<?php
/**
* @version $Id: v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class FullcourtViewLeagues extends JViewLegacy	{
	protected $state;
	function display($tpl = null)	{
		$this->state = $this->get('State');
		$app = JFactory::getApplication();
		$option = JRequest::getCmd('option');
		$this->addToolbar();
		JToolBarHelper::title( JText::_('COM_FULLCOURT_TITLE_LEAGUES'), 'generic.png');
		/*JToolBarHelper::publishList('leaguepublish');
		JToolBarHelper::unpublishList('leagueunpublish');
		JToolBarHelper::deleteList(JText::_('COM_FULLCOURT_TITLE_REMOVE_LEAGUES'), 'removeleagues');
		JToolBarHelper::editListX('editleague');
		JToolBarHelper::addNewX('newleague');
		JToolBarHelper::preferences('com_fullcourt', '580');*/

		$pagination =  $this->get( 'Pagination' );

		$lists = array();
		$filter_order = $app->getUserStateFromRequest($option . 'filter_order', 'filter_order', 'published');
		$filter_order_Dir = $app->getUserStateFromRequest($option . 'filter_order_Dir', 'filter_order_Dir', 'ASC');
		$lists['order'] = $filter_order;
		$lists['order_Dir'] = $filter_order_Dir;

		/* get the leagues from the model; */
		$model  =  $this->getModel('leagues');
		$leagues =  $model->getLeagues();
		$page =  $model->getPagination();
		$divisions =  $model->getDivisions();

		$this->assignRef('leagues', $leagues);
		$this->assignRef('divisions', $divisions);
		$this->assignRef('pagination', $pagination);

		/* pagination assignments; */
		$this->assignRef('lists', $lists);
		$this->assignRef('page', $page);

		parent::display($tpl);
	}
	
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/fullcourt.php';
		$canDo	= FullCourtHelper::getActions($this->state->get('filter.category_id'));
		$user	= JFactory::getUser();
		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');

		//JToolBarHelper::title( JText::_('com_fullcourt_TITLE_LEAGUES'), 'generic.png');

		if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_fullcourt', 'core.create'))) > 0)
		{
			JToolbarHelper::addNew('newleague');
		}

		if (($canDo->get('core.edit')) || ($canDo->get('core.edit.own')))
		{
			JToolbarHelper::editList('editleague');
		}

		if ($canDo->get('core.edit.state'))
		{
			JToolbarHelper::publish('leaguepublish', 'JTOOLBAR_PUBLISH', true);
			JToolbarHelper::unpublish('leagueunpublish', 'JTOOLBAR_UNPUBLISH', true);			
		}

		if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList('', 'leagues.delete', 'JTOOLBAR_EMPTY_TRASH');
		}
		elseif ($canDo->get('core.edit.state'))
		{
			JToolbarHelper::trash('removeleagues');
		}

		if ($canDo->get('core.admin'))
		{
			JToolbarHelper::preferences('com_fullcourt');
		}

		//JHtmlSidebar::setAction('index.php?option=com_fullcourt');


	}

}

?>