<?php
/**
* @version $Id: v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class FullcourtViewPlayer extends JViewLegacy {

	function add() {
		$params = JComponentHelper::getParams('com_fullcourt');

		JToolBarHelper::title(JText::_('COM_FULLCOURT_TITLE_PLAYER_MANAGEMENT') . ': [ <small>' . JText::_('COM_FULLCOURT_TITLE_ADD') . '</small> ]');
		
		JToolBarHelper::save2new('saveplayer2new');
		JToolBarHelper::save('saveplayer');
		JToolBarHelper::cancel('cancelplayer');
		 JToolBarHelper::preferences('com_fullcourt', '580');

		$lists = array();

		$model =  $this->getModel();
		$player = $model->getNewPlayer();

		$lists['teams'] = getTeamsAsSelectListLong('teamid', $player->teamid);
		$lists['positions'] = getPositionsAsSelectList('positions', $player->positions);
		$lists['birthdate'] = getDateAsSelectList('bmonth', 'bday', 'byear', $player->birthdate);

		$this->assignRef('player', $player);
		$this->assignRef('lists', $lists);
		$this->assignRef('params', $params);

		parent::display();
	}

	function edit($id) {
		$params = JComponentHelper::getParams('com_fullcourt');

		JToolBarHelper::title(JText::_('COM_FULLCOURT_TITLE_PLAYER_MANAGEMENT') . ': [ <small>' . JText::_('COM_FULLCOURT_TITLE_EDIT') . '</small> ]');
		
		JToolBarHelper::save2new('saveplayer2new');
		JToolBarHelper::save('saveplayer');
		JToolBarHelper::cancel('cancelplayer', JText::_('COM_FULLCOURT_TITLE_CLOSE'));
 		JToolBarHelper::preferences('com_fullcourt', '580');
		$lists = array();

		$model =  $this->getModel();
		$player = $model->getPlayer($id);

		$lists['teams'] = getTeamsAsSelectListLong('teamid', $player->teamid);
		$lists['positions'] = getPositionsAsSelectList('positions', $player->positions);
		$lists['birthdate'] = getDateAsSelectList('bmonth', 'bday', 'byear', $player->birthdate);

		$this->assignRef('player', $player);
		$this->assignRef('lists', $lists);
		$this->assignRef('params', $params);

		parent::display();
	}

	function cloneplayer($id) {
		$params = JComponentHelper::getParams('com_fullcourt');

		JToolBarHelper::title(JText::_('COM_FULLCOURT_TITLE_PLAYER_MANAGEMENT') . ': [ <small>' . JText::_('COM_FULLCOURT_TITLE_CLONE') . '</small> ]');
		JToolBarHelper::save('saveplayer');
		JToolBarHelper::cancel('cancelplayer', JText::_('COM_FULLCOURT_TITLE_CLOSE'));
		JToolBarHelper::preferences('com_fullcourt', '580');

		$lists = array();

		$model =  $this->getModel();
		$player = $model->getPlayer($id);
	  	$player->clone = true;
	  	$player->id = 0;

		$lists['teams'] = getPlayerCloneTeams('teamid', 0, $player->playerid);
		$lists['positions'] = getPositionsAsSelectList('positions', $player->positions);
		$lists['birthdate'] = getDateAsSelectList('bmonth', 'bday', 'byear', $player->birthdate);

		$this->assignRef('player', $player);
		$this->assignRef('lists', $lists);
		$this->assignRef('params', $params);

		parent::display();
	}

}
?>
