<?php
/**
* @version $Id: v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/* no direct access; */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class FullcourtViewSchedule extends JViewLegacy {

	function add() {
		JToolBarHelper::title(JText::_('COM_FULLCOURT_TITLE_SCHEDULE_MANAGEMENT') . ': [ <small>' . JText::_('COM_FULLCOURT_TITLE_ADD') . '</small> ]');
		
		JToolBarHelper::save2new('saveschedule2new');
		JToolBarHelper::save('saveschedule');
		JToolBarHelper::cancel('cancelschedule');
		 JToolBarHelper::preferences('com_fullcourt', '580');

		$model =  $this->getModel();
		$schedule = $model->getNewSchedule();

		$lists = array();
		$lists['seasons'] = getSeasonsAsSelectList('season[]', $schedule->season);
		$lists['hometeam'] = getTeamsAsSelectListLong('hometeam[]', $schedule->hometeam);
		$lists['visitingteam'] = getTeamsAsSelectListLong('visitingteam[]', $schedule->visitingteam);
		$lists['gametypes'] = getGameTypesAsSelectList('gametype[]', $schedule->gametype);
		$lists['locations'] = getLocationsAsSelectListAjax('location[]', $schedule->location);
		$lists['fields'] = getParkFieldsSelectList($schedule->location, 'field', $schedule->field);
		$lists['gamestatus'] = getGameStatusAsSelectList('status[]', $schedule->status);

		$this->assignRef('schedule', $schedule);
		$this->assignRef('lists', $lists);

		parent::display();
	}

	function edit($id) {
		JToolBarHelper::title(JText::_('FastBall Schedule Management') . ': [ <small>' . JText::_('COM_FULLCOURT_TITLE_EDIT') . '</small> ]');
		
		JToolBarHelper::save2new('saveschedule2new');
		JToolBarHelper::save('saveschedule');
		JToolBarHelper::cancel('cancelschedule', JText::_('COM_FULLCOURT_TITLE_CLOSE'));
		JToolBarHelper::preferences('com_fullcourt', '580');

		$model =  $this->getModel();
		$schedule = $model->getSchedule($id);

		$lists = array();
		$lists['seasons'] = getSeasonsAsSelectList('season', $schedule->season);
		$lists['hometeam'] = getTeamsAsSelectListLong('hometeam', $schedule->hometeam);
		$lists['visitingteam'] = getTeamsAsSelectListLong('visitingteam', $schedule->visitingteam);
		$lists['gametypes'] = getGameTypesAsSelectList('gametype', $schedule->gametype);
		$lists['locations'] = getLocationsAsSelectListAjax('location', $schedule->location);
		$lists['fields'] = getParkFieldsSelectList($schedule->location, 'field', $schedule->field);
		$lists['gamestatus'] = getGameStatusAsSelectList('status', $schedule->status);

		$this->assignRef('schedule', $schedule);
		$this->assignRef('lists', $lists);

		parent::display();
	}

}
?>
