<?php
/**
* @version $Id: controller.php, v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

/* include the SQL helper file for calculating season stats; */
require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_fullcourt' . DS . 'helpers' . DS . 'sql.php');

jimport( 'joomla.application.component.controller' );

class FullcourtController extends JControllerLegacy {

	/* default function; */
	public function display($cachable = false, $urlparams = false) {

		$document =  JFactory::getDocument();
		$viewName = JFactory::getApplication()->input->get('view', 'all');
		$layout = JFactory::getApplication()->input->get( 'layout', 'default' );
		$viewType = $document->getType();
		$view = $this->getView($viewName, $viewType, 'FullcourtView');
		$model =  $this->getModel( $viewName, 'ModelFullcourt' );

		if (!JError::isError( $model )) {
			$view->setModel( $model, true );
		}
		$view->setLayout($layout);
		$view->display();
	}

	/*
	 * this is a redirect function for the "all" or default layout with navigational component link;
	 * this was added to take care of the SEF URL's and the JRoute issue with the select lists and form post;
	 */
	function allredirect() {
		$team = JRequest::getInt('team', 0);
		$division = JRequest::getInt('division', 0);
		$league = JRequest::getInt('league', 0);
		$itemid = JRequest::getInt('itemid', 0);

		if ($league == 0) {
			$league = '';
		}

		if ($team) {
			$link = JRoute::_('index.php?option=com_fullcourt&view=team&id=' . $team . '&Itemid=' . $itemid, false);
		}
		else if ($division) {
			$link = JRoute::_('index.php?option=com_fullcourt&view=all&league=' . $league . '&division=' . $division . '&Itemid=' . $itemid, false);
		}
		else {
			$link = JRoute::_('index.php?option=com_fullcourt&view=all&league=' . $league . '&Itemid=' . $itemid, false);
		}

		$this->setRedirect($link);
	}

	function playerredirect() {
		$id = JFactory::getApplication()->input->get('id', '0', 'int');
		$season = JFactory::getApplication()->input->get('season', '0', int);
		$itemid = JFactory::getApplication()->input->get('itemid', '0', int);
		$link = JRoute::_('index.php?option=com_fullcourt&view=player&id=' . $id . '&season=' . $season . '&Itemid=' . $itemid, false);
		$this->setRedirect($link);
	}

	/* ------------- START FRONTEND ADMIN FUNCTIONS ------------- */
	function setAdminTeam() {
		$option = JRequest::getCmd('option');
		$id = JFactory::getApplication()->input->get('id','0');
		$session =  JFactory::getSession();
		$session->set('_teamid', $id);
		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=manage');
	}


	function saveTeam() {
		$option = JRequest::getCmd('option');

		$user = JFactory::getUser();
		$db =  JFactory::getDBO();

		$row =  JTable::getInstance('team', 'Table');

		$post = JRequest::get('post');

		/* make sure the accomplishments field can allow Raw data; */
		$post['accomplishments'] = JRequest::getVar('accomplishments', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if ($row->id == 0) {
			$row->defaultteam = 0;
			$row->adminids .= $user->id;
		}

		if( !$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		/* check if file was uploaded and process accordingly; */
		if (!$row->fileCheck()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		/* store the team logo and team photo if uploaded; */
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=manage', 'Team information updated and saved...');
	}

	function savePlayer() {
		$option = JRequest::getCmd('option');
		$user = JFactory::getUser();
		$db =  JFactory::getDBO();

		$post = JRequest::get('post');

		/* make sure the accomplishments field can allow Raw data; */
		$post['experience'] = JRequest::getVar('experience', '', 'post', 'string', JREQUEST_ALLOWRAW);

		$row =  JTable::getInstance('player', 'Table');
		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$session =  JFactory::getSession();
		$teamid = $session->get('_teamid');
		$row->teamid = $teamid;

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		/* set the player id to the record id - needed for assigning players to multiple teams; */
		$row->playerid = $row->id;

		/* check if player photo was uploaded and process accordingly; */
		if (!$row->fileCheck()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		/* store the player photo if uploaded; */
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=listroster', 'Player information updated and saved...');
	}

	function saveSchedule() {
		$option = JRequest::getCmd('option');
		$user = JFactory::getUser();
		$db =  JFactory::getDBO();

		$row =  JTable::getInstance('schedule', 'Table');
		if (!$row->bind(JRequest::get('post'))) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=listschedule', 'Game information updated and saved...');
	}

	function saveLocation() {
		$option = JRequest::getCmd('option');
		$user = JFactory::getUser();
		$db =  JFactory::getDBO();

		$row =  JTable::getInstance('location', 'Table');
		if (!$row->bind(JRequest::get('post'))) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=listlocations', 'Venue &amp Court details have been saved successfully...');
	}

	function saveGamestats() {
		$option = JRequest::getCmd('option');
		$this->saveLinescore();
		$this->savePlayerstatsFromCsv();
		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=listgamesplayed', 'Box score details saved...');
	}
	
	function savePlayerstatsFromCsv()
	{
	$db =  JFactory::getDBO();
	jimport('joomla.filesystem.file');
	$file_home = JRequest::getVar('home_team_stats', null, 'files', 'array');
	$file_visiting = JRequest::getVar('visiting_team_stats', null, 'files', 'array');
	$gameid = JFactory::getApplication()->input->post->get('gameid', '', 'int');
	$seasonid = JFactory::getApplication()->input->post->get('seasonid', '', 'int');
	
	$hteamid = JFactory::getApplication()->input->post->get('hteamid', '', 'int');
	$vteamid = JFactory::getApplication()->input->post->get('vteamid', '', 'int');
		
	if($file_home['tmp_name']!='')
	{
		if (($handle = fopen($file_home['tmp_name'], "r")) !== FALSE) 
		{
			$i=0;
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) 
			{
			  $i++;
			  if($i!=1)
			  {
			  	$player_number=$data[0];
				$fname=$data[1];
				$lname=$data[2];
				$fgm=$data[9];
				$fgm=$data[9];
				$fga=$data[10];
				$ftm=$data[12];
				$fta=$data[13];
				$oreb=$data[16];
				$total_points=$data[15];
				$total_rebounds=$data[18];
				$oreb=$data[16];
				$dreb=$data[17];
				$turnovers=$data[19];
				$ast=$data[21];
				$stl=$data[20];
				$blk=$data[23];
				$fouls=$data[22];
				$playing_time=$data[24];
				$threepm=$data[6];
				$threepa=$data[7];
				
				$sql_player="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$hteamid."'";;
				$res_player=$db->setQuery($sql_player);
				$result=$db->loadObjectList();
				$num_rows=count($result);
				if($num_rows==0)
				{
				$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$hteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
				$db->setQuery($sql_ins_player);
				$db->query();
				$auto_id = $db->insertid();
				
				$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
				$db->setQuery($sql_update);
				$db->query();
				
			$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				
				}
				else
				{
				
				$sql_jno="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$hteamid."' AND LOWER(`fname`) = LOWER('".$fname."') AND  LOWER(`lname`) = LOWER('".$lname."')";
					$res_jno=$db->setQuery($sql_jno);
					$result_jno=$db->loadObjectList();
					$numrows_jno=count($result_jno);
					if($numrows_jno==0)
					{
					$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$hteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
					$db->setQuery($sql_ins_player);
					$db->query();
					$auto_id = $db->insertid();
					
					$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
					$db->setQuery($sql_update);
					$db->query();
					
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
					$db->setQuery($sql_boxscore);
					$db->query();
					}
					
					else
					{
				
				$query = "DELETE FROM #__fullcourt_boxscore WHERE playerid='".$result[0]->playerid."'  AND gameid='".$gameid."'";
				$db->setQuery($query);
				$db->query();
				
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore 			(gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) 
				VALUES ('".$gameid."','".$result[0]->playerid."','".$hteamid."','".$seasonid."','','','','".$fgm."','".$fga."','','','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				
				}
				
				
				}
				
			}	
			}//while	

		}	//if
		
		}//if
		
		if($file_visiting['tmp_name']!='')
		{
		if (($handle = fopen($file_visiting['tmp_name'], "r")) !== FALSE) 
		{
			$i=0;
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) 
			{
			  $i++;
			  if($i!=1)
			  {
			  	$player_number=$data[0];
				$fname=$data[1];
				$lname=$data[2];
				$fgm=$data[9];
				$fgm=$data[9];
				$fga=$data[10];
				$ftm=$data[12];
				$fta=$data[13];
				$oreb=$data[16];
				$total_points=$data[15];
				$total_rebounds=$data[18];
				$oreb=$data[16];
				$dreb=$data[17];
				$turnovers=$data[19];
				$ast=$data[21];
				$stl=$data[20];
				$blk=$data[23];
				$fouls=$data[22];
				$playing_time=$data[24];
				$threepm=$data[6];
				$threepa=$data[7];
				
				$sql_player="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$vteamid."'";
				$res_player=$db->setQuery($sql_player);
				$result=$db->loadObjectList();
				$num_rows=count($result);
				if($num_rows==0)
				{
				$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$vteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
				$db->setQuery($sql_ins_player);
				$db->query();
				$auto_id = $db->insertid();
				
				$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
				$db->setQuery($sql_update);
				$db->query();
												
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				
				}
				else
				{
				$sql_jno="SELECT * FROM #__fullcourt_player WHERE jerseyhome='".$player_number."' AND teamid='".$vteamid."' AND LOWER(`fname`) = LOWER('".$fname."') AND  LOWER(`lname`) = LOWER('".$lname."')";
					$res_jno=$db->setQuery($sql_jno);
					$result_jno=$db->loadObjectList();
					$numrows_jno=count($result_jno);
					if($numrows_jno==0)
					{
					$sql_ins_player="INSERT INTO #__fullcourt_player (`active`, `playerid`, `teamid`, `fname`, `lname`, `jerseyhome`, `jerseyaway`, `published`) VALUES (1,'','".$vteamid."','".$fname."','".$lname."','".$player_number."','".$player_number."',1)";
					$db->setQuery($sql_ins_player);
					$db->query();
					$auto_id = $db->insertid();
					
					$sql_update="UPDATE #__fullcourt_player SET `playerid`='".$auto_id."' WHERE id='".$auto_id."'";
					$db->setQuery($sql_update);
					$db->query();
					
				$sql_boxscore="INSERT INTO #__fullcourt_boxscore (gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) VALUES ('".$gameid."','".$auto_id."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','".$threepm."','".$threepa."','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
					$db->setQuery($sql_boxscore);
					$db->query();
					}
					
					else
					{
				
				$query = "DELETE FROM #__fullcourt_boxscore WHERE playerid='".$result[0]->playerid."' AND gameid='".$gameid."'";
				$db->setQuery($query);
				$db->query();
				
			$sql_boxscore="INSERT INTO #__fullcourt_boxscore 			(gameid,playerid,teamid,seasonid,gs,pos,min,fgm,fga,threepm,threepa,ftm,fta,oreb,dreb,ast,stl,blk,turnovers,pf,pts) 
				VALUES ('".$gameid."','".$result[0]->playerid."','".$vteamid."','".$seasonid."','','','','".$fgm."','".$fga."','','','".$ftm."','".$fta."','".$oreb."','".$dreb."','".$ast."','".$stl."','".$blk."','".$turnovers."','','".$total_points."')";
				$db->setQuery($sql_boxscore);
				$db->query();
				
				}
				}
				
			}	
			}//while	

		}	
		}
		
	return true;
	
	
	}

	function savePlayerstats() {
		$db =  JFactory::getDBO();
		$option = JRequest::getCmd('option');

		$playerid = JFactory::getApplication()->input->post->get('id', '', 'int');
		$gameid = JFactory::getApplication()->input->post->get('gameid', '', 'int');
		$teamid = JFactory::getApplication()->input->post->get('teamid', '', 'int');
		$seasonid = JFactory::getApplication()->input->post->get('seasonid', '', 'int');

		$gs = JFactory::getApplication()->input->post->get('gs', '0', 'int');
		$pos = JFactory::getApplication()->input->post->get('pos', '', 'string');
		$min = JFactory::getApplication()->input->post->get('min', '0', 'int');
		$fgm = JFactory::getApplication()->input->post->get('fgm', '0', 'int');
		$fga = JFactory::getApplication()->input->post->get('fga', '0', 'int');
		$threepm = JFactory::getApplication()->input->post->get('threepm', '0', 'int');
		$threepa = JFactory::getApplication()->input->post->get('threepa', '0', 'int');
		$ftm = JFactory::getApplication()->input->post->get('ftm', '0', 'int');
		$fta = JFactory::getApplication()->input->post->get('fta', '0', 'int');
		$oreb = JFactory::getApplication()->input->post->get('oreb', '0', 'int');
		$dreb = JFactory::getApplication()->input->post->get('dreb', '0', 'int');
		$ast = JFactory::getApplication()->input->post->get('ast', '0', 'int');
		$stl = JFactory::getApplication()->input->post->get('stl', '0', 'int');
		$blk = JFactory::getApplication()->input->post->get('blk', '0', 'int');
		$to = JFactory::getApplication()->input->post->get('turnovers', '0', 'int');
		$pf = JFactory::getApplication()->input->post->get('pf', '0', 'int');
		$pts = JFactory::getApplication()->input->post->get('pts', '0', 'int');

		/* remove the old player stats for this game - will readd them next; */
		$query = "DELETE FROM #__fullcourt_boxscore WHERE (gameid = '{$gameid}' AND playerid = '{$playerid}')";
		$db->setQuery($query);
		$db->query();

		if ($gs || $pos || $min || $fgm || $fga || $threepm || $threepa || $ftm || $fta || $oreb || $dreb || $ast || $stl || $blk || $to || $pf) {
			$query = "INSERT INTO #__fullcourt_boxscore (gameid, playerid, teamid, seasonid, gs, pos, min, fgm, fga, threepm, threepa, ftm, fta, oreb, dreb, ast, stl, blk, turnovers, pf, pts) VALUES ('{$gameid}', '{$playerid}', '{$teamid}', '{$seasonid}',
			'{$gs}', '{$pos}', '{$min}', '{$fgm}', '{$fga}', '{$threepm}', '{$threepa}', '{$ftm}', '{$fta}', '{$oreb}', '{$dreb}', '{$ast}', '{$stl}', '{$blk}', '{$to}', '{$pf}', '{$pts}')";
		}

		$db->setQuery($query);
		$db->query();

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=statform&tmpl=component&id=' . $gameid . '&playerid=' . $playerid, 'Player Stats have been saved...');

	}

	function saveLinescore() {
		$db =  JFactory::getDBO();

		$row =  JTable::getInstance('linescore', 'Table');
		$post = JRequest::get('post');
		$otv = array();
		$oth = array();

		/* get the scores by quarter OT input values as an array; */
		$overtimev = $post['overtimev'];
		$overtimeh = $post['overtimeh'];

		/* check if the score was entered by quarters or halves; */
		if ($post['scoretype'] == 'H') {
			/* save the halves to quarter1 and quarter2; */
			$post['quarter1v'] = $post['half1v'];
			$post['quarter2v'] = $post['half2v'];
			$post['quarter1h'] = $post['half1h'];
			$post['quarter2h'] = $post['half2h'];

			/* save the final scores; */
			$post['finalv'] = $post['finalvh'];
			$post['finalh'] = $post['finalhh'];

			/* clear out the other quarters and overtimes; */
			$post['quarter3v'] = 0;
			$post['quarter4v'] = 0;
			$post['quarter3h'] = 0;
			$post['quarter4h'] = 0;

			/* get the score by halves OT input values as an array; */
			$overtimev = $post['halfovertimev'];
			$overtimeh = $post['halfovertimeh'];
		}

		/* cycle through the OTs and make sure values have been entered; */
		for ($i = 0; $i < sizeof($overtimev); $i++) {
			if (is_numeric($overtimev[$i]) || is_numeric($overtimeh[$i])) {
				if (is_numeric($overtimev[$i])) {
					$otv[] = $overtimev[$i];
				}
				else {
					$otv[] = 0;
				}

				if (is_numeric($overtimeh[$i])) {
					$oth[] = $overtimeh[$i];
				}
				else {
					$oth[] = 0;
				}
			}
		}

		$overtimev = serialize($otv);
		$overtimeh = serialize($oth);

		if (!$row->bind($post)) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$row->overtimev = $overtimev;
		$row->overtimeh = $overtimeh;

		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		/* update the game schedule and set the "scored" flag on; */
		$gameid = intval($post['gameid']);
		$query = "UPDATE #__fullcourt_schedule SET status = 3, scored = 1 WHERE (id = {$gameid})";
		$db->setQuery($query);
		$db->query();

		return true;
	}

	function deleteBoxscore() {
		$option = JRequest::getCmd('option');
		$cids = JRequest::getVar('cids', '0', 'get', 'array');
		$db =  JFactory::getDBO();

		/* delete the box score stats for the game(s); */
		$table = $db->nameQuote('#__fullcourt_boxscore');
		$id = $db->nameQuote('gameid');
		$query = "DELETE FROM " . $table . " WHERE " . $id . "IN (" . implode( ',', $cids ) . ")";
		$db->setQuery($query);
		$db->query();

		/* delete the line score for the game(s); */
		$table = $db->nameQuote('#__fullcourt_linescore');
		$id = $db->nameQuote('gameid');
		$query = "DELETE FROM " . $table . " WHERE " . $id . "IN (" . implode( ',', $cids ) . ")";
		$db->setQuery($query);
		$db->query();

		/* mark the game in the schedule as not being scored yet; */
		$table = $db->nameQuote('#__fullcourt_schedule');
		$id = $db->nameQuote('id');
		$query = "UPDATE " . $table . " SET status = 1, scored = 0 WHERE " . $id . "IN (" . implode( ',', $cids ) . ")";
		$db->setQuery($query);
		$db->query();

		$this->setRedirect('index.php?option=' . $option . '&view=admin&task=listgamesplayed', 'Box score details/results have been deleted...');
	}
	/* ------------- END FRONTEND ADMIN FUNCTIONS ------------- */

	/* ------------- START AJAX CALLS ------------- */
	function leagueDivisions() {
		$leagueid = JFactory::getApplication()->input->get('lid', 1);
		echo getDivisionsAsSelectList($leagueid, 'divisionid', 0);
	}

	function leagueDivisionTeams() {
		$leagueid = JFactory::getApplication()->input->get('lid', 0);
		$divisionid = JFactory::getApplication()->input->get('did', 0);
		echo getTeamsAsSelectListAjax('teamid', '', $leagueid, $divisionid );
	}

	function parkFields() {
		$location = JFactory::getApplication()->input->get( 'location', '' );
		echo getParkFieldListAjax($location, 'field');
	}
	/* ------------- END AJAX CALLS ------------- */

}
?>