<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class ModelFullcourtBoxscore extends JModelLegacy {
	var $_id = null;
	var $_game = null;
	var $_boxscore = null;
	var $_hometeam = null;
	var $_visitingteam = null;

	function __construct() {
		parent::__construct();

		/* get the game id; */
		$id = JFactory::getApplication()->input->get('id','0');

		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$id) {
			$app = JFactory::getApplication('site');
			$params = $app->getParams('com_fullcourt');
			$id = $params->get('id');
		}
		$this->_id = $id;

	}

	function getGame() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_schedule WHERE (id = {$this->_id})";
		$db->setQuery($query);
		$this->_game = $db->loadObject();
		return $this->_game;
	}

	function getLinescore() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_linescore WHERE (gameid = {$this->_game->id})";
		$db->setQuery($query);
		$this->_boxscore = $db->loadObject();

		$overtime = $this->_boxscore->overtimev;
		if ($overtime) {
			$overtime = unserialize($overtime);
			$this->_boxscore->overtimev = $overtime;
		}
		else {
			$this->_boxscore->overtimev = array();
		}

		$overtime = $this->_boxscore->overtimeh;
		if ($overtime) {
			$overtime = unserialize($overtime);
			$this->_boxscore->overtimeh = $overtime;
		}
		else {
			$this->_boxscore->overtimeh = array();
		}

		return $this->_boxscore;
	}

	function getBoxscore($teamid) {
		$db = $this->getDBO();
		/* OST Changes 
		Added AND l.published = 1 in where clause for displaying only published results
		*/
		$query = "SELECT b.*, CONCAT(p.fname, ' ', p.lname) AS name FROM #__fullcourt_boxscore AS b LEFT JOIN #__fullcourt_player AS p ON b.playerid = p.id WHERE (b.gameid = {$this->_game->id} AND b.teamid = {$teamid})";
		$db->setQuery($query);
		$this->_boxscore = $db->loadObjectList();
		return $this->_boxscore;
	}

	function getHometeam() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_team WHERE (id = {$this->_game->hometeam})";
		$db->setQuery($query);
		$this->_hometeam = $db->loadObject();
		return $this->_hometeam;
	}

	function getVisitingteam() {
		$db = $this->getDBO();
		$query = "SELECT * FROM #__fullcourt_team WHERE (id = {$this->_game->visitingteam})";
		$db->setQuery($query);
		$this->_visitingteam = $db->loadObject();
		return $this->_visitingteam;
	}


}

?>
