<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );
jimport( 'joomla.application.component.helper' );

class ModelFullcourtLeague extends JModelLegacy {
	var $_defaultleagueid = null;
	var $_defaultseasonid = null;
	var $_leaguename = null;
	var $_teamname = null;
	var $_standings = null;

	function __construct() {
		parent::__construct();

		/* set the default league; */
		$defaultleagueid = getDefaultLeagueId();
		$this->_defaultleagueid = $defaultleagueid;

		/* set the default season; */
		$defaultseasonid = getDefaultSeasonId();
		$this->_defaultseasonid = $defaultseasonid;

		/* get the league id if it was passed in; */
		$selectedleagueid = JRequest::getVar('league', 0, 'GET', 'INT');
		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$selectedleagueid) {
			$app = JFactory::getApplication('site');
			$params = $app->getParams('com_fullcourt');
			$selectedleagueid = $params->get('lid');
		}
		$this->_selectedleagueid = $selectedleagueid;
		if ($this->_selectedleagueid == 0) {
			$this->_selectedleagueid = $this->_defaultleagueid;
		}

		/* get the division id if it was passed in; */
		$selecteddivisionid = JRequest::getVar('division', 0, 'GET', 'INT');
		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$selecteddivisionid) {
			$app = JFactory::getApplication('site');
			$params = $app->getParams('com_fullcourt');
			$selecteddivisionid = $params->get('did');
		}
		$this->_selecteddivisionid = $selecteddivisionid;

		/* set the league name; */
		$leaguename = getLeagueName($this->_selectedleagueid);
		$this->_leaguename = $leaguename;
	}


	/* calculate and return league/division standings; */
	function getStandings() {
		if ($this->_selectedleagueid && $this->_selecteddivisionid) {
			$teams = getStandingsTeams($this->_selecteddivisionid, $this->_selectedleagueid, $this->_defaultseasonid);
			$standings = getStandingsStats($teams, $this->_defaultseasonid);
		}
		else if ($this->_selectedleagueid) {
			$standings = array();
			/* check if there are divisions configured within the league, if so calculate each division separately; */
			$this->_db->setQuery("SELECT t.divisionid, d.ordering FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_division AS d ON t.divisionid = d.id WHERE (t.published = 1 AND t.defaultteam = 1 AND t.leagueid = {$this->_selectedleagueid} AND t.divisionid > 0) GROUP BY t.divisionid ORDER BY d.ordering");
			$divisions = $this->_db->loadObjectList();

			/* if there are divisions configured use them; */
			if (sizeof($divisions) > 1) {
				foreach ($divisions as $division) {
					$teams = getStandingsTeams($division->divisionid, $this->_selectedleagueid, $this->_defaultseasonid);
					$standings = array_merge($standings, getStandingsStats($teams, $this->_defaultseasonid));
				}
			}
			else { /* no divisions so get the standings for all teams within the league; */
				$teams = getStandingsTeams(0, $this->_selectedleagueid, $this->_defaultseasonid);
				$standings = getStandingsStats($teams, $this->_defaultseasonid);
			}
		}
		$this->_standings = $standings;
		return $this->_standings;
	}

}

?>