<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class ModelFullcourtPlayer extends JModelLegacy {
	var $_id = null;
	var $_season = null;
	var $_seasonid = null;
	var $_seasons = null;
	var $_player = null;
	var $_positions = null;
	var $_defaultseasonid = null;
	var $_stats = null;
	var $_statstotals = null;

	function __construct() {
		parent::__construct();
		$id = JFactory::getApplication()->input->get('id','0');

		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$id) {
			$app = JFactory::getApplication('site');
			$params =  $app->getParams('com_fullcourt');
			$id = $params->get('id');
		}
		$this->_id = $id;

		/* set the default season id; */
		$this->_defaultseasonid = getDefaultSeasonId();

	}

	function getPlayer() {
		if (!$this->_player) {
		/* OST Changes for displaying only published results */
		$query = "SELECT p.*, CONCAT(p.fname, ' ', p.mname, ' ', p.lname) AS fullname, CURDATE(), (YEAR(CURDATE())-YEAR(p.birthdate)) - (RIGHT(CURDATE(), 5) < RIGHT(birthdate, 5))AS age, t.name AS teamname, t.leagueid FROM #__fullcourt_player AS p LEFT JOIN #__fullcourt_team AS t ON p.teamid = t.id WHERE p.id = '".$this->_id."'";
			$this->_db->setQuery($query);
			$this->_player = $this->_db->loadObject();

			/* build a list of the player's positions; */
			$arr = array();
			if (isset($this->_player->positions)) {
				$arr[] = $this->_player->positions;
			}
			if(!empty($arr)){
				$this->_player->positions = implode(", ", $arr);
			}
			
		}
	
		return $this->_player;
	}

	function getSeasons() {
		if (!$this->_seasons) {
			/* get the season selected by the user; */
			$season = JRequest::getVar('season', '', 'REQUEST', 'INT');
			if (!$season) {
				/* if there is no season var check for a menu configured season param; */
				$app = JFactory::getApplication('site');
				$params = $app->getParams('com_fullcourt');
				$season = $params->get('sid');
			}

			/* if there is no season passed in or a menu param use the default; */
			if (!$season) {
				$season = $this->_defaultseasonid;
			}
			$this->_seasonid = $season;

			$seasons = array();
			$this->_db->setQuery("SELECT id, name AS season FROM #__fullcourt_season WHERE (published = 1) ORDER BY id DESC");
			$rows = $this->_db->loadObjectList();
			//$seasons[] = JHTML::_('select.option',  '0', JText::_( '-- select stats' ), 'value', 'text' );
			foreach ($rows as $row) {
				$seasons[] = JHTML::_('select.option',  $row->id, JText::_( $row->season ), 'value', 'text' );
			}
			$this->_seasons = JHTML::_('select.genericlist', $seasons, 'season', 'class="inputbox" onchange="document.getElementById(\'adminForm\').submit();"', 'value', 'text', $this->_seasonid);
		}
		return $this->_seasons;
	}

	function getStats() {
		if (!$this->_stats) {
			$this->_stats = boxscoreStats($this->_id, '', '', $this->_seasonid, 'playerseason', '');
		}
		return $this->_stats;
	}

	function getStatsTotals() {
		if (!$this->_statstotals) {
			$this->_statstotals = boxscoreStats($this->_id, '', '', $this->_seasonid, '', '');
		}
		return $this->_statstotals;
	}

}

?>
