<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class ModelFullcourtRoster extends JModelLegacy {
	var $_id = null;
	var $_roster = null;
	var $_teamname = null;
	var $_teamlogo = null;
	var $_isfrontendadmin = null;

	function __construct() {
		parent::__construct();
		$id = JFactory::getApplication()->input->get('id','0');

		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$id) {
			$app = JFactory::getApplication('site');
			$params = $app->getParams('com_fullcourt');
			$id = $params->get('id');
		}
		$this->_id = $id;

		/* get the team name; */
		$this->_teamname = getTeamName($this->_id);

		/* get the team logo; */
		$this->_teamlogo = getTeamLogo($this->_id);

		/* check if user is a frontend admin; */
		$admin = isFrontendAdmin($this->_id);
		$this->_isfrontendadmin = $admin;
	}

	function getRoster() {
		$app = JFactory::getApplication('site');
		$params = $app->getParams('com_fullcourt');
		$sort = $params->get('roster_sort');
/* OST REMOVE PUBLISHED CONDITION FOR PLAYERS */
		if (!$this->_roster) {
			if ($sort == 'jerseyhome') {
				$query = "SELECT p.*, CONCAT(p.lname, ', ', p.fname, ' ', p.mname) AS fullname, CURDATE(), (YEAR(CURDATE())-YEAR(p.birthdate)) - (RIGHT(CURDATE(), 5) < RIGHT(birthdate, 5))AS age, t.facebook, t.website, t.mediaroster FROM #__fullcourt_player AS p LEFT JOIN #__fullcourt_team AS t ON p.teamid = t.id WHERE (p.published = 1 AND t.id = {$this->_id}) ORDER BY 0 + p.jerseyhome ASC";
			}
			else {
				$query = "SELECT p.*, CONCAT(p.lname, ', ', p.fname, ' ', p.mname) AS fullname, CURDATE(), (YEAR(CURDATE())-YEAR(p.birthdate)) - (RIGHT(CURDATE(), 5) < RIGHT(birthdate, 5))AS age, t.facebook, t.website, t.mediaroster FROM #__fullcourt_player AS p LEFT JOIN #__fullcourt_team AS t ON p.teamid = t.id WHERE (p.published = 1 AND t.id = {$this->_id}) ORDER BY fullname ASC";
			}
			$this->_db->setQuery($query);
			$roster = $this->_db->loadObjectList();
			$this->_roster = $roster;
		}
		return $this->_roster;
	}
	function getTeam() {
			$query = "SELECT t.* FROM #__fullcourt_team AS t WHERE (id = {$this->_id})";
			$this->_db->setQuery($query);
			$team = $this->_db->loadObject();
		
		return $team;
	}

}

?>
