<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class ModelFullcourtStatLeaders extends JModelLegacy {
	var $_seasonid = null;
	var $_gametypes = null;
	var $_teamids = null;
	var $_leagueids = null;
	var $_divisionids = null;
	var $_category = null;
	var $_mingames = null;
	var $_sort = null;
	var $_statsfor = null;
	var $_record = null;
	var $_displaylogo = null;
	var $_statleaders = null;
	var $_stattype = null;
	var $_statcategory = null;
	var $_displaypercent = null;

	function __construct() {
		parent::__construct();

		$app = JFactory::getApplication('site');
		$params = $app->getParams('com_fullcourt');

		$this->_seasonid = $params->get('seasonid');
 		$this->_gametypes = $params->get('gametypes');
 		$this->_teamids = $params->get('teamids');
 		$this->_leagueids = $params->get('leagueids');
 		$this->_divisionids = $params->get('divisionids');
 		$this->_category = $params->get('category');
 		$this->_mingames = $params->get('mingames');
 		$this->_sort = $params->get('sort');
 		$this->_statsfor = $params->get('stats');
 		$this->_records = $params->get('records');
 		$this->_displaylogo = $params->get('displaylogo');
 		$this->_displaypercent = FALSE;
	}

	function getStatType() {
		return ucfirst($this->_statsfor);
	}

	function getStatCategory() {
		return $this->_category;
	}

	function getStatCategoryName() {
		$categoryname = NULL;

		switch ($this->_category) {
			case 'min':
				$categoryname = 'Minutes';
				break;

			case 'ppg':
				$categoryname = 'Points Per Game';
				break;

			case 'reb':
				$categoryname = 'Rebounds';
				break;

			case 'ast':
				$categoryname = 'Assists';
				break;

			case 'stl':
				$categoryname = 'Steals';
				break;

			case 'fgpct':
				$categoryname = 'FG Percent';
				break;

			case 'threepct':
				$categoryname = '3PT Percent';
				break;

		}
		return ucfirst($categoryname);
	}

	function getStatLeaders() {
		if (!$this->_statleaders) {
			$category = $this->_category;
			$stats = $this->_statsfor;
			$seasonid = $this->_seasonid;
			$records = $this->_records;
			$sort = $this->_sort;

			if (is_array($this->_gametypes)) {
				$gametypes = implode(',', $this->_gametypes);
			}
			if (is_array($this->_teamids)) {
				$teamids = implode(',', $this->_teamids);
			}
			if (is_array($this->_leagueids)) {
				$leagueids = implode(',', $this->_leagueids);
			}
			if (is_array($this->_divisionids)) {
				$divisionids = implode(',', $this->_divisionids);
			}

			/* need to get a listing of all teams that are a part of the league and/or division; */
			if ($teamids) {
				$ids = $teamids;
			}
			else {
				if ($divisionids) {
					/* get a listing of all team ID's that belong in the league and division; */
					$sql = "SELECT id, name, shortname FROM #__fullcourt_team WHERE (FIND_IN_SET(divisionid, '$divisionids'))";
				}
				else {
					/* get a listing of all team ID's that belong in the league; */
					$sql = "SELECT id, name, shortname FROM #__fullcourt_team WHERE (FIND_IN_SET(leagueid, '$leagueids'))";
				}
				$this->_db->setQuery($sql);
				$ids = $this->_db->loadColumn();
				$ids = implode(',', $ids);
			}

			if ($category == 'fgpct') {
				$havingclause = "HAVING fgpct > 0";
				$this->_displaypercent = TRUE;
			}
			else if ($category == 'threepct') {
				$havingclause = "HAVING threepct > 0";
				$this->_displaypercent = TRUE;
			}
			else {
				$havingclause = "";
				$this->_displaypercent = FALSE;
			}

			if ($stats == 'team') {
				$whereclause = "(FIND_IN_SET(t.id, '$ids') AND b.seasonid = {$seasonid}) GROUP BY t.id {$havingclause} ORDER BY {$category} $sort LIMIT 0, {$records}";
				//$sql = "SELECT t.*, t.name AS name, b.gameid AS gameid, SUM(b.fgm) AS fgm, SUM(b.fga) AS fga, ROUND((SUM(b.fgm)/SUM(b.fga))*100, 1) AS fgpct, SUM(b.threepm) AS threepm, SUM(b.threepa) AS threepa, ROUND((SUM(b.threepm)/SUM(b.threepa))*100, 1) AS threepct, SUM(b.ftm) AS ftm, SUM(b.fta) AS fta, SUM(b.oreb) AS oreb, SUM(b.dreb) AS dreb, SUM(b.oreb) + SUM(b.dreb) AS reb, SUM(b.ast) AS ast, SUM(b.stl) AS stl, SUM(b.blk) AS blk, SUM(b.turnovers) AS turnovers, SUM(b.pts) AS pts, ROUND(AVG(b.pts), 1) AS ppg FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id WHERE {$whereclause}";
				 /* OST Changes to match with statleaders module results*/
					$sql = "SELECT t.*, t.name AS teamname, b.gameid AS gameid, SUM(b.fgm) AS fgm, SUM(b.fga) AS fga,ROUND(AVG(b.min),1) AS min, ROUND((SUM(b.fgm)/SUM(b.fga))*100, 1) AS fgpct, SUM(b.threepm) AS threepm, SUM(b.threepa) AS threepa, ROUND((SUM(b.threepm)/SUM(b.threepa))*100, 1) AS threepct, SUM(b.ftm) AS ftm, SUM(b.fta) AS fta, SUM(b.oreb) AS oreb, SUM(b.dreb) AS dreb, Round((AVG(b.oreb) + AVG(b.dreb)),1) AS reb,ROUND(AVG(b.ast),1) AS ast,Round((AVG(b.ftm)/AVG(b.fta))*100,1) AS ftpct, ROUND(AVG(b.stl),1) AS stl, AVG(b.blk) AS blk, SUM(b.turnovers) AS turnovers, SUM(b.pts) AS pts, ROUND(AVG(b.pts), 1) AS ppg FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id WHERE {$whereclause}";
				$this->_db->setQuery($sql);
			}
			else {
			
				$whereclause = "(FIND_IN_SET(t.id, '$ids') AND b.seasonid = {$seasonid}) GROUP BY b.playerid {$havingclause} ORDER BY {$category} $sort LIMIT 0, {$records}";
			 //	$sql = "SELECT t.*, b.gameid AS gameid, b.playerid AS playerid, CONCAT(l.fname, ' ', l.lname) AS name, SUM(b.min) AS min, SUM(b.fgm) AS fgm, SUM(b.fga) AS fga, ROUND((SUM(b.fgm)/SUM(b.fga))*100, 1) AS fgpct, SUM(b.threepm) AS threepm, SUM(b.threepa) AS threepa, ROUND((SUM(b.threepm)/SUM(b.threepa))*100, 1) AS threepct, SUM(b.ftm) AS ftm, SUM(b.fta) AS fta, SUM(b.oreb) AS oreb, SUM(b.dreb) AS dreb, SUM(b.oreb) + SUM(b.dreb) AS reb, SUM(b.ast) AS ast, SUM(b.stl) AS stl, SUM(b.blk) AS blk, SUM(b.turnovers) AS turnovers, SUM(b.pf) AS pf, SUM(b.pts) AS pts, ROUND(AVG(b.pts), 1) AS ppg FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id LEFT JOIN #__fullcourt_player AS l ON l.id = b.playerid WHERE {$whereclause}";
			 
			 /* OST Changes to match with statleaders module results*/
			 	$sql = "SELECT t.*, b.gameid AS gameid, b.playerid AS playerid, CONCAT(l.fname, ' ', l.lname) AS name,t.name as teamname, ROUND(AVG(b.min),1) AS min, SUM(b.fgm) AS fgm, SUM(b.fga) AS fga, ROUND((SUM(b.fgm)/SUM(b.fga))*100, 1) AS fgpct, SUM(b.threepm) AS threepm, SUM(b.threepa) AS threepa, ROUND((SUM(b.threepm)/SUM(b.threepa))*100, 1) AS threepct, SUM(b.ftm) AS ftm, SUM(b.fta) AS fta, Round((AVG(b.ftm)/AVG(b.fta))*100,1) AS ftpct ,SUM(b.oreb) AS oreb, SUM(b.dreb) AS dreb, Round((AVG(b.oreb) + AVG(b.dreb)),1) AS reb, ROUND(AVG(b.ast),1) AS ast, ROUND(AVG(b.stl),1) AS stl, AVG(b.blk) AS blk, SUM(b.turnovers) AS turnovers, SUM(b.pf) AS pf, SUM(b.pts) AS pts, ROUND(AVG(b.pts), 1) AS ppg FROM #__fullcourt_team AS t LEFT JOIN #__fullcourt_boxscore AS b ON b.teamid = t.id LEFT JOIN #__fullcourt_player AS l ON l.id = b.playerid WHERE {$whereclause}";
				$this->_db->setQuery($sql);
			}

		}

		$this->_statleaders = $this->_db->loadObjectList();
		return $this->_statleaders;
	}

}

?>