<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');

/* include the SQL helper file for calculating season stats; */
require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_fullcourt' . DS . 'helpers' . DS . 'sql.php');

jimport('joomla.application.component.model');

class ModelFullcourtStats extends JModelLegacy {
	var $_defaultleagueid = null;
	var $_defaultseasonid = null;
	var $_id = null;
	var $_season = null;
	var $_seasonid = null;
	var $_statstype = null;
	var $_seasons = null;
	var $_stats = null;
	var $_teamname = null;
	var $_statstemplate = null;
	var $_isfrontendadmin = null;
	var $_params = null;
	var $_teamstats = null;
	var $_teamstatstotals = null;
	var $_teamstatsorder = null;

	function __construct() {
		parent::__construct();
		$id = JFactory::getApplication()->input->get('id','0');

		/* if no id was passed in check to see if it's part of the menu params; */
		if (!$id) {
			$app = JFactory::getApplication('site');
			$params = $app->getParams('com_fullcourt');
			$id = $params->get('id');
		}
		$this->_id = $id;

		$this->_teamname = getTeamName($this->_id);

		/* set the default season id; */
		$this->_defaultseasonid = getDefaultSeasonId();
	}

	function getTeamname() {
		$this->_teamname = getTeamName($this->_id);
		return $this->_teamname;
	}

	function getSeasons() {
		if (!$this->_seasons) {
			/* get the season selected by the user; */
			$season = JRequest::getVar('season', '', 'REQUEST', 'INT');
			if (!$season) {
				/* if there is no season var check for a menu configured season param; */
			$menuitemid = JRequest::getInt('Itemid');
				if ($menuitemid) {
					$menu = JFactory::getApplication()->getMenu();
				    $menuparams = $menu->getParams( $menuitemid );
				    $season = $menuparams->get('sid');
				}
			}

			/* if there is no season passed in or a menu param use the default; */
			if (!$season) {
				$season = $this->_defaultseasonid;
			}
			$this->_seasonid = $season;

			$seasons = array();
			$this->_db->setQuery("SELECT id, name AS season FROM #__fullcourt_season WHERE (published = 1) ORDER BY id DESC");
			$rows = $this->_db->loadObjectList();
			foreach ($rows as $row) {
				$seasons[] = JHTML::_('select.option',  $row->id, JText::_( $row->season ), 'value', 'text' );
			}
			$this->_seasons = JHTML::_('select.genericlist', $seasons, 'season', 'class="inputbox"', 'value', 'text', $this->_seasonid);
		}
		return $this->_seasons;
	}

	function getStats() {
		if (!$this->_teamstats) {
		    $filter_order = JRequest::getVar('filter_order', 'min', 'REQUEST');
			$this->_teamstats = boxscoreStats('', '', $this->_id, $this->_seasonid, 'teamseason', $filter_order);
		}
		$this->_teamstatsorder = $filter_order;
		return $this->_teamstats;
	}

	function getStatsTotals() {
		if (!$this->_teamstatstotals) {
			$this->_teamstatstotals = boxscoreStats('', '', $this->_id, $this->_seasonid, 'teamseasontotals', '');
		}
		return $this->_teamstatstotals;
	}

}

?>
