<?php
/**
* @version $Id: router.php, v1.7.3 August 2012 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

function FullcourtBuildRoute(&$query) {
	$segments = array();

	if (isset($query['view'])) {
		$segments[] = $query['view'];
		unset($query['view']);
	}

	if (isset($query['id'])) {
		$segments[] = $query['id'];
		unset($query['id']);
	}

	if (isset($query['league'])) {
		$segments[] = $query['league'];
		unset($query['league']);
	}

	if (isset($query['division'])) {
		$segments[] = $query['division'];
		unset($query['division']);
	}

	if (isset($query['month'])) {
		$segments[] = $query['month'];
		unset($query['month']);
	}

	if (isset($query['day'])) {
		$segments[] = $query['day'];
		unset($query['day']);
	}

	if (isset($query['year'])) {
		$segments[] = $query['year'];
		unset($query['year']);
	}

	if (isset($query['layout'])) {
		$segments[] = $query['layout'];
		unset($query['layout']);
	}

	if (isset($query['schedule'])) {
		$segments[] = $query['schedule'];
		unset($query['schedule']);
	}

	if (isset($query['season'])) {
		$segments[] = $query['season'];
		unset($query['season']);
	}

	return $segments;
}

function FullcourtParseRoute($segments) {
	$vars = array();
	$count = count($segments);

	switch ($segments[0]) {
		case 'player':
			if ($count == 3) {
				$vars['season'] = @$segments[2];
			}
			$vars['view'] = 'player';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
			break;

	    case 'team':
		    $vars['view'] = 'team';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

	    case 'stats':
		    $vars['view'] = 'stats';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

	    case 'boxscore':
		    $vars['view'] = 'boxscore';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

	    case 'roster':
		    $vars['view'] = 'roster';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

	    case 'schedule':
	    	if ($count == 6) {
				$vars['layout'] = $segments[5];
				$vars['year'] = $segments[4];
				$vars['day'] = $segments[3];
				$vars['month'] = $segments[2];
	    	}
	    	else if ($count == 5) {
				$vars['layout'] = $segments[4];
				$vars['year'] = $segments[3];
				$vars['month'] = $segments[2];
	    	}
			else if ($count == 3 && $segments[2] == 'print') {
				$vars['layout'] = $segments[2];
			}
			else if ($count == 3 && $segments[2] == 'ical') {
				$vars['layout'] = $segments[2];
			}
		    $vars['view'] = 'schedule';
		    $id = explode( ':', $segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

		case 'all':
		    $vars['view'] = 'all';
		    $id = explode( ':', @$segments[1] );
		    $vars['league'] = (int)$id[0];
		    $id = explode( ':', @$segments[2] );
		    $vars['division'] = (int)$id[0];
		    break;

	    case 'admin':
		    $vars['view'] = 'admin';
		    $id = explode( ':', @$segments[1] );
		    $vars['id'] = (int) $id[0];
		    break;

	}

	return $vars;

}
?>
