<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
error_reporting(E_ALL ^ E_NOTICE);
jimport('joomla.application.component.view');

class FullcourtViewAdmin extends JViewLegacy {

	function display($tpl = null) {

		$model =  $this->getModel();
		$task = JFactory::getApplication()->input->get('task', '', 'DEFAULT');

		/* get the user object; */
		$user = JFactory::getUser();
		if (!$user->id) {
			 parent::display('noadmin');
			 return;
		}

		$app = JFactory::getApplication('site');
    	$params = $app->getParams('com_fullcourt');

		$this->assignRef('params', $params);

		/* get and assign the team data to the view; */
		$this->assignRef('adminteams', $model->_adminteams);
		$this->assignRef('id', $model->_id);
		$this->assignRef('teamname', $model->_teamname);
		$this->assignRef('leagues', $model->_leagues);
		$this->assignRef('divisions', $model->_divisions);


		if ($task == '') {
			parent::display($tpl);
		}
		else if ($task == 'manage') {
			$this->assignRef('teamid', $model->_teamid);
			parent::display('manage');
		}
		else if ($task == 'editteam') {
			$team = $model->getTeam();
			$this->assignRef('team', $team);
			parent::display('teamform');
		}
		else if ($task == 'listroster') {
			$roster = $model->getRoster();
			$this->assignRef('roster', $roster);
			parent::display('listroster');
		}
		else if ($task == 'editplayer') {
			$player = $model->getPlayer();
			$this->assignRef('player', $player);
			$this->assignRef('lists', $model->_lists);
			parent::display('playerform');
		}
		else if ($task == 'listschedule') {
			$schedule = $model->getSchedule();
			$this->assignRef('schedule', $schedule);
			parent::display('listschedule');
		}
		else if ($task == 'editschedule') {
			$game = $model->getGame();
			$this->assignRef('teamid', $model->_teamid);
			$this->assignRef('game', $game);
			$this->assignRef('lists', $model->_lists);
			parent::display('scheduleform');
		}
		else if ($task == 'listlocations') {
			$locations = $model->getLocations();
			$this->assignRef('locations', $locations);
			parent::display('listlocations');
		}
		else if ($task == 'editlocation') {
			$location = $model->getLocation();
			$this->assignRef('teamid', $model->_teamid);
			$this->assignRef('return', $model->_return);
			$this->assignRef('fieldnames', $model->_fieldnames);
			$this->assignRef('location', $location);
			parent::display('locationform');
		}
		else if ($task == 'listgamesplayed') {
			$games = $model->getGames();
			$this->assignRef('games', $games);
			parent::display('listgamesplayed');
		}
		else if ($task == 'editboxscore') {
			$game =  $model->getGame();
			$hometeam =  $model->getHometeam();
			$visitingteam =  $model->getVisitingteam();
			$linescore =  $model->getLinescore();
			$boxscoreh =  $model->getBoxscore($game->hometeam);
			$boxscorev =  $model->getBoxscore($game->visitingteam);

			if (isset($linescore->overtimev)) {
				$overtimev = $linescore->overtimev;
			}
			else {
				$overtimev = array('');
			}

			if (isset($linescore->overtimeh)) {
				$overtimeh = $linescore->overtimeh;
			}
			else {
				$overtimeh = array('');
			}

			$this->assignRef('overtimev', $overtimev);
			$this->assignRef('overtimeh', $overtimeh);
			$this->assignRef('game', $game);
			$this->assignRef('hometeam', $hometeam);
			$this->assignRef('visitingteam', $visitingteam);
			$this->assignRef('linescore', $linescore);
			$this->assignRef('boxscoreh', $boxscoreh);
			$this->assignRef('boxscorev', $boxscorev);

			parent::display('boxscoreform');
		}
		else if ($task == 'statform') {
			$game =  $model->getGame();
			$stats =  $model->getPlayerStats();
			$this->assignRef('game', $game);
			$this->assignRef('stats', $stats);
			parent::display('statform');
		}
	}

}

?>