<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.view');

class FullcourtViewAll extends JViewLegacy {

	function display($tpl = null) {

		$itemid = JRequest::getInt('Itemid', 0);
		$option = JRequest::getCmd('option');

		$app = JFactory::getApplication('site');
		$params = $app->getParams('com_fullcourt');

		$model =  $this->getModel();

		/* get the league, division, and team select lists for displaying in the drop-down; */
		$leagues = $model->getLeaguesList();
		$divisions = $model->getDivisionsList();
		$teams = $model->getTeamsList();
		$team = $model->getTeam();

		/* calculate the league/division standings; */
		$standings = $model->getLeagueStandings();

		/* assign template references; */
		$this->assignRef('params', $params);
		$this->assignRef('leaguename', $model->_leaguename);
		$this->assignRef('teamname', $model->_teamname);
		$this->assignRef('leagues', $leagues);
		$this->assignRef('divisions', $divisions);
		$this->assignRef('teams', $teams);
		$this->assignRef('standings', $standings);
		$this->assignRef('team', $team);
		$this->assignRef('option', $option);
		$this->assignRef('itemid', $itemid);
		$this->assignRef('isfrontendadmin', $model->_isfrontendadmin);

		/* display the template; */
		parent::display('dropdowns');
		if ($model->_teamname) {
			parent::display('teampage');
		}
		else {
			parent::display($tpl);
		}
	}

}

?>