<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.view');

class FullcourtViewBoxscore extends JViewLegacy {

	function display($tpl = null) {

		$app = JFactory::getApplication('site');
		$params = $app->getParams('com_fullcourt');
		
		$id = $params->get('id');

		$model =  $this->getModel();

		/* get and assign the box score data to the view; */
		$game =  $model->getGame($id);
		
		$hometeam =  $model->getHometeam();
		$visitingteam =  $model->getVisitingteam();
		$linescore =  $model->getLinescore();
		$boxscoreh =  $model->getBoxscore($hometeam->id);
		$boxscorev =  $model->getBoxscore($visitingteam->id);



		/* check if displaying the team logo is enabled or not and create a variable to display it rather than
		 * adding a lot of if statements to display it or not;
		 */
		$vlogonormal = $visitingteam->name;
		$vlogosmall = '';
		$hlogonormal = $hometeam->name;
		$hlogosmall = '';
		if ($params->get('team_logo') == 1) {
			/* check to make sure the logo file actually exists; */
			if ($visitingteam->logo && file_exists(JPATH_CONFIGURATION . DS . $params->get('images_path') . $visitingteam->logo)) {
				$vlogonormal = '<img src="./' . $params->get('images_path') . $visitingteam->logo . '" vspace="5" border="0" alt="" align="middle" />';
				$vlogomedium = '<img src="./' . $params->get('images_path') . $visitingteam->logo . '" vspace="5" border="0" alt="" align="middle" width="50" />';
				$vlogosmall = '<img src="./' . $params->get('images_path') . $visitingteam->logo . '" vspace="0" border="0" alt="" align="middle" width="25" />';
			}
			if ($hometeam->logo && file_exists(JPATH_CONFIGURATION . DS . $params->get('images_path') . $hometeam->logo)) {
				$hlogonormal = '<img src="./' . $params->get('images_path') . $hometeam->logo . '" vspace="5" border="0" alt="" align="middle" />';
				$hlogomedium = '<img src="./' . $params->get('images_path') . $hometeam->logo . '" vspace="0" border="0" alt="" align="middle" width="50" />';
				$hlogosmall = '<img src="./' . $params->get('images_path') . $hometeam->logo . '" vspace="0" border="0" alt="" align="middle" width="25" />';
			}
		}

		$this->assignRef('params', $params);
		$this->assignRef('game', $game);
		$this->assignRef('hometeam', $hometeam);
		$this->assignRef('visitingteam', $visitingteam);
		$this->assignRef('linescore', $linescore);
		$this->assignRef('boxscoreh', $boxscoreh);
		$this->assignRef('boxscorev', $boxscorev);

		$this->assignRef('vlogonormal', $vlogonormal);
		$this->assignRef('vlogomedium', $vlogomedium);
		$this->assignRef('vlogosmall', $vlogosmall);
		$this->assignRef('hlogonormal', $hlogonormal);
		$this->assignRef('hlogomedium', $hlogomedium);
		$this->assignRef('hlogosmall', $hlogosmall);

		parent::display($tpl);
	}
public function pr($data){

echo "<pre>";
print_r($data);
echo "</pre>";
}
}

?>
