<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
$params = JComponentHelper::getParams( 'com_fullcourt' );
$display_points_column=$params->get('display_points_column');
$win_points=$params->get('win_points' , '2' );
$loss_points=$params->get('loss_points' , '0' );
$tie_points=$params->get('tie_points' , '1' );
$points_column_heading=$params->get( 'points_column_heading' , 'Points' );
?>
<h1><?php echo $this->leaguename;?> <?php echo JText::_('COM_FULLCOURT_STANDINGS');?></h1>
<?php $division = $this->standings[0]->division; ?>
<?php if ($division) { ?>
<h3><?php echo JText::_('COM_FULLCOURT_DIVISION');?>: <?php echo $division;?></h3>
<?php } ?>
<table border="0" cellpadding="0" cellspacing="0" class="bb_table_wide" width="100%">
	<tr>
		<th><?php echo JText::_('COM_FULLCOURT_TEAM');?></th>
		<th>&nbsp;</th>
		<th style="text-align:center">W</th>
		<th style="text-align:center">L</th>
		<?php if ($this->params->get('standing_ties')) { ?>
		<th style="text-align:center">T</th>
		<?php } ?>
		<?php if($display_points_column==1) { ?>
		<th style="text-align:center;"><?php echo $points_column_heading;?></th>
		<?php }?>
		<th style="text-align:center">Pct</th>
		<th style="text-align:center">GP</th>
		<th style="text-align:center">PF</th>
		<th style="text-align:center">PA</th>
	</tr>
<?php foreach ($this->standings as $stats) { ?>
<?php if ($division != $stats->division) { ?>
<?php $division = $stats->division; ?>
</table>
<br />
<h3><?php echo JText::_('COM_FULLCOURT_DIVISION');?>: <?php echo $stats->division;?></h3>
<table border="0" cellpadding="0" cellspacing="0" class="bb_table_wide" width="100%">
	<tr>
		<th><?php echo JText::_('COM_FULLCOURT_TEAM');?></th>
		<th>&nbsp;</th>
		<th style="text-align:center">W</th>
		<th style="text-align:center">L</th>
		<?php if ($this->params->get('standing_ties')) { ?>
		<th style="text-align:center">T</th>
		<?php } ?>
		<?php if($display_points_column==1) { ?>
		<th style="text-align:center;"><?php echo $points_column_heading;?></th>
		<?php }?>
		<th style="text-align:center">Pct</th>
		<th style="text-align:center">GP</th>
		<th style="text-align:center">PF</th>
		<th style="text-align:center">PA</th>
	</tr>
<?php } ?>
	<tr>
		<td><a href="<?php echo JRoute::_("index.php?view=team&id=$stats->id");?>"><?php echo $stats->name;?></a></td>
		<td>&nbsp;</td>
		<?php if ($stats) { 
		$total_points=($stats->wins*$win_points)+($stats->losses*$loss_points)+($stats->ties*$tie_points);
		?>
		<td style="text-align:center"><?php echo $stats->wins ? $stats->wins:0;?></td>
		<td style="text-align:center"><?php echo $stats->losses;?></td>
		<?php if ($this->params->get('standing_ties')) { ?>
		<td style="text-align:center"><?php echo $stats->ties;?></td>
		<?php } ?>
		<?php if($display_points_column==1) { ?>
		<td style="text-align:center"><?php echo $total_points;?></td>
		<?php }?>
		<td style="text-align:center"><?php echo number_format($stats->winpct, 3);?></td>
		<td style="text-align:center"><?php echo $stats->gamesplayed;?></td>
		<td style="text-align:center"><?php echo $stats->pointsfor;?></td>
		<td style="text-align:center"><?php echo $stats->pointsagainst;?></td>
		<?php } else { ?>
		<td style="text-align:center">0</td>
		<td style="text-align:center">0</td>
		<?php if ($this->params->get('standing_ties')) { ?>
		<td style="text-align:center">0</td>
		<?php } ?>
		<?php if($display_points_column==1) { ?>
		<td style="text-align:center"><?php echo $total_points;?></td>
		<?php }?>
		<td style="text-align:center">0.00</td>
		<td style="text-align:center">&#45;</td>
		<td style="text-align:center">0</td>
		<td style="text-align:center">0</td>
		<?php } ?>
	</tr>
<?php } ?>
</table>
<br /><br />