<?php
/**
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
?>
<?php if (sizeof($this->stats) > 0): ?>
<?php
$script = <<<SCRIPT
window.addEvent( 'domready', function() {
	var bsummary = $('gi-passing-summary');
	var bdetails = $('gi-passing-details');
	bsummary.setStyle('display', 'none');
	if ($('gi-passing-toggle')) {
		$('gi-passing-toggle').addEvent( 'click', function() {
			bsummary.setStyle('display', bsummary.getStyle('display') == 'none' ? 'block' : 'none');
			bdetails.setStyle('display', bsummary.getStyle('display') == 'none' ? 'block' : 'none');
  		});
  	}
});
SCRIPT;
$document =  JFactory::getDocument();
$document->addScriptDeclaration($script);
?>
<h3><?php echo JText::_('COM_FULLCOURT_INDIVIDUAL_PLAYER_STATS');?></h3>
<div style="padding-bottom:5px;"><a href="javascript:void(0);" class="button" id="gi-passing-toggle">&raquo; <?php echo JText::_('COM_FULLCOURT_DISPLAY_INDIVIDUAL_GAMES');?></a></div>
<div id="gi-passing-summary">
<table border="0" cellpadding="0" cellspacing="0" class="bb_table_wide" width="100%">
	<tr>
		<th>&nbsp;</th>
		<th align="center">MIN</th>
		<th align="center">FGM-A</th>
		<th align="center">FG%</th>
		<th align="center">3PM-A</th>
		<th align="center">3P%</th>
		<th align="center">FTM-A</th>
		<th align="center">FT%</th>
		<th align="center">REB</th>
		<th align="center">AST</th>
		<th align="center">STL</th>
		<th align="center">BLK</th>
		<th align="center">TO</th>
		<th align="center">PF</th>
		<th align="center">PTS</th>
	</tr>
	<?php foreach ($this->statstotals as $stats): ?>
	<tr class="totals" valign="top" style="">
		<td style="padding-top:2px;"><?php echo JText::_('COM_FULLCOURT_TOTALS');?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->min;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->fgm . '-' . $stats->fga;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->fgpct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->threepm . '-' . $stats->threepa;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->threeppct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ftm . '-' . $stats->fta;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ftpct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->reb;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ast;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->stl;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->blk;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->turnovers;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->pf;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->pts;?></td>
	</tr>
	<?php endforeach;?>
</table>
</div>

<div id="gi-passing-details">
<table border="0" cellpadding="0" cellspacing="0" class="bb_table_wide"  width="100%">
	<tr>
		<th align="center">MIN</th>
		<th align="center">FGM-A</th>
		<th align="center">FG%</th>
		<th align="center">3PM-A</th>
		<th align="center">3P%</th>
		<th align="center">FTM-A</th>
		<th align="center">FT%</th>
		<th align="center">REB</th>
		<th align="center">AST</th>
		<th align="center">STL</th>
		<th align="center">BLK</th>
		<th align="center">TO</th>
		<th align="center">PF</th>
		<th align="center">PTS</th>
	</tr>
	<?php foreach ($this->stats as $stats): ?>
	<?php
	if ($stats->teamid == $stats->hometeam) {
		if ($stats->finalh > $stats->finalv) {
			$gameresult = 'W ' . $stats->finalh . '-' . $stats->finalv;
		}
		else if ($stats->finalh < $stats->finalv) {
			$gameresult = 'L ' . $stats->finalh . '-' . $stats->finalv;
		}
		else {
			$gameresult = 'T ' . $stats->finalh . '-' . $stats->finalv;
		}
	}
	else {
		if ($stats->finalv > $stats->finalh) {
			$gameresult = 'W ' . $stats->finalv . '-' . $stats->finalh;
		}
		else if ($stats->finalv < $stats->finalh) {
			$gameresult = 'L ' . $stats->finalv . '-' . $stats->finalh;
		}
		else {
			$gameresult = 'T ' . $stats->finalv . '-' . $stats->finalh;
		}
	}
	?>
	<tr>
		<td style="text-align:left;" colspan="14">
		<a href="<?php echo JRoute::_("index.php?view=boxscore&id=$stats->gameid");?>"><?php echo date('D n/d', strtotime($stats->date));?></a>
		<?php echo $stats->teamid == $stats->hometeam ? 'vs ' . $stats->visitingteamname:'@ ' . $stats->hometeamname; ?>
		<?php echo $gameresult;?>
		</td>
	</tr>
	<tr>
		<td style="text-align:center;"><?php echo $stats->min;?></td>
		<td style="text-align:center;"><?php echo $stats->fgm . '-' . $stats->fga;?></td>
		<td style="text-align:center;"><?php echo $stats->fgpct;?></td>
		<td style="text-align:center;"><?php echo $stats->threepm . '-' . $stats->threepa;?></td>
		<td style="text-align:center;"><?php echo $stats->threeppct;?></td>
		<td style="text-align:center;"><?php echo $stats->ftm . '-' . $stats->fta;?></td>
		<td style="text-align:center;"><?php echo $stats->ftpct;?></td>
		<td style="text-align:center;"><?php echo $stats->reb;?></td>
		<td style="text-align:center;"><?php echo $stats->ast;?></td>
		<td style="text-align:center;"><?php echo $stats->stl;?></td>
		<td style="text-align:center;"><?php echo $stats->blk;?></td>
		<td style="text-align:center;"><?php echo $stats->turnovers;?></td>
		<td style="text-align:center;"><?php echo $stats->pf;?></td>
		<td style="text-align:center;"><?php echo $stats->pts;?></td>
	</tr>
	<?php endforeach; ?>
	<?php foreach ($this->statstotals as $stats): ?>
	<tr class="totals" valign="top">
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->min;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->fgm . '-' . $stats->fga;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->fgpct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->threepm . '-' . $stats->threepa;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->threeppct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ftm . '-' . $stats->fta;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ftpct;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->reb;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->ast;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->stl;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->blk;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->turnovers;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->pf;?></td>
		<td style="text-align:center;padding-top:2px;"><?php echo $stats->pts;?></td>
	</tr>
	<?php endforeach;?>
</table>
</div>
<br />
<?php endif; ?>
