<?php
/**
* @version $Id: mod_fullcourt_game_results.php, v1.7 October 2011 01:32:15
* @author Fastball Productions
* @package com_fullcourt
* @copyright Copyright (C) 2009-2017 Fastball Productions
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
*/

/** Change History
* 01/14/18 - MCrosbie Added class="row-striped" to add divider to game scores
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

$db = JFactory::getDBO();

$app = JFactory::getApplication('site');
$com_params = $app->getParams('com_fullcourt');
$menuitemid = JRequest::getInt( 'Itemid' );

// get the module parameters
$heading = $params->get( 'heading', '' );
$showpast = $params->get( 'showpast', '1' );
$numberpast = $params->get( 'numberpast', '1' );
$linkboxscore = $params->get( 'linkboxscore', '1' );
$shownextgame = $params->get( 'nextgame', '1' );
$numbernext = $params->get( 'numbernext', '1' );
$linknext = $params->get( 'linknext', '1' );
$seasonid = $params->get( 'seasonid', '1' );
$gametypes = $params->get( 'gametypes', '1' );
$teamids = $params->get( 'teamids', '' );
$leagueids = $params->get( 'leagueids', '' );
$divisionids = $params->get( 'divisionids', '' );
$displaylogo = $params->get( 'displaylogo', 0);

$displayshortname=$params->get( 'displayshortname' , '1' );
$upGameLayout = $params->get( 'upGameLayout', 1);
$date_format = $params->get( 'date_format', 'D d M,');
$time_format = $params->get( 'time_format', 'H:i');
$document = JFactory::getDocument();
$document->addStyleSheet(JURI::base().'/modules/mod_fullcourt_game_results/style.css');

if (is_array($gametypes)) {
	$gametypes = implode(',', $gametypes);
}
if (is_array($teamids)) {
	$teamids = implode(',', $teamids);
}
if (is_array($leagueids)) {
	$leagueids = implode(',', $leagueids);
}
if (is_array($divisionids)) {
	$divisionids = implode(',', $divisionids);
}

// if there is a league configured, get the teams within the league/division;
if ($teamids == '' && ($divisionids || $leagueids)) {
	if ($divisionids) {
		// get a listing of all team ID's that belong in the league and division;
		$sql = "SELECT id FROM #__fullcourt_team WHERE (FIND_IN_SET(divisionid, '$divisionids'))";
	}
	else {
		// get a listing of all team ID's that belong in the league;
		$sql = "SELECT id FROM #__fullcourt_team WHERE (FIND_IN_SET(leagueid, '$leagueids'))";
	}
	$db->setQuery($sql);
	$rows = $db->loadResultArray();
	$teamids = implode(',', $rows);
}
else if ($teamids == '') {
	// get the default team (single team component only);
	$db->setQuery("SELECT id FROM #__fullcourt_team WHERE (defaultteam = 1)");
	$teamids = $db->loadResult();
}

// get the last x number of games played and the results;
$db->setQuery("SELECT a.*, a.hometeam AS hometeamid, a.visitingteam AS visitingteamid,
	DATE_FORMAT(a.gamedatetime, '%a, %M %D') AS gamedate,
	DATE_FORMAT(a.gamedatetime, '%l:%i %p') As gametime,
	h.name AS hometeam,
	h.shortname AS hshortname,
	h.logo AS hlogo,
	v.name AS visitingteam,
	v.shortname AS vshortname,
	v.logo AS vlogo,
	b.finalv, b.finalh
	FROM #__fullcourt_schedule AS a
	LEFT JOIN #__fullcourt_team AS h ON a.hometeam = h.id
	LEFT JOIN #__fullcourt_team AS v ON a.visitingteam = v.id
	LEFT JOIN #__fullcourt_linescore AS b ON a.id = b.gameid
	WHERE (a.scored = 1 AND a.season = {$seasonid} AND (FIND_IN_SET(a.gametype, '$gametypes')) AND (FIND_IN_SET(a.hometeam, '$teamids') OR FIND_IN_SET(a.visitingteam, '$teamids')) AND a.gamedatetime < now())
	GROUP BY a.id
	ORDER BY a.gamedatetime DESC LIMIT 0, {$numberpast}");
$pastgames = $db->loadObjectList();

// get the next x number of games scheduled;
$db->setQuery("SELECT a.*,l.name as venue, a.hometeam AS hometeamid, a.visitingteam AS visitingteamid,
	DATE_FORMAT(a.gamedatetime, '%a, %M %D') AS gamedate,
	DATE_FORMAT(a.gamedatetime, '%l:%i %p') As gametime,
	h.name AS hometeam,
	h.shortname AS hshortname,
	h.logo AS hlogo,
	v.name AS visitingteam,
	v.shortname AS vshortname,
	v.logo AS vlogo,
	t.description AS gametype
	FROM #__fullcourt_schedule AS a
	LEFT JOIN #__fullcourt_team AS h ON a.hometeam = h.id
	LEFT JOIN #__fullcourt_team AS v ON a.visitingteam = v.id
	LEFT JOIN #__fullcourt_gametype AS t ON a.gametype = t.id
	LEFT JOIN #__fullcourt_location AS l ON a.location = l.id
	WHERE (a.scored = 0 AND a.season = {$seasonid} AND (FIND_IN_SET(a.gametype, '$gametypes')) AND (FIND_IN_SET(a.hometeam, '$teamids') OR FIND_IN_SET(a.visitingteam, '$teamids')) AND DATE_ADD(a.gamedatetime, INTERVAL 3 HOUR) > now())
	GROUP BY a.id
	ORDER BY a.gamedatetime ASC LIMIT 0, {$numbernext}");
$nextgames = $db->loadObjectList();
?>
<table width="100%" border="0" align="center">
	<?php if ($showpast && $numberpast > 0) { ?>
	<tr>
		<td width="618" style="text-align:center;" colspan="2"><b><?php echo $heading;?></b></td>
	</tr>
	<tr>
		<td><u>Games</u></td>
		<td width="540" style="text-align:center;"><u>Score</u></td>
	</tr>
	<?php foreach ($pastgames as $past) { ?>
	<?php 
	if($displayshortname)
	{
	$past->vshortname == '' ? $vteamname = $past->visitingteam:$vteamname = $past->vshortname;
	$past->hshortname == '' ? $hteamname = $past->hometeam:$hteamname = $past->hshortname;
	
	}
	else
	{
	$vteamname = $past->visitingteam;
	$hteamname = $past->hometeam;
	}
	
	 //$past->hshortname ? $past->hometeam = $past->hshortname:NULL;?>
	<tr>
   		<td valign="middle" nowrap="nowrap">
   			<?php if ($displaylogo) { ?>
			<?php if($past->vlogo!='') {?>
   			<img src="<?php echo JURI::base() . $com_params->get('images_path') . $past->vlogo;?>" alt="" width="24" align="middle" />
			<?php } else {?>
			<img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpg" alt="" width="24" align="middle" />
   			<?php } } ?>
   			<?php echo $vteamname; ?>
   		</td>
		<td valign="middle" style="text-align:center;"><?php if ($linkboxscore) { ?><a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=boxscore&id=$past->id");?>"><?php echo $past->finalv;?></a><?php } else { ?><?php echo $past->finalv;?>
    </td
	<?php } ?>
  	</tr>
  	<tr>
		<td valign="middle" nowrap="nowrap">
		<?php if ($displaylogo) { ?>
		<?php if($past->hlogo!='') {?>
		<img src="<?php echo JURI::base() . $com_params->get('images_path') . $past->hlogo;?>" alt="" width="24" align="middle" />
		<?php } else { ?>
		<img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpeg" alt="" width="24" align="middle" />
		<?php } } ?>
		<?php echo $hteamname;?>
		</td>
		<td valign="middle" style="text-align:center;"><?php if ($linkboxscore) { ?><a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=boxscore&id=$past->id");?>"><?php echo $past->finalh;?></a><?php } else { ?><?php echo $past->finalh;?>

      </td>
	<?php } ?>
	</tr>
  	<tr>
		<td colspan="2" class="row-striped"></td>
	</tr>
	<?php } ?>
	<?php } ?>
	<?php if ($shownextgame && $numbernext > 0 && $nextgames) { 
	
	if($upGameLayout == 1){ ?>
    <tr>
    <td colspan="2" class="upgame"><b>Upcoming games</b></td>
	</tr>
    <tr>
	<td colspan="2"><b>Next games</b></td>	
	</tr>
	<?php } else { ?>
		
	<tr>
		<td><u>Next Game</u></td>
        <td><u>Date &amp; Time</u></td>
	</tr>
	<?php }	?>
   
	<?php foreach ($nextgames as $next) { ?>
	<?php $next->visitingteam == '' ? $next->visitingteam = 'TBA':$next->visitingteam = $next->visitingteam;?>
	<?php $next->hometeam == '' ? $next->hometeam = 'TBA':$next->hometeam = $next->hometeam;?>
	<?php $next->vshortname ? $next->visitingteam = $next->vshortname:NULL;?>
	<?php $next->hshortname ? $next->hometeam = $next->hshortname:NULL;?>
    <?php if($upGameLayout == 1){ ?>
   
    <tr class="center next_games"> <td colspan="2"><?php echo date($date_format ,strtotime($next->gamedatetime)) . ' ' .  date($time_format ,strtotime($next->gametime));?></td> </tr>
		<tr class="center">
	  <td nowrap="nowrap" colspan="2">
      <div class="team1">
		<?php if ($linknext) { ?>
		<?php if ($next->visitingteam == 'TBA') { ?>
		<?php echo $next->visitingteam;?>
		<?php } else { ?>
		<?php if ($displaylogo) { ?>
		<?php if($next->vlogo!='') {?>
		<img src="<?php echo JURI::base() . $com_params->get('images_path') . $next->vlogo;?>" alt="" width="24" align="middle" />
		<?php } else {?>
		<img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpeg" alt="" width="24" align="middle" />
		<?php }
		?>  <br /> <?php 
		 } ?>
       
		<a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=schedule&id=$next->visitingteamid");?>"><?php echo $next->visitingteam;?></a>
		<?php } ?>
        </div>
		<div class="mid">vs.</div>
        <div class="team2">
        
		<?php if ($next->hometeam == 'TBA') { ?>
		<?php echo $next->hometeam;?>
		<?php } else { ?>
		
	  	<?php if ($displaylogo) { ?>
		<?php if($next->hlogo!='') {?>
	  	<img src="<?php echo JURI::base() . $com_params->get('images_path') . $next->hlogo;?>" alt="" width="24" align="middle" />
		<?php } else {?>
		<img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpeg" alt="" width="24" align="middle" />
	  	<?php } 
		?>  <br /> <?php 
		} ?>
	  	<a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=schedule&id=$next->hometeamid");?>"><?php echo $next->hometeam;?></a>
		<?php } ?>
		<?php } else { ?>
        <br />
		<?php echo $next->visitingteam;?> vs. <?php echo $next->hometeam;?>
		<?php } ?>
        </div>
	  </td>
  	</tr>
    <tr><td colspan="2" class="center next_games"> <?php if( $next->venue) echo  "@ ".$next->venue; ?></td></tr>
	<?php } else { ?>
        <tr>
          <td nowrap="nowrap">
            <?php if ($linknext) { ?>
            <?php if ($next->visitingteam == 'TBA') { ?>
            <?php echo $next->visitingteam;?>
            <?php } else { ?>
            <?php if ($displaylogo) { ?>
            <?php if($next->vlogo!='') {?>
            <img src="<?php echo JURI::base() . $com_params->get('images_path') . $next->vlogo;?>" alt="" width="24" align="middle" />
            <?php } else {?>
            <img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpeg" alt="" width="24" align="middle" />
            <?php } } ?>
            <a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=schedule&id=$next->visitingteamid");?>"><?php echo $next->visitingteam;?></a>
            <?php } ?>
            @
            <?php if ($next->hometeam == 'TBA') { ?>
            <?php echo $next->hometeam;?>
            <?php } else { ?>
            </td>
            <td valign="top" style="text-align:center;" rowspan="2"><?php echo $next->gamedate . ' ' . $next->gametime;?></td>
        </tr>
        <tr>
          <td nowrap="nowrap">
            <?php if ($displaylogo) { ?>
            <?php if($next->hlogo!='') {?>
            <img src="<?php echo JURI::base() . $com_params->get('images_path') . $next->hlogo;?>" alt="" width="24" align="middle" />
            <?php } else {?>
            <img src="<?php echo JURI::base()?>components/com_fullcourt/default_logo.jpeg" alt="" width="24" align="middle" />
            <?php } } ?>
            <a href="<?php echo JRoute::_("index.php?option=com_fullcourt&view=schedule&id=$next->hometeamid");?>"><?php echo $next->hometeam;?></a>
            <?php } ?>
            <?php } else { ?>
            <?php echo $next->visitingteam;?> @ <?php echo $next->hometeam;?>
            <?php } ?>
          </td>
        </tr>
	<?php }?>
	
	<?php } ?>
	<?php } ?>
</table>
